(function () {
    'use strict';

    var Scene = Laya.Scene;
    var REG = Laya.ClassUtils.regClass;
    var ui;
    (function (ui) {
        var View;
        (function (View) {
            class BattleSceneUI extends Scene {
                constructor() {
                    super();
                }
                createChildren() {
                    super.createChildren();
                    this.createView(BattleSceneUI.uiView);
                }
            }
            BattleSceneUI.uiView = { "type": "Scene", "props": { "width": 750, "visible": true, "runtime": "script/BattleScene.ts", "height": 1334 }, "compId": 2, "loadList": [], "loadList3D": [] };
            View.BattleSceneUI = BattleSceneUI;
            REG("ui.View.BattleSceneUI", BattleSceneUI);
        })(View = ui.View || (ui.View = {}));
    })(ui || (ui = {}));

    class Gam2DRectanglee {
        constructor(p1, p2, p3, p4) {
            this.p1 = p1;
            this.p2 = p2;
            this.p3 = p3;
            this.p4 = p4;
            this.width = Math.abs(p1.x - p4.x);
            this.height = Math.abs(p1.y - p4.y);
        }
        IsPointInMatrix(p) {
            let isPointIn = this.isPointInMatrix(this.p1, this.p2, this.p3, this.p4, p);
            return isPointIn;
        }
        isPointInMatrix(p1, p2, p3, p4, p) {
            let isPointIn = true;
            if (p.x < p1.x || p.x > p2.x || p.y < p2.y || p.y > p4.y) {
                isPointIn = false;
            }
            return isPointIn;
        }
        correctPoint(p) {
            if (p.x < this.p1.x) {
                p.x = this.p1.x + 40;
            }
            if (p.x > this.p2.x) {
                p.x = this.p2.x - 40;
            }
            if (p.y < this.p2.y) {
                p.y = this.p2.y + 40;
            }
            if (p.y > this.p4.y) {
                p.y = this.p4.y - 40;
            }
            return p;
        }
        static LineRectIntersection(lineStartPoint, lineEndPoint, rectangle) {
            var result;
            var minXLinePoint = lineStartPoint.x <= lineEndPoint.x ? lineStartPoint : lineEndPoint;
            var maxXLinePoint = lineStartPoint.x <= lineEndPoint.x ? lineEndPoint : lineStartPoint;
            var minYLinePoint = lineStartPoint.y <= lineEndPoint.y ? lineStartPoint : lineEndPoint;
            var maxYLinePoint = lineStartPoint.y <= lineEndPoint.y ? lineEndPoint : lineStartPoint;
            var rectMaxX = rectangle.right;
            var rectMinX = rectangle.x;
            var rectMaxY = rectangle.bottom;
            var rectMinY = rectangle.y;
            if (minXLinePoint.x <= rectMaxX && rectMaxX <= maxXLinePoint.x) {
                var m = (maxXLinePoint.y - minXLinePoint.y) / (maxXLinePoint.x - minXLinePoint.x);
                var intersectionY = ((rectMaxX - minXLinePoint.x) * m) + minXLinePoint.y;
                if (minYLinePoint.y <= intersectionY && intersectionY <= maxYLinePoint.y
                    && rectMinY <= intersectionY && intersectionY <= rectMaxY) {
                    result = new Laya.Point(rectMaxX, intersectionY);
                    return result;
                }
            }
            if (minXLinePoint.x <= rectMinX && rectMinX <= maxXLinePoint.x) {
                var m = (maxXLinePoint.y - minXLinePoint.y) / (maxXLinePoint.x - minXLinePoint.x);
                var intersectionY = ((rectMinX - minXLinePoint.x) * m) + minXLinePoint.y;
                if (minYLinePoint.y <= intersectionY && intersectionY <= maxYLinePoint.y
                    && rectMinY <= intersectionY && intersectionY <= rectMaxY) {
                    result = new Laya.Point(rectMinX, intersectionY);
                    return result;
                }
            }
            if (minYLinePoint.y <= rectMaxY && rectMaxY <= maxYLinePoint.y) {
                var rm = (maxYLinePoint.x - minYLinePoint.x) / (maxYLinePoint.y - minYLinePoint.y);
                var intersectionX = ((rectMaxY - minYLinePoint.y) * rm) + minYLinePoint.x;
                if (minXLinePoint.x <= intersectionX && intersectionX <= maxXLinePoint.x
                    && rectMinX <= intersectionX && intersectionX <= rectMaxX) {
                    result = new Laya.Point(intersectionX, rectMaxY);
                    return result;
                }
            }
            if (minYLinePoint.y <= rectMinY && rectMinY <= maxYLinePoint.y) {
                var rm = (maxYLinePoint.x - minYLinePoint.x) / (maxYLinePoint.y - minYLinePoint.y);
                var intersectionX = ((rectMinY - minYLinePoint.y) * rm) + minYLinePoint.x;
                if (minXLinePoint.x <= intersectionX && intersectionX <= maxXLinePoint.x
                    && rectMinX <= intersectionX && intersectionX <= rectMaxX) {
                    result = new Laya.Point(intersectionX, rectMinY);
                    return result;
                }
            }
            return result;
        }
    }

    class LocalStorage {
        static getJSON(_key) {
            return Laya.LocalStorage.getJSON(_key);
        }
        static setJSON(_key, _value) {
            return Laya.LocalStorage.setJSON(_key, _value);
        }
        static setItem(key, value) {
            Laya.LocalStorage.setItem(key, value);
        }
        static getSignNum() {
            let _loginDate = LocalStorage.getItem('LoginDate');
            if (!_loginDate) {
                LocalStorage.m_LoginDate = '-1';
                this.setItem('LoginDate', LocalStorage.m_LoginDate);
            }
            else {
                LocalStorage.m_LoginDate = _loginDate;
            }
        }
        static setCurrentData() {
            let day = new Date();
            day.setTime(day.getTime());
            let s2 = day.getFullYear() + "-" + (day.getMonth() + 1) + "-" + day.getDate();
            this.setItem('LoginDate', s2);
        }
        static isSign() {
            let day = new Date();
            day.setTime(day.getTime());
            let s2 = day.getFullYear() + "-" + (day.getMonth() + 1) + "-" + day.getDate();
            console.log(s2);
            let data = Laya.LocalStorage.getItem("LoginDate");
            if (data && data == s2) {
                return true;
            }
            else {
                return false;
            }
        }
        static getItem(key) {
            return Laya.LocalStorage.getItem(key);
        }
        static clear() {
            Laya.LocalStorage.clear();
        }
        static removeItem(key) {
            Laya.LocalStorage.removeItem(key);
        }
    }

    const sven_3D_preload = "res/sven3DAssets/sven_3D_preload";
    class Global {
        static get defaultMat1() {
            if (!this._defaultMat1) {
                Global._defaultMat1 = new Laya.PBRStandardMaterial();
                Global._defaultMat1.albedoColor = Global.defaltColor1;
                Global._defaultMat1.smoothness = 0.3;
                Global._defaultMat1.metallic = 0.1;
            }
            return Global._defaultMat1;
        }
        static get defaultMat2() {
            if (!this._defaultMat2) {
                Global._defaultMat2 = new Laya.PBRStandardMaterial();
                Global._defaultMat2.albedoColor = Global.defaltColor2;
                Global._defaultMat2.smoothness = 0.3;
                Global._defaultMat2.metallic = 0.1;
            }
            return Global._defaultMat2;
        }
        static set checkPoint(_checkPoint) {
            Global.m_checkPoint = _checkPoint;
            LocalStorage.setItem('checkPoint', _checkPoint.toString());
        }
        static get checkPoint() {
            return Global.m_checkPoint;
        }
        static Init() {
            let _checkPoint = LocalStorage.getItem('checkPoint');
            if (_checkPoint) {
                Global.checkPoint = Number(_checkPoint);
            }
            else {
                Global.checkPoint = 1;
            }
        }
    }
    Global.gameVersionString = "1.0.0.1:0";
    Global.localSvenAssets = "res/svenAssets/";
    Global.localSvenAssetsPreload = "res/svenAssets/sven_preload/";
    Global.localSven3DAssetsPreload = sven_3D_preload;
    Global.localSven3DAssetsPreload_Prefabs = sven_3D_preload + "LayaPrefabs/";
    Global.localConfig = "res/configs/";
    Global.localRes = "res/";
    Global.cofingRes = "";
    Global.localSvenLoad = "res/SvenAssets/sven_load/";
    Global.npcShowDistance = 50;
    Global.map2DRectanglee = new Gam2DRectanglee(new Laya.Point(-134, -100), new Laya.Point(142, -100), new Laya.Point(-134, 82), new Laya.Point(142, 82));
    Global.gameTimerMax = 120;
    Global.gameTimeRemaining = 0;
    Global.playerRank = 1;
    Global.playerExpAll = 0;
    Global.randomMoney = 60;
    Global.randomExp = 0.8;
    Global.playerJump = 15;
    Global.rondomNames10 = "赵钱孙李周吴郑王冯陈褚卫蒋沈韩杨朱秦尤许何吕施张孔曹严华金魏陶姜戚谢邹喻柏水窦章云苏潘葛奚范彭郎鲁韦昌马苗凤花方俞任袁柳酆鲍史唐费廉岑薛雷贺倪汤滕殷罗毕郝邬安常乐于时傅皮卞齐康伍余元卜顾孟平黄和穆萧尹姚邵湛汪祁毛禹狄米贝明臧计伏成戴谈宋茅庞熊纪舒屈项祝董梁杜阮蓝闵席季麻强贾路娄危江童颜郭梅盛林刁钟徐邱骆高夏蔡田樊胡凌霍虞万支柯咎管卢莫经房裘缪干解应宗宣丁贲邓郁单杭洪包诸左石崔吉钮龚程嵇邢滑裴陆荣翁荀羊於惠甄魏加封芮羿储靳汲邴糜松井段富巫乌焦巴弓牧隗山谷车侯宓蓬全郗班仰秋仲伊宫宁仇栾暴甘钭厉戎祖武符刘姜詹束龙叶幸司韶郜黎蓟薄印宿白怀蒲台从鄂索咸籍赖卓蔺屠蒙池乔阴郁胥能苍双闻莘党翟谭贡劳逄姬申扶堵冉宰郦雍却璩桑桂濮牛寿通边扈燕冀郏浦尚农温别庄晏柴瞿阎充慕连茹习宦艾鱼容向古易慎戈廖庚终暨居衡步都耿满弘匡国文寇广禄阙东殴殳沃利蔚越夔隆师巩厍聂晁勾敖融冷訾辛阚那简饶空曾毋沙乜养鞠须丰巢关蒯相查后江红游竺权逯盖益桓公万俟司马上官欧阳夏侯诸葛闻人东方赫连皇甫尉迟公羊澹台公冶宗政濮阳淳于仲孙太叔申屠公孙乐正轩辕令狐钟离闾丘长孙慕容鲜于宇文司徒司空亓官司寇仉督子车颛孙端木巫马公西漆雕乐正壤驷公良拓拔夹谷宰父谷粱晋楚阎法汝鄢涂钦段干百里东郭南门呼延归海羊舌微生岳帅缑亢况后有琴梁丘左丘东门西门商牟佘佴伯赏南宫墨哈谯笪年爱阳佟第五言福百家姓续";
    Global.rondomNames11 = "秀娟英华慧巧美娜静淑惠珠翠雅芝玉萍红娥玲芬芳燕彩春菊兰凤洁梅琳素云莲真环雪荣爱妹霞香月莺媛艳瑞凡佳嘉琼勤珍贞莉桂娣叶璧璐娅琦晶妍茜秋珊莎锦黛青倩婷姣婉娴瑾颖露瑶怡婵雁蓓纨仪荷丹蓉眉君琴蕊薇菁梦岚苑婕馨瑗琰韵融园艺咏卿聪澜纯毓悦昭冰爽琬茗羽希宁欣飘育滢馥筠柔竹霭凝晓欢霄枫芸菲寒伊亚宜可姬舒影荔枝思丽";
    Global.rondomNames12 = "伟刚勇毅俊峰强军平保东文辉力明永健世广志义兴良海山仁波宁贵福生龙元全国胜学祥才发武新利清飞彬富顺信子杰涛昌成康星光天达安岩中茂进林有坚和彪博诚先敬震振壮会思群豪心邦承乐绍功松善厚庆磊民友裕河哲江超浩亮政谦亨奇固之轮翰朗伯宏言若鸣朋斌梁栋维启克伦翔旭鹏泽晨辰士以建家致树炎德行时泰盛雄琛钧冠策腾楠榕风航弘";
    Global.PlayerPostion = new Laya.Vector3();
    Global.PlayerSpeed = 18;
    Global.loadingBatch = 2;
    Global.spwanBulletSpeed = 100;
    Global.defaltColor1 = new Laya.Vector4(15 / 255, 178 / 255, 255 / 255, 1);
    Global.defaltColor2 = new Laya.Vector4(0.2, 0.2, 0.2, 1);
    Global.m_checkPoint = 14;
    Global.hitCount = 0;
    Global.hitCountPerFrame = 0;
    Global.bulletMaxDistance = 0;
    Global.isPlaying = false;
    Global.isEnter = 0;
    Global.proportion = 0;
    Global.levelProgress = 0;
    Global.score = 0;
    Global.gold = 0;

    class SvenHashObject {
        constructor() {
            this.m_hashCode = SvenHashObject.hashCount++;
        }
        get hashCode() {
            let _hashCode = this.m_hashCode;
            return _hashCode;
        }
    }
    SvenHashObject.hashCount = 0;

    class SvenEvent extends SvenHashObject {
        constructor(_type, _bubbles = false, _cancelable = false) {
            super();
            this.m_type = _type;
        }
        getType() {
            return this.m_type;
        }
        set target(_target) {
            this.m_target = _target;
        }
        get target() {
            return this.m_target;
        }
    }
    SvenEvent.COMPLETE = "COMPLETE";

    class TaskQueueEvent extends SvenEvent {
        constructor(type, bubbles = false, cancelable = false) {
            super(type, bubbles, cancelable);
        }
    }
    TaskQueueEvent.TASK_QUEUE_COMPLETE = "TASK_QUEUE_COMPLETE";

    class TaskQueueSever {
        constructor(_queueID = "default") {
            this.m_isRun = false;
            this.m_taskList = [];
            this.m_queueID = _queueID;
        }
        get getLength() {
            return this.m_taskList.length;
        }
        addTaskQueue(_taskQueue) {
            if (_taskQueue == null) {
                return;
            }
            if (this.m_taskList.indexOf(_taskQueue) != -1) {
                return;
            }
            _taskQueue.addEventListener(TaskQueueEvent.TASK_QUEUE_COMPLETE, this.complete, this);
            this.m_taskList.push(_taskQueue);
            if (this.m_isRun == false)
                this.execute();
        }
        removeTaskQueue(_taskQueue) {
            let _index = this.m_taskList.indexOf(_taskQueue);
            let _bool = (_index > -1);
            if (_bool)
                this.m_taskList.splice(_index);
            return _bool;
        }
        removeTaskQueueAll() {
            this.m_taskList.length = 0;
        }
        execute() {
            if (this.m_taskList.length == 0) {
                this.m_isRun = false;
                return;
            }
            this.m_isRun = true;
            this.m_taskQueueBase = this.m_taskList[0];
            this.m_taskList.splice(0, 1);
            this.m_taskQueueBase.execute();
        }
        complete(_event) {
            let _taskQueueBase = _event.target;
            if (this.m_taskQueueBase == null || _taskQueueBase != this.m_taskQueueBase) {
                console.error("TaskQueueSeverBase.Complete   _taskQueueBase == null  queue break !!!");
                console.error("TaskQueue  Be destroyed !!!!!!!!!!");
                return;
            }
            _taskQueueBase.removeEventListener(TaskQueueEvent.TASK_QUEUE_COMPLETE, this.complete, this);
            this.execute();
        }
    }

    class TaskQueueManager {
        constructor() {
            if (TaskQueueManager.m_instance != null) {
                console.error("This class is a single class !!!!!!!!!  new TaskQueueManager()  ?????");
                return;
            }
            else
                TaskQueueManager.m_instance = this;
            this.m_taskQueueSever = new TaskQueueSever("MainTaskQueue");
        }
        static get Instance() {
            if (TaskQueueManager.m_instance == null) {
                TaskQueueManager.m_instance = new TaskQueueManager();
            }
            return TaskQueueManager.m_instance;
        }
        addTaskQueue(_taskQueueBase) {
            this.m_taskQueueSever.addTaskQueue(_taskQueueBase);
        }
    }

    class SvenEventDispatcher extends SvenHashObject {
        constructor() {
            super();
            this.m_layaEventDispatcher = new Laya.EventDispatcher();
        }
        dispatchEvent(_event) {
            _event.target = this;
            this.m_layaEventDispatcher.event(_event.getType(), _event);
        }
        addEventListener(type, listener, thisObject) {
            this.m_layaEventDispatcher.once(type, thisObject, listener);
        }
        removeEventListener(type, listener, thisObject) {
            this.m_layaEventDispatcher.off(type, thisObject, listener);
        }
    }

    class TaskQueueBase extends SvenEventDispatcher {
        constructor(_queueRank = 2) {
            super();
            this.m_queueRank = 1;
            this.execute = function () { this.run(); };
        }
        get getQueueRank() {
            return this.m_queueRank;
        }
        start() {
            TaskQueueManager.Instance.addTaskQueue(this);
            return this;
        }
        stop() {
        }
        Exit() {
            this.exit();
        }
        exit() {
            this.dispatchEvent(new TaskQueueEvent(TaskQueueEvent.TASK_QUEUE_COMPLETE));
        }
        run() {
        }
    }

    class Dictionary {
        constructor(list) {
            this._count = 0;
            this._maps = {};
            this._hashMaps = {};
            this._objKeys = [];
            this._objDatum = [];
            if (list != null) {
                this.addList(list);
            }
        }
        get Maps() {
            return this._maps;
        }
        addList(list) {
            let length = list.length;
            let value;
            for (let i = 0; i < length; i++) {
                value = list[i];
                this.add(value.key, value.data);
            }
        }
        addNumberKey(key, data) {
            if (null == this._maps[key]) {
                this._count++;
            }
            this._maps[key] = data;
        }
        getNumberKey(key) {
            return this._maps[key];
        }
        addStringKey(key, data) {
            if (null == this._maps[key]) {
                this._count++;
            }
            this._maps[key] = data;
        }
        getStringKey(key) {
            return this._maps[key];
        }
        add(key, data) {
            if (typeof (key) != "object") {
                if (null == this._maps[key]) {
                    this._count++;
                }
                this._maps[key] = data;
            }
            else {
                var index = this._objKeys.lastIndexOf(key);
                if (index == -1) {
                    this._objKeys.push(key);
                    this._objDatum.push(data);
                    this._count++;
                }
                else {
                    this._objDatum[index] = data;
                }
            }
        }
        remove(key) {
            var index;
            if (typeof (key) != "object") {
                if (null != this._maps[key]) {
                    delete this._maps[key];
                    this._count--;
                }
            }
            else {
                index = this._objKeys.lastIndexOf(key);
                if (index != -1) {
                    this._objKeys.splice(index, 1);
                    this._objDatum.splice(index, 1);
                    this._count--;
                }
            }
        }
        getValue(key) {
            if (typeof (key) != "object") {
                return this._maps[key];
            }
            else {
                var index = this._objKeys.lastIndexOf(key);
                if (index != -1) {
                    return this._objDatum[index];
                }
                return null;
            }
        }
        has(key) {
            if (typeof (key) != "object") {
                return this._maps[key] ? true : false;
            }
            else {
                var index = this._objKeys.lastIndexOf(key);
                if (index != -1) {
                    return true;
                }
                return false;
            }
        }
        get count() {
            return this._count;
        }
        forEach(callback, thisObject = null) {
            var name, arr;
            for (name in this._maps) {
                callback.call(thisObject, name, this._maps[name]);
            }
            for (name in this._hashMaps) {
                arr = this._hashMaps[name];
                callback.call(thisObject, arr[0], arr[1]);
            }
            for (var j = 0; j < this._objKeys.length; j++) {
                var key = this._objKeys[j];
                callback.call(thisObject, this._objKeys[j], this._objDatum[j]);
                if (key != this._objKeys[j]) {
                    j--;
                }
            }
        }
        get elements() {
            var _list = [];
            var name, arr;
            for (name in this._maps) {
                _list.push({ key: name, data: this._maps[name] });
            }
            for (name in this._hashMaps) {
                arr = this._hashMaps[name];
                _list.push({ key: arr[0], data: arr[1] });
            }
            var len = this._objKeys.length;
            for (var j = 0; j < len; j++) {
                _list.push({ key: this._objKeys[j], data: this._objDatum[j] });
            }
            return _list;
        }
        get keys() {
            var _list = [];
            var name;
            for (name in this._maps) {
                _list.push(name);
            }
            for (name in this._hashMaps) {
                _list.push(this._hashMaps[name][0]);
            }
            _list = _list.concat(this._objKeys);
            return _list;
        }
        get datum() {
            var _list = [];
            var name;
            for (name in this._maps) {
                _list.push(this._maps[name]);
            }
            for (name in this._hashMaps) {
                _list.push(this._hashMaps[name][1]);
            }
            _list = _list.concat(this._objDatum);
            return _list;
        }
        destroy() {
            this._maps = {};
            this._hashMaps = {};
            this._objKeys.length = 0;
            this._objDatum.length = 0;
        }
        dump() {
            var name, arr;
            for (name in this._maps) {
                console.log("key:", name, "---> data:", this._maps[name]);
            }
            for (name in this._hashMaps) {
                arr = this._hashMaps[name];
                console.log("key:", arr[0], "---> data:", arr[1]);
            }
            var len = this._objKeys.length;
            for (var j = 0; j < len; j++) {
                console.log("key:", typeof (this._objKeys[j]), " ---> data:", this._objDatum[j]);
            }
        }
        getValueByIndex(index) {
            return this.datum[index];
        }
    }

    class ActionTaskQueueManager {
        constructor() {
            this.m_actionTaskQueueDic = new Dictionary();
        }
        addTaskQueue(_actionTaskQueue) {
            if (_actionTaskQueue.id == "" || _actionTaskQueue.id == "default")
                return;
            if (!this.m_actionTaskQueueDic.has(_actionTaskQueue.id))
                this.m_actionTaskQueueDic.add(_actionTaskQueue.id, new TaskQueueSever(_actionTaskQueue.id));
            this.m_actionTaskQueueDic.getStringKey(_actionTaskQueue.id).addTaskQueue(_actionTaskQueue);
        }
        getLength(_actionTaskQueue) {
            return this.m_actionTaskQueueDic.getStringKey(_actionTaskQueue.id).getLength;
        }
        destroyTaskQueueSever(_id) {
            if (_id == "" || _id == "default")
                return;
            if (!this.m_actionTaskQueueDic.has(_id))
                return;
            let _tasQueueSever = this.m_actionTaskQueueDic.getStringKey(_id);
            _tasQueueSever.removeTaskQueueAll();
        }
    }
    ActionTaskQueueManager.Instance = new ActionTaskQueueManager();

    class ActionTaskQueue extends TaskQueueBase {
        constructor(_id, _queueRank = 1) {
            super(_queueRank);
            this.m_id = _id;
        }
        get id() {
            return this.m_id;
        }
        start() {
            ActionTaskQueueManager.Instance.addTaskQueue(this);
            return this;
        }
        stop() {
        }
    }

    class ActionTaskQueueCallBack extends ActionTaskQueue {
        constructor(_taskQueueID, _loadDelegate, _callBackThis = null) {
            super(_taskQueueID);
            this.m_callBackThis = _callBackThis;
            this.m_completeCallBack = _loadDelegate;
        }
        run() {
            this.exit();
            this.m_completeCallBack.call(this.m_callBackThis, this.m_callBackThis);
        }
    }

    var Loader = Laya.Loader;
    class SvenAssetsVo {
        constructor() {
            this.sven_preload = new Dictionary();
            this.sven_dynamicload = new Dictionary();
        }
        readJson(_jsonData) {
            for (var key in _jsonData) {
                if (!this[key])
                    this[key] = new Dictionary();
                let _dic = this[key];
                for (var uiName in _jsonData[key]) {
                    let _vo = new UIAssetsVo(_jsonData[key][uiName], uiName);
                    _dic.addStringKey(_vo.id, _vo);
                }
            }
            return this;
        }
    }
    class UIAssetsVo {
        constructor(_json, _id) {
            this.vos = [];
            this.id = _id;
            this.isLoading = false;
            for (var i = 0; i < _json["length"]; i++) {
                let _childVo = new UIAssetsChildVo(_json[i], this);
                this.vos.push(_childVo);
            }
        }
    }
    class UIAssetsChildVo {
        constructor(_json, _fatherVo) {
            this.fatherVo = _fatherVo;
            this.fileName = _json["fileName"];
            this.uiName = _json["uiName"];
            this.resName = _json["resName"];
            this.path = Global.localRes + _json["path"];
            this.resSuffix = this.resName.split(".")[1].toLowerCase();
            switch (this.resSuffix) {
                case 'bin':
                    this.loaderType = Loader.BUFFER;
                    this.fatherVo.fairGuiPackageKey = this.path.split(".")[0];
                    this.fatherVo.fairGuiPackageKeySuffix = 'bin';
                    break;
                case 'fui':
                    this.loaderType = Loader.BUFFER;
                    this.fatherVo.fairGuiPackageKey = this.path.split(".")[0];
                    break;
                case 'jpg':
                case 'png':
                    this.loaderType = Loader.IMAGE;
                    break;
                default:
                    console.error("未找到匹配的 loaderType 类型 !!!!");
            }
        }
    }

    class GameConfigManager {
        constructor() {
            this.currencySymbleVoDic = new Dictionary();
            this.ScrollTipsConfigDic = new Dictionary();
            this.LoadQueueConfig = new Dictionary();
            this.pokerConfigDic = new Dictionary();
            this.serviceSettingConfigDic = new Dictionary();
            this.scrollListRunConfigDic = new Dictionary();
            this.soundConfigDic = new Dictionary();
            this.tipsConfigDic = new Dictionary();
            this.gameTimeDic = new Dictionary();
            this.WangSoundConfigVoDic = new Dictionary();
            this.WangSoundTypeConfigVoDic = new Dictionary();
            this.ScrollBarConfig = new Dictionary();
            this.ScrollBarCheckerboardConfig = new Dictionary();
            if (GameConfigManager.m_instance != null) {
                console.error("This class is a single class !!!!!!!!!  new GameConfigManager()  ?????");
                return;
            }
            else
                GameConfigManager.m_instance = this;
        }
        static get Instance() {
            if (GameConfigManager.m_instance == null) {
                GameConfigManager.m_instance = new GameConfigManager();
            }
            return GameConfigManager.m_instance;
        }
        setConfigXMLData(_xmlData, _classType, _dic) {
        }
        setConfigJSONData(_jsonData, _classType, _dic) {
        }
    }
    GameConfigManager.m_instance = null;

    class LoadingUIModel {
        constructor() {
            this.progressNumber = 1;
        }
        IModel() { }
    }

    class DispatchModuleManager {
        constructor() {
            this.m_dispatchs = new Dictionary();
            if (DispatchModuleManager.m_instance != null) {
                console.error("This class is a single class !!!!!!!!!  new DispatchModuleManager()  ?????");
                return;
            }
            else
                DispatchModuleManager.m_instance = this;
        }
        static get Instance() {
            if (DispatchModuleManager.m_instance == null) {
                DispatchModuleManager.m_instance = new DispatchModuleManager();
            }
            return DispatchModuleManager.m_instance;
        }
        add(_Idispatch) {
            if (!_Idispatch["IDispatch"])
                return;
            if (this.m_dispatchs.has(_Idispatch.hashCode))
                return;
            this.m_dispatchs.addNumberKey(_Idispatch.hashCode, _Idispatch);
        }
        remove(_Idispatch) {
            if (!_Idispatch["IDispatch"])
                return;
            if (!this.m_dispatchs.has(_Idispatch.hashCode))
                return;
            this.m_dispatchs.remove(_Idispatch.hashCode);
        }
        dispatch(_moduleState, _moduleEnume) {
            this.m_dispatchs.forEach((_key, _Idispatch) => {
                _Idispatch.moduleDispatch(_moduleState, _moduleEnume);
            }, this);
        }
    }
    DispatchModuleManager.m_instance = null;

    class ProxyManager {
        constructor() {
            this.proxys = new Dictionary();
            if (ProxyManager.m_instance != null) {
                console.error("This class is a single class !!!!!!!!!  new UIManager()  ?????");
                return;
            }
            else
                ProxyManager.m_instance = this;
        }
        static get Instance() {
            if (ProxyManager.m_instance == null) {
                ProxyManager.m_instance = new ProxyManager();
            }
            return ProxyManager.m_instance;
        }
        getModel(_proxy) {
            return this.proxys.getStringKey(_proxy.getModelID).model;
        }
        registered(_proxy) {
            if (!this.proxys.has(_proxy.getModelID))
                this.proxys.addStringKey(_proxy.getModelID, new ProxyObject());
            if (_proxy["IModel"] && this.proxys.getStringKey(_proxy.getModelID).model == null)
                this.proxys.getStringKey(_proxy.getModelID).model = _proxy;
            if (this.proxys.getStringKey(_proxy.getModelID).model == null)
                this.proxys.getStringKey(_proxy.getModelID).model = _proxy.initializeModel();
            if (_proxy["IView"])
                this.proxys.getStringKey(_proxy.getModelID).addView(_proxy);
        }
        close(_modelID) {
            if (!this.proxys.has(_modelID))
                return;
            for (let i = 0; i < this.proxys.getStringKey(_modelID).views.length; i++) {
                let _proxyObject = this.proxys.getStringKey(_modelID);
                _proxyObject.closeView(this.proxys.getStringKey(_modelID).views[i]);
            }
        }
        open(_modelID) {
            if (!this.proxys.has(_modelID))
                return;
            for (let i = 0; i < this.proxys.getStringKey(_modelID).views.length; i++) {
                let _proxyObject = this.proxys.getStringKey(_modelID);
                _proxyObject.openView(this.proxys.getStringKey(_modelID).views[i]);
            }
        }
        destroy(_modelID) {
            if (!this.proxys.has(_modelID))
                return;
            while (this.proxys.getStringKey(_modelID).views.length > 0) {
                this.proxys.getStringKey(_modelID).removeView(this.proxys.getStringKey(_modelID).views[0]);
            }
            this.proxys.getStringKey(_modelID).views = [];
        }
        refresh(_proxy, _isCallUpdate = true, _methodName, _optionalParams) {
            for (let i = 0; i < this.proxys.getStringKey(_proxy.getModelID).views.length; i++) {
                let _iview = this.proxys.getStringKey(_proxy.getModelID).views[i];
                if (_iview.isOpenView == false)
                    return;
                if (_isCallUpdate)
                    _iview.update();
                if (_methodName == null || _methodName == undefined)
                    continue;
                if (_iview[_methodName] == null)
                    continue;
                if (_optionalParams == undefined) {
                    _iview[_methodName]();
                    continue;
                }
                _iview[_methodName](_optionalParams[0], _optionalParams[1], _optionalParams[2], _optionalParams[3], _optionalParams[4], _optionalParams[5]);
            }
        }
    }
    ProxyManager.m_instance = null;
    class ProxyObject {
        constructor() {
            this.views = [];
        }
        addView(_view) {
            let index = this.views.indexOf(_view);
            if (index > -1)
                return;
            this.views.push(_view);
        }
        removeView(_view) {
            let index = this.views.indexOf(_view);
            if (index == -1)
                return;
            DispatchModuleManager.Instance.remove(_view);
            this.views.splice(index, 1);
            _view.destroyView();
        }
        closeView(_view) {
            let index = this.views.indexOf(_view);
            if (index == -1)
                return;
            DispatchModuleManager.Instance.remove(_view);
            _view.setOpenView(false);
            _view.closeView();
        }
        openView(_view) {
            let index = this.views.indexOf(_view);
            if (index == -1)
                return;
            DispatchModuleManager.Instance.add(_view);
            _view.setOpenView(true);
            _view.openView();
            _view.update();
        }
    }

    class Proxy extends Laya.EventDispatcher {
        constructor() {
            super();
            this.m_isOpenView = false;
            this.initializeProxy();
            this.errorChecking();
        }
        get isOpenView() {
            return this.m_isOpenView;
        }
        setOpenView(_boolean) {
            this.m_isOpenView = _boolean;
        }
        initializeModel() {
            let _imodel = new this.m_modelClass();
            return _imodel;
        }
        openModule() {
            if (this["IView"]) {
                ProxyManager.Instance.open(this.m_modelID);
            }
        }
        closeModule() {
            if (this["IView"]) {
                ProxyManager.Instance.close(this.m_modelID);
            }
        }
        destroyModule() {
            if (this["IView"]) {
                ProxyManager.Instance.destroy(this.m_modelID);
            }
        }
        refresh(methodName) {
            this.executeRefresh(methodName);
        }
        callSingleMethod(methodName, ...optionalParams) {
            this.executeCallSingleMethod(methodName, optionalParams);
        }
        get getModelID() {
            return this.m_modelID;
        }
        get className() {
            return this.m_className;
        }
        set setModelID(_modelClass) {
            this.m_modelClass = _modelClass;
            this.m_modelID = _modelClass.name;
        }
        registered() {
            ProxyManager.Instance.registered(this);
        }
        get getModel() {
            let _model = ProxyManager.Instance.getModel(this);
            if (_model == null)
                console.warn("Model == null ???  !!!!!!!!!!!");
            return _model;
        }
        executeRefresh(_methodName) {
            if (this["IView"] || this["ICommand"]) {
                ProxyManager.Instance.refresh(this, true, _methodName);
            }
        }
        executeCallSingleMethod(_methodName, _optionalParams) {
            if (!this["ISingleCallMethod"])
                return;
            ProxyManager.Instance.refresh(this, false, _methodName, _optionalParams);
        }
        initializeProxy() {
            this.m_className = this["__proto__"].constructor.name;
        }
        errorChecking() {
            if ((this["IView"] || this["ICommand"] || this["IModel"]))
                return;
        }
    }

    class LoadingUIProxy extends Proxy {
        constructor() {
            super();
            this.setModelID = LoadingUIModel;
            this.registered();
        }
        get model() {
            return this.getModel;
        }
    }

    class LoadingUIProgressBarComd extends LoadingUIProxy {
        constructor(current, total) {
            super();
            let number = current / total * 100;
            this.model.progressNumber = number;
        }
        execute() {
            this.refresh();
        }
        ICommand() { }
    }

    var Handler = Laya.Handler;
    class StartLoaderGroup {
        constructor(_taskQueueID = 'StartLoader', _groupName = 'sven_preload') {
            this.m_uiVos = [];
            this.m_laoderResDatas = [];
            this.m_groupName = _groupName;
            this.m_actionTaskQueue = new ActionTaskQueue(_taskQueueID).start();
        }
        start() {
            let _dic = GameConfigManager.Instance.SvenAssetsVo[this.m_groupName];
            for (let i = 0; i < _dic.keys.length; i++) {
                let _vo = _dic.getStringKey(_dic.keys[i]);
                this.m_uiVos.push(_vo);
                for (let j = 0; j < _vo.vos.length; j++) {
                    let _childVo = _vo.vos[j];
                    let _object = new Object;
                    _object["url"] = _childVo.path;
                    _object["type"] = _childVo.loaderType;
                    this.m_laoderResDatas.push(_object);
                }
            }
            this.loader();
        }
        loader() {
            Laya.loader.load(this.m_laoderResDatas, Handler.create(this, this.onComplete), Handler.create(this, this.onLoadedProgress, null, false));
        }
        onComplete() {
            for (var i = 0; i < this.m_uiVos.length; i++) {
                this.m_uiVos[i].isLoading = true;
                fgui.UIPackage.addPackage(this.m_uiVos[i].fairGuiPackageKey);
            }
            this.m_actionTaskQueue.Exit();
        }
        onLoadedProgress(data) {
            if (this.m_groupName == 'sven_loading')
                return;
            new LoadingUIProgressBarComd(data / Global.loadingBatch, 1).execute();
        }
    }

    class ModulesManager {
        constructor() {
            this.modules = new Dictionary();
            if (ModulesManager.m_instance != null) {
                console.error("This class is a single class !!!!!!!!!  new UIManager()  ?????");
                return;
            }
            else
                ModulesManager.m_instance = this;
        }
        static get Instance() {
            if (ModulesManager.m_instance == null) {
                ModulesManager.m_instance = new ModulesManager();
            }
            return ModulesManager.m_instance;
        }
        back(_classType) {
            if (!this.modules.has(_classType.prototype["__class__"]))
                return;
            this.modules[_classType.ToString()].window.back();
        }
        open(_classType) {
            var _vo;
            let _id = _classType.name;
            if (this.modules.has(_id)) {
                _vo = this.modules.getStringKey(_id);
                if (_vo.window == null) {
                    _vo.window = new _classType();
                }
                _vo.window.open();
            }
            else {
                _vo = new ModuleVo();
                _vo.window = new _classType();
                this.modules.addStringKey(_id, _vo);
                _vo.window.open();
            }
            DispatchModuleManager.Instance.dispatch("open", _classType);
        }
        close(_classType, _isDestory = false) {
            let _id = _classType.name;
            if (!this.modules.has(_id))
                return;
            let _window = this.modules.getStringKey(_id).window;
            _window.close();
            DispatchModuleManager.Instance.dispatch("close", _classType);
            if (_isDestory) {
                _window.dispose();
                DispatchModuleManager.Instance.dispatch("dispose", _classType);
                this.modules.remove(_id);
            }
        }
        isOpen(_classType) {
            let _id = _classType.name;
            if (!this.modules.has(_id))
                return false;
            return this.modules.getStringKey(_id).window.isOpen;
        }
    }
    ModulesManager.m_instance = null;
    class ModuleVo {
    }

    class OpenModule extends TaskQueueBase {
        constructor(_classType) {
            super();
            this.m_classType = _classType;
        }
        run() {
            if (!ModulesManager.Instance.isOpen(this.m_classType)) {
                ModulesManager.Instance.open(this.m_classType);
            }
            this.exit();
        }
    }

    class Sven_GComponent extends fgui.GComponent {
        constructor() {
            super();
            this._container.name = this["__proto__"].constructor.name;
        }
    }

    class UIManager {
        constructor() {
            this.containerGComponent = new Sven_GComponent();
            this.toolTip = new Sven_GComponent();
            this.top = new Sven_GComponent();
            this.uiTop = new Sven_GComponent();
            this.ui = new Sven_GComponent();
            this.uiBottom = new Sven_GComponent();
            this.background = new Sven_GComponent();
            this.world = new Sven_GComponent();
            this.space = new Sven_GComponent();
            if (UIManager.m_instance != null) {
                console.error("This class is a single class !!!!!!!!!  new UIManager()  ?????");
                return;
            }
            else
                UIManager.m_instance = this;
            this.init();
        }
        static get Instance() {
            if (UIManager.m_instance == null) {
                UIManager.m_instance = new UIManager();
            }
            return UIManager.m_instance;
        }
        init() {
            fgui.GRoot.inst.addChild(this.containerGComponent);
            this.space.name = "sven.space";
            this.world.name = "sven.world";
            this.background.name = "sven.background";
            this.uiBottom.name = "sven.uibottom";
            this.ui.name = "sven.ui";
            this.uiTop.name = "sven.uiTop";
            this.top.name = "sven.top";
            this.toolTip.name = "sven.toolTip";
            this.containerGComponent.addChild(this.space);
            this.containerGComponent.addChild(this.world);
            this.containerGComponent.addChild(this.background);
            this.containerGComponent.addChild(this.uiBottom);
            this.containerGComponent.addChild(this.ui);
            this.containerGComponent.addChild(this.uiTop);
            this.containerGComponent.addChild(this.top);
            this.containerGComponent.addChild(this.toolTip);
        }
        add(_gcom, _depth) {
            if (_gcom.parent != null)
                return null;
            switch (_depth) {
                case EUIDepth.toolTip:
                    return this.toolTip.addChild(_gcom).asCom;
                case EUIDepth.top:
                    return this.top.addChild(_gcom).asCom;
                case EUIDepth.uiTop:
                    return this.uiTop.addChild(_gcom).asCom;
                case EUIDepth.ui:
                    return this.ui.addChild(_gcom).asCom;
                case EUIDepth.uiBottom:
                    return this.uiBottom.addChild(_gcom).asCom;
                case EUIDepth.background:
                    return this.background.addChild(_gcom).asCom;
                case EUIDepth.world:
                    return this.world.addChild(_gcom).asCom;
                case EUIDepth.space:
                    return this.space.addChild(_gcom).asCom;
                default:
                    console.error("addLayer ====> error !!! 无效");
            }
        }
        remove(_gcom) {
            if (_gcom.parent == null)
                return;
            _gcom.parent.removeChild(_gcom);
        }
        visiableLayer(_depth, _visible) {
            switch (_depth) {
                case EUIDepth.toolTip:
                    this.toolTip.visible = _visible;
                    break;
                case EUIDepth.top:
                    this.top.visible = _visible;
                    break;
                case EUIDepth.top:
                    this.uiTop.visible = _visible;
                    break;
                case EUIDepth.ui:
                    this.ui.visible = _visible;
                    break;
                case EUIDepth.uiBottom:
                    this.uiBottom.visible = _visible;
                    break;
                case EUIDepth.background:
                    this.background.visible = _visible;
                    break;
                case EUIDepth.world:
                    this.world.visible = _visible;
                    break;
                case EUIDepth.space:
                    this.space.visible = _visible;
                    break;
                default:
                    console.error("setVisiableLayer ====> error !!! 无效");
            }
        }
        setSize(_sizeX, _sizeY) {
            fgui.GRoot.inst.minWidth = _sizeX;
            this.containerGComponent.setScale(_sizeX, _sizeY);
        }
        setXY(_x, _y) {
            this.containerGComponent.setXY(_x, _y);
        }
    }
    UIManager.m_instance = null;
    var EUIDepth;
    (function (EUIDepth) {
        EUIDepth[EUIDepth["toolTip"] = 0] = "toolTip";
        EUIDepth[EUIDepth["top"] = 1] = "top";
        EUIDepth[EUIDepth["uiTop"] = 2] = "uiTop";
        EUIDepth[EUIDepth["ui"] = 3] = "ui";
        EUIDepth[EUIDepth["uiBottom"] = 4] = "uiBottom";
        EUIDepth[EUIDepth["background"] = 5] = "background";
        EUIDepth[EUIDepth["world"] = 6] = "world";
        EUIDepth[EUIDepth["space"] = 7] = "space";
    })(EUIDepth || (EUIDepth = {}));

    class Sven_GComponentAndFguiAddPackage extends Sven_GComponent {
        constructor() {
            super();
        }
    }

    class BaseWindow extends Sven_GComponentAndFguiAddPackage {
        constructor() {
            super();
            this.m_EUIDepth = EUIDepth.ui;
            this.m_isOpen = false;
            this.init();
            this["IUI"]();
        }
        IModel() { }
        get isOpen() {
            return this.m_isOpen;
        }
        get contentPane() {
            return this.m_contentPane;
        }
        set contentPane(value) {
            this.m_contentPane = value;
            if (this.m_contentPane.parent == null) {
                this.addChild(this.m_contentPane);
            }
        }
        back() {
        }
        open() {
            if (this.m_isOpen)
                return;
            UIManager.Instance.add(this, this.m_EUIDepth);
            this._container.visible = true;
            this.m_isOpen = true;
            this.m_Iview.setOpenView(true);
            this.m_Iview.openModule();
            this["openUI"]();
        }
        close() {
            if (!this.m_isOpen)
                return;
            this._container.visible = false;
            this.m_isOpen = false;
            this.m_Iview.setOpenView(false);
            this.m_Iview.closeModule();
            this["closeUI"]();
        }
        dispose() {
            this.m_isOpen = false;
            this.m_Iview.setOpenView(false);
            if (this.m_Iview != null)
                this.m_Iview.destroyModule();
            UIManager.Instance.remove(this);
            this["disposeUI"]();
            super.dispose();
        }
        init() {
        }
    }

    class LoginUIModel {
        constructor() { }
        IModel() { }
    }

    class LoginUIProxy extends Proxy {
        constructor() {
            super();
            this.setModelID = LoginUIModel;
            this.registered();
        }
        get model() {
            return this.getModel;
        }
    }

    class CloseModule extends TaskQueueBase {
        constructor(_classType, _isdestory = false) {
            super();
            this.m_classType = _classType;
            this.m_isdestory = _isdestory;
        }
        run() {
            ModulesManager.Instance.close(this.m_classType, this.m_isdestory);
            this.exit();
        }
    }

    class LoginUIView extends LoginUIProxy {
        constructor(_view) {
            super();
            this.m_view = _view;
        }
        LoginUIClick() {
            new CloseModule(ModuleEnume.LOGINUI, true).execute();
        }
        IView() { }
        openView() {
        }
        update() {
        }
        closeView() {
        }
        destroyView() {
        }
        backView() {
        }
    }

    class LoginUI extends BaseWindow {
        constructor() {
            super();
            this.m_EUIDepth = EUIDepth.uiTop;
            this.m_Iview = new LoginUIView(this);
        }
        IUI() {
        }
        openUI() {
        }
        closeUI() {
        }
        disposeUI() {
        }
        backUI() {
        }
    }

    class LoadingUIView extends LoadingUIProxy {
        constructor(_view) {
            super();
            this.m_progressBarValue = 0;
            this.m_view = _view;
            this.m_view.progressBar.value = 1;
            this.m_view.width = 220;
            this.m_view.versionText.text = Global.gameVersionString;
        }
        IView() { }
        openView() {
        }
        update() {
            this.m_view.progressBar.value = this.model.progressNumber;
            this.m_view.aniText.text = this.m_view.progressBar.value.toFixed();
        }
        closeView() {
        }
        destroyView() {
        }
        backView() {
        }
        timerCallBck() {
        }
    }

    class LoadingUI extends BaseWindow {
        constructor() {
            super();
            this.m_Iview = new LoadingUIView(this);
        }
        IUI() {
            this.contentPane = fgui.UIPackage.createObject("LoadingUI", "Main").asCom;
            this.progressBar = this.contentPane.getChild("progress_01").asProgress;
            this.progressBar.visible = true;
            this.versionText = this.contentPane.getChild("versionText").asTextField;
            this.logo = this.contentPane.getChild("n28").asImage;
            this.logo.visible = false;
            this.aniText = this.progressBar.getChild("ani").asCom.getChild("n1").asTextField;
        }
        openUI() {
        }
        closeUI() {
        }
        disposeUI() {
        }
        backUI() {
        }
    }

    class GameUIModel {
        constructor() {
            this.exp = 0;
            this.progress = 1;
            this.gameTimer = Global.gameTimerMax;
        }
        IModel() { }
    }

    class GameUIProxy extends Proxy {
        constructor() {
            super();
            this.setModelID = GameUIModel;
            this.registered();
        }
        get model() {
            return this.getModel;
        }
    }

    class GameUIView extends GameUIProxy {
        constructor(_view) {
            super();
            this.m_progressBarValue = 0;
            this.m_view = _view;
            this.model.exp = 0;
            this.model.progress = 0;
            this.model.gameTimer = Global.gameTimerMax;
            this.m_timer = new Laya.Timer();
            this.m_timer.loop(1000, this, this.timerCallBck);
            this.m_view.timerText.text = this.model.gameTimer.toString();
            window["sdk"].hideBanner();
        }
        IView() { }
        openView() {
        }
        update() {
            this.m_view.progressBar.value = this.model.progress;
            this.m_view.expText.text = this.model.exp.toString();
        }
        closeView() {
        }
        destroyView() {
            this.m_timer.pause();
            this.m_timer.clear(this, this.timerCallBck);
            this.m_timer.clearAll(this);
        }
        backView() {
        }
        timerCallBck() {
            let _timer = this.model.gameTimer--;
            let _timerString = _timer;
            Global.gameTimeRemaining = _timerString;
            this.m_view.timerText.text = _timerString.toString();
            if (_timer >= 0)
                return;
            this.m_timer.pause();
            this.gameOver();
        }
        gameOver() {
            console.log("GameOver!  -----   GameOver!");
        }
    }

    class GameUI extends BaseWindow {
        constructor() {
            super();
            this.m_Iview = new GameUIView(this);
        }
        IUI() {
            this.contentPane = fgui.UIPackage.createObject("GameUI", "Main").asCom;
            this.progressBar = this.contentPane.getChild("n0").asCom.getChild("progress_01").asProgress;
            this.expText = this.contentPane.getChild("n0").asCom.getChild("n5").asTextField;
            this.timerText = this.contentPane.getChild("timerText").asTextField;
            this.m_dinosaurCom = this.contentPane.getChild("DinosaurCom").asCom;
        }
        openUI() {
            this.m_dinosaurCom.center();
        }
        closeUI() {
        }
        disposeUI() {
        }
        backUI() {
        }
    }

    class EventManager {
        constructor() {
            this.ed = new Laya.EventDispatcher();
        }
        static get inst() {
            if (!EventManager._inst) {
                EventManager._inst = new EventManager;
            }
            return EventManager._inst;
        }
        Emit(name, ...args) {
            this.ed.event(name, args);
        }
        AddNotice(name, caller, listener) {
            this.ed.on(name, caller, listener);
        }
        RemoveNotice(name, caller, listener) {
            this.ed.off(name, caller, listener);
        }
    }
    EventManager.LOADSCENE = 'loadscene';
    EventManager.SCENELOADED = 'sceneloaded';
    EventManager.PLAY = 'play';
    EventManager.FINISH = 'finish';
    EventManager.END = 'end';
    EventManager.DEAD = 'dead';
    EventManager.EndlessEnd = 'endlessend';
    EventManager.SCALEBULLET = 'scalebullet';
    EventManager.ChagePlayerName = "ChagePlayerNmae";
    EventManager.ChageSkinsName = "ChageSkinsName";
    EventManager.SoundOn = "SoundOn";
    EventManager.SoundOff = "SoundOff";
    EventManager.MusicOn = "MusicOn";
    EventManager.MusicOff = "MusicOff";
    EventManager.RoleEvent = "RoleEvent";
    EventManager.RoleUIEvent = "RoleUIEvent";
    EventManager.MYEND = "MYEND";
    EventManager.MYBEGIN = "MYBEGIN";

    class SettingsUIModel {
        constructor() {
            this.m_isShake = true;
            this.m_isSound = true;
            this.m_isMusic = true;
            let _isShake = LocalStorage.getItem('isShake');
            let _isSound = LocalStorage.getItem('isSound');
            let _isMusic = LocalStorage.getItem('isMusic');
            if (_isShake != null)
                this.m_isShake = (_isShake != "0");
            if (_isSound != null)
                this.m_isSound = (_isSound != "0");
            if (_isMusic != null)
                this.m_isMusic = (_isMusic != "0");
            this.dataUpdate();
        }
        IModel() { }
        set isMusic(_bool) {
            this.m_isMusic = _bool;
            let _string = '0';
            this.m_isMusic = _bool;
            if (this.m_isMusic == true)
                _string = '1';
            LocalStorage.setItem('isMusic', _string);
            this.dataUpdate();
        }
        get isMusic() {
            return this.m_isMusic;
        }
        set isShake(_bool) {
            let _string = '0';
            this.m_isShake = _bool;
            if (this.m_isSound == true)
                _string = '1';
            LocalStorage.setItem('isShake', _string);
        }
        get isShake() {
            return this.m_isShake;
        }
        set isSound(_bool) {
            let _string = '0';
            this.m_isSound = _bool;
            if (this.m_isSound == true)
                _string = '1';
            LocalStorage.setItem('isSound', _string);
            this.dataUpdate();
        }
        get isSound() {
            return this.m_isSound;
        }
        dataUpdate() {
            if (this.m_isSound)
                EventManager.inst.Emit(EventManager.SoundOn);
            else
                EventManager.inst.Emit(EventManager.SoundOff);
            if (this.m_isMusic)
                EventManager.inst.Emit(EventManager.MusicOn);
            else
                EventManager.inst.Emit(EventManager.MusicOff);
        }
    }

    class SettingsUIProxy extends Proxy {
        constructor() {
            super();
            this.setModelID = SettingsUIModel;
            this.registered();
        }
        get model() {
            return this.getModel;
        }
    }

    class TipsUIModel {
        constructor() {
            this.describe = '';
            this.isOpen = false;
        }
        IModel() { }
    }

    class TipsUIProxy extends Proxy {
        constructor() {
            super();
            this.setModelID = TipsUIModel;
            this.registered();
        }
        get model() {
            return this.getModel;
        }
    }

    class TipsUIComd extends TipsUIProxy {
        constructor(_describe) {
            super();
            this.model.describe = _describe;
            this.model.isOpen = true;
        }
        execute() {
            this.refresh();
        }
        ICommand() { }
    }

    class ChannelID {
    }
    ChannelID.TEST = 0;
    ChannelID.OPPO = 1;
    ChannelID.VIVO = 2;
    ChannelID.TT = 3;
    ChannelID.HUAWEI = 4;
    class Globall {
    }
    Globall.bannerCount = 0;
    Globall.nativeCount = 0;
    Globall.rewardCd = 30000;
    Globall.isGamed = false;
    Globall.startGame = 0;
    Globall.isHwTest = false;
    Globall.isUseTestId = false;
    Globall.isShowGray = null;
    Globall.isUseWuChu = true;
    Globall.adSwitch = 0;
    Globall.nativeClickRate = 0;
    Globall.isShowVideo = 1;
    Globall.isVOTest = 0;
    Globall.nativeCD = 15;
    let AdIDS = [
        {
            insertId: '111111',
            bannerId: '222222',
            rewardId: '333333',
            nativeId: '444444',
        },
        {
            bannerId: '257272',
            rewardId: '257271',
            nativeId: ['257276', '257277', '257278', '257280'],
        },
        {
            insertId: '021ba99fe47440c1a4118d4cf5347eea',
            bannerId: '106e5d3471c34a6584638eedd7009b22',
            rewardId: '04cd535f7e8342319b522d659658a684',
            nativeId: '3d7121d3f7194e47be703476aab12a28',
        },
        {
            insertId: 'e52057jedgk11ccja7',
            bannerId: 'wouef3pce5j7f03dp4',
            rewardId: '10f2doffefgj6n562p',
        },
        {
            rewardId: 'e7hm5vx799',
            nativeId: 'testu7m3hc4gvm',
            formalRewardId: "k450i6lyo2",
            formalNativeId: "s7x36pcb5k",
            formalBanner: "o4pt5puf85",
        }
    ];

    class SettingsUIView extends SettingsUIProxy {
        constructor(_view) {
            super();
            this.m_view = _view;
            this.m_view.musicBtn.onClick(this, this.musicCtonChanged);
            this.m_view.soundBtn.onClick(this, this.soundCtonChanged);
            this.m_view.shakeBtn.onClick(this, this.shakeCtonChanged);
            this.m_view.closeBtn.onClick(this, this.onBgClick);
            this.m_view.rankingCom.onClick(this, this.onRankingComClick);
            if (window['myPlatform'] == ChannelID.OPPO) {
                if (Globall.bannerCount < 5) {
                    window["sdk"].openBanner();
                }
            }
        }
        onRankingComClick() {
            new TipsUIComd('暂未开放').execute();
        }
        onBgClick() {
            window["sdk"].hideBanner();
            window["sdkmgr"].openNative(Laya.stage, 1, null, true, false);
            new CloseModule(ModuleEnume.SETTINGSUI, true).execute();
        }
        shakeCtonChanged() {
            let isAhake = !this.m_view.shakeBtn.selected;
        }
        musicCtonChanged() {
            let isMusic = !this.m_view.musicBtn.selected;
            this.model.isMusic = isMusic;
        }
        soundCtonChanged() {
            let isSound = !this.m_view.soundBtn.selected;
            this.model.isSound = isSound;
        }
        IView() { }
        openView() {
            window["sdkmgr"].openNative(Laya.stage, 1, null, true, false);
            this.m_view.uiController.selectedPage = 'open';
        }
        update() {
            this.m_view.soundBtn.selected = !this.model.isSound;
            this.m_view.musicBtn.selected = !this.model.isMusic;
        }
        closeView() {
        }
        destroyView() {
        }
        backView() {
        }
    }

    class SettingsUI extends BaseWindow {
        constructor() {
            super();
            this.m_EUIDepth = EUIDepth.uiTop;
            this.m_Iview = new SettingsUIView(this);
        }
        IUI() {
            this.contentPane = fgui.UIPackage.createObject("SettingsUI", "Main").asCom;
            this.uiController = this.contentPane.getController('c1');
            let _com = this.contentPane.getChild("n8").asCom;
            this.musicBtn = _com.getChild("musicBtn").asButton;
            this.soundBtn = _com.getChild("soundBtn").asButton;
            this.shakeBtn = _com.getChild("shakeBtn").asButton;
            this.closeBtn = _com.getChild("closeBtn").asButton;
            this.rankingCom = _com.getChild('n11').asCom;
            this.rankingCom.visible = false;
        }
        openUI() {
        }
        closeUI() {
        }
        disposeUI() {
        }
        backUI() {
        }
    }

    class MainUIModel {
        constructor() {
            this.isSuper = false;
            this.m_playerName = "Player";
            this.m_playerMoney = 0;
            this.playerRuank = 1;
            this.playerExp = 1;
            this.m_achievementSystemRank = 1;
            this.m_achievementSystemExp = 0;
            this.m_baseExp = 200;
            this.m_achievementSystemExpMax = this.m_baseExp;
            LocalStorage.getSignNum();
            this.m_POWER = LocalStorage.getItem('POWER');
            this.m_SPEED = LocalStorage.getItem('SPEED');
            this.m_GROWTH = LocalStorage.getItem('GROWTH');
            if (!this.m_POWER)
                this.POWER = 0;
            if (!this.m_SPEED)
                this.SPEED = 0;
            if (!this.m_GROWTH)
                this.GROWTH = 0;
            let _playerName = LocalStorage.getItem('playerName');
            let _playerMoney = LocalStorage.getItem('playerMoney');
            let _playerRuank = LocalStorage.getItem('playerRuank');
            let _playerExp = LocalStorage.getItem('playerExp');
            let _achievementSystemRank = LocalStorage.getItem('achievementSystemRank');
            let _achievementSystemExp = LocalStorage.getItem('achievementSystemExp');
            let _achievementSystemExpMax = LocalStorage.getItem('achievementSystemExpMax');
            if (_achievementSystemRank && _achievementSystemExp) {
                this.m_achievementSystemRank = Number(_achievementSystemRank);
                this.m_achievementSystemExp = Number(_achievementSystemExp);
                this.m_achievementSystemExpMax = Number(_achievementSystemExpMax);
            }
            if (_playerName != null) {
                this.m_playerName = _playerName;
            }
            if (_playerMoney != null) {
                this.m_playerMoney = Math.ceil(Number(_playerMoney));
            }
            if (_playerRuank != null) {
                this.playerRuank = Number(_playerRuank);
            }
            if (_playerExp != null) {
                this.playerExp = Math.ceil(Number(_playerExp));
            }
        }
        IModel() { }
        get playerMoney() {
            return this.m_playerMoney;
        }
        set playerMoney(_money) {
            this.m_playerMoney = Math.ceil(_money);
            LocalStorage.setItem('playerMoney', this.m_playerMoney.toString());
        }
        get playerName() {
            return this.m_playerName;
        }
        set playerName(_string) {
            this.m_playerName = _string;
            LocalStorage.setItem('playerName', this.m_playerName);
        }
        get achievementSystemRank() {
            return this.m_achievementSystemRank;
        }
        get achievementSystemExp() {
            return this.m_achievementSystemExp;
        }
        get achievementSystemExpMax() {
            return this.m_achievementSystemExpMax;
        }
        addMainExp(_addMainExp) {
            let isRankUp = false;
            let expAll = this.m_achievementSystemRank * this.m_baseExp;
            let exp = this.m_achievementSystemExp + _addMainExp;
            if (exp >= expAll) {
                if (this.m_achievementSystemRank < 14) {
                    this.m_achievementSystemRank++;
                    this.m_achievementSystemExp = exp - expAll;
                    expAll = this.m_achievementSystemRank * this.m_baseExp;
                    isRankUp = true;
                }
                else {
                    this.m_achievementSystemExp = expAll;
                }
            }
            else {
                this.m_achievementSystemExp = exp;
            }
            this.m_achievementSystemExpMax = expAll;
            this.m_achievementSystemExpMax = Math.ceil(this.m_achievementSystemExpMax);
            this.m_achievementSystemExp = Math.ceil(this.m_achievementSystemExp);
            this.m_achievementSystemRank = Math.ceil(this.m_achievementSystemRank);
            LocalStorage.setItem('achievementSystemRank', this.m_achievementSystemRank.toString());
            LocalStorage.setItem('achievementSystemExp', this.m_achievementSystemExp.toString());
            LocalStorage.setItem('achievementSystemExpMax', this.m_achievementSystemExpMax.toString());
            return isRankUp;
        }
        get POWER() {
            return Number(this.m_POWER);
        }
        get SPEED() {
            return Number(this.m_SPEED);
        }
        get GROWTH() {
            return Number(this.m_GROWTH);
        }
        set POWER(_value) {
            this.m_POWER = _value.toFixed(0);
            LocalStorage.setItem('POWER', this.m_POWER);
        }
        set SPEED(_value) {
            this.m_SPEED = _value.toFixed(0);
            LocalStorage.setItem('SPEED', this.m_SPEED);
        }
        set GROWTH(_value) {
            this.m_GROWTH = _value.toFixed(0);
            LocalStorage.setItem('GROWTH', this.m_GROWTH);
        }
        set LoginDate(_number) {
            LocalStorage.m_LoginDate = _number.toString();
            LocalStorage.setItem('LoginDate', _number.toString());
        }
    }

    class MainUIProxy extends Proxy {
        constructor() {
            super();
            this.setModelID = MainUIModel;
            this.registered();
        }
        get model() {
            return this.getModel;
        }
    }

    class GetMoneyComd extends MainUIProxy {
        constructor() {
            super();
            this.moneyAll = this.model.playerMoney;
        }
        execute() {
        }
        ICommand() { }
    }

    class SetMoneyComd extends MainUIProxy {
        constructor(_money) {
            super();
            this.model.playerMoney = _money;
        }
        execute() {
            this.refresh();
        }
        ICommand() { }
    }

    class AchievementsUIModel {
        constructor() {
            this.m_destroyCarsNumber = 0;
            this.m_destroySkyscraperNumber = 0;
            this.m_destroyDinosaurNumber = 0;
            this.m_destroyHumanNumber = 0;
            this.destroyCarsNumberMax = 0;
            this.destroySkyscraperNumberMax = 0;
            this.destroyDinosaurNumberMax = 0;
            this.destroyHumanNumberMax = 0;
            let _destroyCarsNumber = LocalStorage.getItem('destroyCarsNumber');
            let _destroySkyscraperNumber = LocalStorage.getItem('destroySkyscraperNumber');
            let _destroyDinosaurNumber = LocalStorage.getItem('destroyDinosaurNumber');
            let _destroyHumanNumber = LocalStorage.getItem('destroyHumanNumber');
            if (!_destroyCarsNumber)
                _destroyCarsNumber = "0";
            this.m_destroyCarsNumber = Number(_destroyCarsNumber);
            this.destroyCarsNumberMax = Math.round(this.m_destroyCarsNumber / 500 + 1) * 500;
            this.destroyCarsNumberMax = Math.round(this.destroyCarsNumberMax);
            if (!_destroySkyscraperNumber)
                _destroySkyscraperNumber = "0";
            this.m_destroySkyscraperNumber = Number(_destroySkyscraperNumber);
            this.destroySkyscraperNumberMax = Math.round(this.m_destroySkyscraperNumber / 500 + 1) * 500;
            this.destroySkyscraperNumberMax = Math.round(this.destroySkyscraperNumberMax);
            if (!_destroyCarsNumber)
                _destroyCarsNumber = "0";
            this.m_destroyDinosaurNumber = Number(_destroyDinosaurNumber);
            this.destroyDinosaurNumberMax = Math.round(this.m_destroyDinosaurNumber / 500 + 1) * 500;
            this.destroyDinosaurNumberMax = Math.round(this.destroyDinosaurNumberMax);
            if (!_destroyHumanNumber)
                _destroyHumanNumber = "0";
            this.m_destroyHumanNumber = Number(_destroyHumanNumber);
            this.destroyHumanNumberMax = Math.round(this.m_destroyHumanNumber / 500 + 1) * 500;
            this.destroyHumanNumberMax = Math.round(this.destroyHumanNumberMax);
        }
        IModel() { }
        get destroyCarsNumber() {
            return this.m_destroyCarsNumber;
        }
        set destroyCarsNumber(_value) {
            this.m_destroyCarsNumber = Math.fround(_value);
            LocalStorage.setItem('destroyCarsNumber', this.m_destroyCarsNumber.toString());
            if (this.m_destroyCarsNumber > this.destroyCarsNumberMax) {
                this.addMoney();
                this.destroyCarsNumberMax + 500;
            }
        }
        get destroySkyscraperNumber() {
            return this.m_destroySkyscraperNumber;
        }
        set destroySkyscraperNumber(_value) {
            this.m_destroySkyscraperNumber = Math.fround(_value);
            LocalStorage.setItem('destroySkyscraperNumber', this.m_destroySkyscraperNumber.toString());
            if (this.m_destroySkyscraperNumber > this.destroySkyscraperNumberMax) {
                this.addMoney();
                this.destroySkyscraperNumberMax + 500;
            }
        }
        get destroyDinosaurNumber() {
            return this.m_destroyDinosaurNumber;
        }
        set destroyDinosaurNumber(_value) {
            this.m_destroyDinosaurNumber = Math.fround(_value);
            LocalStorage.setItem('destroyDinosaurNumber', this.m_destroyDinosaurNumber.toString());
            if (this.m_destroyDinosaurNumber > this.destroyDinosaurNumberMax) {
                this.addMoney();
                this.destroyDinosaurNumberMax + 500;
            }
        }
        get destroyHumanNumber() {
            return this.m_destroyHumanNumber;
        }
        set destroyHumanNumber(_value) {
            this.m_destroyHumanNumber = Math.fround(_value);
            LocalStorage.setItem('destroyHumanNumber', this.m_destroyHumanNumber.toString());
            if (this.m_destroyHumanNumber > this.destroyHumanNumberMax) {
                this.addMoney();
                this.destroyHumanNumberMax + 500;
            }
        }
        addMoney() {
            let _money = new GetMoneyComd().moneyAll + 500;
            new SetMoneyComd(_money).execute();
        }
    }

    class AchievementsUIProxy extends Proxy {
        constructor() {
            super();
            this.setModelID = AchievementsUIModel;
            this.registered();
        }
        get model() {
            return this.getModel;
        }
    }

    class AchievementChildCom {
        constructor(_com) {
            this.GProgressBar = _com.getChild('n3').asProgress;
            this.MoneyText = _com.getChild('n7').asTextField;
            this.ProgressText = _com.getChild('n4').asTextField;
            this.DescribeText = _com.getChild('n5').asTextField;
        }
    }

    var Handler$1 = Laya.Handler;
    class AchievementsUIView extends AchievementsUIProxy {
        constructor(_view) {
            super();
            this.m_view = _view;
            this.m_view.okBtn.onClick(this, this.onOkBtnClick);
            this.m_view.itemlist.itemRenderer = Handler$1.create(this, this.renderListItem, null, false);
            this.m_view.itemlist.numItems = 4;
        }
        renderListItem(index, com) {
            let describe;
            let moneyString = "500";
            let progress;
            let taskNumber;
            let taskNumberMax;
            if (index == 0) {
                taskNumber = this.model.destroyCarsNumber;
                taskNumberMax = this.model.destroyCarsNumberMax;
                describe = "摧毁" + taskNumberMax + "辆汽车";
            }
            else if (index == 1) {
                taskNumber = this.model.destroyDinosaurNumber;
                taskNumberMax = this.model.destroyDinosaurNumberMax;
                describe = "消灭" + taskNumberMax + "个恐龙";
            }
            else if (index == 2) {
                taskNumber = this.model.destroyHumanNumber;
                taskNumberMax = this.model.destroyHumanNumberMax;
                describe = "消灭" + taskNumberMax + "个人类";
            }
            else if (index == 3) {
                taskNumber = this.model.destroySkyscraperNumber;
                taskNumberMax = this.model.destroySkyscraperNumberMax;
                describe = "摧毁" + taskNumberMax + "个建筑";
            }
            progress = taskNumber / taskNumberMax * 100;
            let _com = new AchievementChildCom(com);
            _com.DescribeText.text = describe;
            _com.ProgressText.text = taskNumber + '/' + taskNumberMax;
            _com.MoneyText.text = moneyString;
            _com.GProgressBar.value = progress;
        }
        onOkBtnClick() {
            new CloseModule(ModuleEnume.ACHIEVEMENTSUI, true).execute();
        }
        IView() { }
        openView() {
        }
        update() {
            this.m_view.itemlist.numItems = 0;
            this.m_view.itemlist.numItems = 4;
        }
        closeView() {
            this.m_view.itemlist.numItems = 0;
            this.m_view.itemlist.numItems = 4;
        }
        destroyView() {
        }
        backView() {
        }
    }

    class AchievementsUI extends BaseWindow {
        constructor() {
            super();
            this.m_EUIDepth = EUIDepth.uiTop;
            this.m_Iview = new AchievementsUIView(this);
        }
        IUI() {
            this.contentPane = fgui.UIPackage.createObject("AchievementsUI", "Main").asCom;
            this.okBtn = this.contentPane.getChild("n7").asCom;
            this.itemlist = this.contentPane.getChild('n2').asList;
        }
        openUI() {
        }
        closeUI() {
        }
        disposeUI() {
        }
        backUI() {
        }
    }

    class FinishUIModel {
        constructor() { }
        IModel() { }
    }

    class FinishUIProxy extends Proxy {
        constructor() {
            super();
            this.setModelID = FinishUIModel;
            this.registered();
        }
        get model() {
            return this.getModel;
        }
    }

    class AssetsUIModel {
        constructor() {
            this.m_gold = 0;
            this.m_diamond = 0;
        }
        IModel() { }
        get gold() {
            let _value = LocalStorage.getJSON('AssetsUIModel_gold');
            if (!_value)
                this.gold = this.m_gold;
            else
                this.gold = _value;
            return this.m_gold;
        }
        set gold(_value) {
            this.m_gold = _value;
            LocalStorage.setJSON('AssetsUIModel_gold', _value);
        }
        get diamond() {
            let _value = LocalStorage.getJSON('AssetsUIModel_diamond');
            if (!_value)
                this.diamond = this.m_diamond;
            else
                this.diamond = _value;
            return this.m_diamond;
        }
        set diamond(_value) {
            this.m_diamond = _value;
            LocalStorage.setJSON('AssetsUIModel_diamond', _value);
        }
    }

    class AssetsUIProxy extends Proxy {
        constructor() {
            super();
            this.setModelID = AssetsUIModel;
            this.registered();
        }
        get model() {
            return this.getModel;
        }
    }

    class AssetsUIGetDiamondComd extends AssetsUIProxy {
        constructor() {
            super();
            this.diamond = this.model.diamond;
        }
        execute() {
            this.refresh();
        }
        ICommand() { }
    }

    class AssetsUIGetGoldComd extends AssetsUIProxy {
        constructor() {
            super();
            this.gold = this.model.gold;
        }
        execute() {
            this.refresh();
        }
        ICommand() { }
    }

    class AssetsUIAddGoldComd extends AssetsUIProxy {
        constructor(_gold) {
            super();
            this.model.gold += _gold;
        }
        execute() {
            this.refresh();
        }
        ICommand() { }
    }

    class TaskUIModel {
        constructor() {
            this.m_loginDayArr = [true, false, false, false, false, false, false];
            this.m_dayReceiveArr = [false, false, false, false, false, false, false];
            this.init();
        }
        IModel() { }
        init() {
            if (!LocalStorage.isSign()) {
                LocalStorage.setItem('everydayDiamond', '0');
                LocalStorage.setItem('everydayGold', '0');
                LocalStorage.setItem('每日任务1领取', 'false');
                LocalStorage.setItem('每日任务2领取', 'false');
                LocalStorage.setItem('每日任务3领取', 'false');
            }
            let _loginDayArr = LocalStorage.getJSON('loginDayArr');
            let _dayReceiveArr = LocalStorage.getJSON('dayReceiveArr');
            if (_dayReceiveArr)
                this.m_dayReceiveArr = _dayReceiveArr;
            let _everydayDiamond = LocalStorage.getJSON('everydayDiamond');
            if (!_everydayDiamond)
                _everydayDiamond = 0;
            this.everydayDiamond = _everydayDiamond;
            console.log(_everydayDiamond, "_everydayDiamond");
            let _everydayGold = LocalStorage.getJSON('everydayGold');
            if (!_everydayGold)
                _everydayGold = 0;
            this.everydayGold = _everydayGold;
        }
        get loginDayArr() {
            return this.m_loginDayArr;
        }
        get dayReceiveArr() {
            return this.m_dayReceiveArr;
        }
        get everydayGold() {
            return this.m_everydayGold;
        }
        set everydayGold(_value) {
            this.m_everydayGold = _value;
            LocalStorage.setJSON('everydayGold', this.m_everydayGold);
        }
        set addEverydayGold(_value) {
            this.m_everydayGold += _value;
        }
        get everydayDiamond() {
            return this.m_everydayDiamond;
        }
        set everydayDiamond(_value) {
            this.m_everydayDiamond = _value;
            LocalStorage.setJSON('everydayDiamond', this.m_everydayDiamond);
        }
        set addEverydayDiamond(_value) {
            this.everydayDiamond += _value;
        }
        setDayReceiveArrItem(_index, _boole = true) {
            this.m_dayReceiveArr[_index] = _boole;
            LocalStorage.setJSON('dayReceiveArr', this.m_dayReceiveArr);
            if (_index == 0) {
                new AssetsUIAddGoldComd(300).execute();
            }
            if (_index == 1) {
                GameConfigManager.Instance.RoleCfVo.getData('31').unlock = true;
            }
            if (_index == 2) {
                GameConfigManager.Instance.RoleCfVo.getData('32').unlock = true;
            }
            if (_index == 3) {
                GameConfigManager.Instance.RoleCfVo.getData('33').unlock = true;
            }
            if (_index == 4) {
                new AssetsUIAddGoldComd(800).execute();
            }
            if (_index == 5) {
                new AssetsUIAddGoldComd(2000).execute();
            }
            if (_index == 6) {
                GameConfigManager.Instance.RoleCfVo.getData('34').unlock = true;
            }
        }
        get checkpointComplete() {
            this.m_checkpointComplete = LocalStorage.getJSON('checkpointComplete');
            if (!this.m_checkpointComplete)
                this.checkpointComplete = 0;
            return this.m_checkpointComplete;
        }
        set checkpointComplete(_value) {
            this.m_checkpointComplete = _value;
            LocalStorage.setJSON('checkpointComplete', _value);
        }
        get overComplet() {
            this.m_overComplet = LocalStorage.getJSON('overComplet');
            if (!this.m_overComplet)
                this.overComplet = 0;
            return this.m_overComplet;
        }
        set overComplet(_value) {
            this.m_overComplet = _value;
            LocalStorage.setJSON('overComplet', _value);
        }
        get flyingObject() {
            this.m_flyingObject = LocalStorage.getJSON('flyingObject');
            if (!this.m_flyingObject)
                this.flyingObject = 0;
            return this.m_flyingObject;
        }
        set flyingObject(_value) {
            this.m_flyingObject = _value;
            LocalStorage.setJSON('flyingObject', _value);
        }
        get hitBomb() {
            this.m_hitBomb = LocalStorage.getJSON('hitBomb');
            if (!this.m_hitBomb)
                this.hitBomb = 0;
            return this.m_hitBomb;
        }
        set hitBomb(_value) {
            this.m_hitBomb = _value;
            LocalStorage.setJSON('hitBomb', _value);
        }
    }

    class TaskUIProxy extends Proxy {
        constructor() {
            super();
            this.setModelID = TaskUIModel;
            this.registered();
        }
        get model() {
            return this.getModel;
        }
    }

    class TaskUIAddEverydayGoldComd extends TaskUIProxy {
        constructor(_value) {
            super();
            this.model.everydayGold += _value;
        }
        execute() {
            this.refresh();
        }
        ICommand() { }
    }

    class AssetsUISetGoldComd extends AssetsUIProxy {
        constructor(_gold) {
            super();
            if (_gold < this.model.gold)
                new TaskUIAddEverydayGoldComd(this.model.gold - _gold).execute();
            this.model.gold = _gold;
        }
        execute() {
            this.refresh();
        }
        ICommand() { }
    }

    class TaskUIAddEverydayDiamondComd extends TaskUIProxy {
        constructor(_value) {
            super();
            this.model.everydayDiamond += _value;
        }
        execute() {
            this.refresh();
        }
        ICommand() { }
    }

    class AssetsUISetDiamondComd extends AssetsUIProxy {
        constructor(_diamond) {
            super();
            if (_diamond < this.model.diamond)
                new TaskUIAddEverydayDiamondComd(this.model.diamond - _diamond).execute();
            this.model.diamond = _diamond;
        }
        execute() {
            this.refresh();
        }
        ICommand() { }
    }

    class RoleUIModel {
        constructor() {
            this.init();
        }
        IModel() { }
        init() {
            this.roleItemArr = GameConfigManager.Instance.RoleCfVo.getAllRoleVo();
            this.roleItemArr[0].unlock = true;
            this.selectShowRoleVo = this.m_selectRoleVo = this.roleItemArr[0];
            let id = LocalStorage.getItem('selectRoleVoID');
            if (id) {
                this.selectShowRoleVo = this.selectRoleVo = GameConfigManager.Instance.RoleCfVo.getData(id);
            }
            EventManager.inst.Emit(EventManager.RoleEvent, this.selectRoleVo);
        }
        get selectRoleVo() {
            return this.m_selectRoleVo;
        }
        set selectRoleVo(_value) {
            this.m_selectRoleVo = _value;
            LocalStorage.setItem('selectRoleVoID', this.m_selectRoleVo.id);
        }
    }

    class RoleUIProxy extends Proxy {
        constructor() {
            super();
            this.setModelID = RoleUIModel;
            this.registered();
        }
        get model() {
            return this.getModel;
        }
    }

    class RoleUISelectRoleVoComd extends RoleUIProxy {
        constructor(_roleVo) {
            super();
            this.model.selectShowRoleVo = this.model.selectRoleVo = _roleVo;
            EventManager.inst.Emit(EventManager.RoleEvent, this.model.selectRoleVo);
        }
        execute() {
            this.refresh();
        }
        ICommand() { }
    }

    class NavigationUIModel {
        constructor() {
            this.setCT_index = false;
            this.trial = true;
        }
        IModel() { }
    }

    class NavigationUIProxy extends Proxy {
        constructor() {
            super();
            this.setModelID = NavigationUIModel;
            this.registered();
        }
        get model() {
            return this.getModel;
        }
    }

    class NavigationUITrialComd extends NavigationUIProxy {
        constructor() {
            super();
            this.model.trial = true;
        }
        ICommand() { }
        execute() {
            this.refresh();
        }
    }

    class RoleUIGetSelectRoleVoComd extends RoleUIProxy {
        constructor() {
            super();
            this.roleVo = this.model.selectRoleVo;
        }
        execute() {
        }
        ICommand() { }
    }

    class BattleUIModel {
        constructor() {
            this.maxScore = 0;
            this.proportion = 0;
            this.levelProgress = 0;
            this.m_score = 0;
            this.gold = 0;
            let _maxScore = LocalStorage.getJSON('maxScore');
            if (_maxScore) {
                this.maxScore = _maxScore;
            }
        }
        IModel() { }
        set score(_value) {
            this.m_score = _value;
            if (this.m_score > this.maxScore) {
                LocalStorage.setJSON('maxScore', this.m_score);
                this.maxScore = this.m_score;
            }
        }
        get score() {
            return this.m_score;
        }
    }

    class BattleUIProxy extends Proxy {
        constructor() {
            super();
            this.setModelID = BattleUIModel;
            this.registered();
        }
        get model() {
            return this.getModel;
        }
    }

    class BattleUIGetGoldComd extends BattleUIProxy {
        constructor() {
            super();
            this.gold = this.model.gold;
        }
        execute() {
        }
        ICommand() { }
    }

    class GetIsSuperComd extends MainUIProxy {
        constructor() {
            super();
            this.isSuper = this.model.isSuper;
        }
        execute() {
        }
        ICommand() { }
    }

    class TimeUtil {
        constructor(key) {
            this.timeKey = "";
            this.lastTime = 0;
            this.timeKey = key;
        }
        isNextDay() {
            var now = new Date();
            let nowTime = Date.parse(now.toString());
            let nowDay = now.getDate();
            let nowMonth = now.getMonth();
            let nowYear = now.getFullYear();
            let lasttime = new Date(this.lastTime);
            let lastDay = lasttime.getDate();
            let lastMonth = lasttime.getMonth();
            let lastYear = lasttime.getFullYear();
            if (lastYear == nowYear && lastMonth == nowMonth && lastDay == nowDay) {
                return false;
            }
            let tomorrow = this.lastTime + 24 * 60 * 60 * 1000;
            let tomorrowDay = new Date(tomorrow);
            let tomoDay = tomorrowDay.getDate();
            let tomoMonth = tomorrowDay.getMonth();
            let tomoYear = tomorrowDay.getFullYear();
            if (tomoYear == nowYear && tomoMonth == nowMonth && tomoDay == nowDay) {
                return true;
            }
            else {
                return false;
            }
        }
        isNowToday() {
            var now = new Date();
            let nowTime = Date.parse(now.toString());
            let nowDay = now.getDate();
            let nowMonth = now.getMonth();
            let nowYear = now.getFullYear();
            let lasttime = new Date(this.lastTime);
            let lastDay = lasttime.getDate();
            let lastMonth = lasttime.getMonth();
            let lastYear = lasttime.getFullYear();
            if (lastYear == nowYear && lastMonth == nowMonth && lastDay == nowDay) {
                return true;
            }
            return false;
        }
        getLongTime() {
            let nowTime = Date.parse(Date());
            return nowTime - this.lastTime;
        }
        static timeStr(time) {
            let min = Math.floor(time / 60);
            let sec = Math.floor(time % 60);
            let text = sec >= 10 ? min + ":" + sec : min + ":0" + sec;
            return text;
        }
        static getCurTime() {
            return Date.parse(Date());
        }
        static saveCurTime() {
            this.curTime = Date.parse(Date());
        }
        static init() {
            this.startTime = Date.parse(Date());
        }
    }
    TimeUtil.curTime = 0;
    TimeUtil.startTime = 0;

    class FinishUIView extends FinishUIProxy {
        constructor(_view) {
            super();
            this.m_view = _view;
            this.m_view.okBtn.onClick(this, this.onOkBtnClick);
            this.m_view.doublebtn.onClick(this, this.shareBtnClick);
            this.m_vo = GameConfigManager.Instance.LeveCfVo.getData(Global.checkPoint.toString());
            if (new GetIsSuperComd().isSuper == false)
                Global.checkPoint++;
        }
        shareBtnClick() {
            window["sdkmgr"].openReward(() => {
                new OpenModule(ModuleEnume.LUCKUI).execute();
                new CloseModule(ModuleEnume.FINISHUI, true).execute();
                let _glod = new AssetsUIGetGoldComd().gold + this.m_vo.gold * 2 + new BattleUIGetGoldComd().gold;
                let _diamond = new AssetsUIGetDiamondComd().diamond + this.m_vo.diamond * 2;
                new AssetsUISetGoldComd(_glod).execute();
                new AssetsUISetDiamondComd(_diamond).execute();
                TimeUtil.saveCurTime();
            });
        }
        onOkBtnClick() {
            new OpenModule(ModuleEnume.LUCKUI).execute();
            new CloseModule(ModuleEnume.FINISHUI, true).execute();
            let _glod = new AssetsUIGetGoldComd().gold + this.m_vo.gold + new BattleUIGetGoldComd().gold;
            let _diamond = new AssetsUIGetDiamondComd().diamond + this.m_vo.diamond;
            new AssetsUISetGoldComd(_glod).execute();
            new AssetsUISetDiamondComd(_diamond).execute();
        }
        IView() { }
        openView() {
            if (window['myPlatform'] == ChannelID.OPPO) {
                if (Globall.nativeCount < 5) {
                    window["sdk"].openNative(this.m_view.nNative.displayObject, 0);
                }
                else if (Globall.bannerCount < 5) {
                    window["sdk"].openBanner();
                }
            }
            else {
                window["sdkmgr"].openNative(this.m_view.contentPane.displayObject, 1, null, true);
            }
        }
        update() {
            this.m_view.goldText.text = (this.m_vo.gold + new BattleUIGetGoldComd().gold).toFixed(0);
            this.m_view.diamondText.text = this.m_vo.diamond.toString();
        }
        closeView() {
            window["sdk"].hideBanner();
            new RoleUISelectRoleVoComd(new RoleUIGetSelectRoleVoComd().roleVo).execute();
            new NavigationUITrialComd().execute();
            EventManager.inst.Emit(EventManager.LOADSCENE, Global.checkPoint);
        }
        destroyView() {
        }
        backView() {
        }
    }

    class FinishUI extends BaseWindow {
        constructor() {
            super();
            this.m_EUIDepth = EUIDepth.uiTop;
            this.m_Iview = new FinishUIView(this);
        }
        IUI() {
            this.contentPane = fgui.UIPackage.createObject("FinishUI", "Main").asCom;
            this.okBtn = this.contentPane.getChild("okBtn").asButton;
            this.goldText = this.contentPane.getChild("goldText").asTextField;
            this.diamondText = this.contentPane.getChild("diamondText").asTextField;
            this.doublebtn = this.contentPane.getChild("doubel").asButton;
            this.nNative = this.contentPane.getChild("n14").asCom;
            var videoicon = this.contentPane.getChild('n13').asCom;
            videoicon.visible = Globall.isShowVideo == 1;
        }
        openUI() {
            new CloseModule(ModuleEnume.BATTLEUI, true).execute();
        }
        closeUI() {
        }
        disposeUI() {
        }
        backUI() {
        }
    }

    class OfflineUIModel {
        constructor() {
            this.isUpdate = false;
        }
        IModel() { }
    }

    class OfflineUIProxy extends Proxy {
        constructor() {
            super();
            this.setModelID = OfflineUIModel;
            this.registered();
        }
        get model() {
            return this.getModel;
        }
    }

    class OfflineUIComd extends OfflineUIProxy {
        constructor(_minute) {
            super();
            this.model.minute = _minute;
            this.model.gold = (this.model.minute * 2);
            this.model.isUpdate = true;
        }
        execute() {
            this.refresh();
        }
        ICommand() { }
    }

    class BattleUIGetMaxScoreComd extends BattleUIProxy {
        constructor() {
            super();
            this.maxScore = this.model.maxScore;
        }
        execute() {
        }
        ICommand() { }
    }

    class LayerManager {
        constructor() {
            this.laya3DLayer = new Laya.Sprite();
            this.laya3DUILayer = new Laya.Sprite();
            this.layaUILayer = new Laya.Sprite();
            this.layaTopLayer = new Laya.Sprite();
            if (LayerManager.m_instance != null) {
                console.error("This class is a single class !!!!!!!!!  new LayerManager()  ?????");
                return;
            }
            LayerManager.m_instance = this;
            this.init();
        }
        static get Instance() {
            if (LayerManager.m_instance == null)
                LayerManager.m_instance = new LayerManager();
            return LayerManager.m_instance;
        }
        init() {
            Laya.stage.addChild(LayerManager.Instance.laya3DLayer);
            Laya.stage.addChild(LayerManager.Instance.laya3DUILayer);
            Laya.stage.addChild(LayerManager.Instance.layaUILayer);
            Laya.stage.addChild(LayerManager.Instance.layaTopLayer);
        }
    }
    LayerManager.m_instance = null;

    class Scene3DUI {
        static start() {
            Scene3DUI.IsStart = true;
            Scene3DUI.m_Scene3D = new Laya.Scene3D();
            let x = Laya.stage.width / 2 * Laya.stage.clientScaleX;
            let y = Laya.stage.height / 2 * Laya.stage.clientScaleY;
            Scene3DUI.pos = new Laya.Vector3(x, y, 0);
            LayerManager.Instance.layaTopLayer.addChild(Scene3DUI.m_Scene3D);
            var camera = Scene3DUI.m_camera = new Laya.Camera(0, 0.1, 1000);
            Scene3DUI.m_Scene3D.addChild(camera);
            camera.transform.translate(new Laya.Vector3(5, -10, 1));
            camera.orthographic = true;
            camera.orthographicVerticalSize = 10;
            camera.clearFlag = Laya.BaseCamera.CLEARFLAG_DEPTHONLY;
            var directionLight = new Laya.DirectionLight();
            Scene3DUI.m_Scene3D.addChild(directionLight);
        }
        static LoadModel(vo) {
            if (Scene3DUI.IsStart == false)
                Scene3DUI.start();
            var id = vo.modelID;
            var r = id + '';
            if (id < 10) {
                r = '0' + r;
            }
            Laya.Sprite3D.load(Global.localSven3DAssetsPreload + '/LayaScene_Man/Conventional/body_mod_' + r + '.lh', Laya.Handler.create(this, function (layaMonkey) {
                layaMonkey = Laya.Sprite3D.instantiate(layaMonkey);
                Scene3DUI.destroyModel();
                Scene3DUI.m_model = layaMonkey;
                Scene3DUI.m_Scene3D.addChild(layaMonkey);
                let animator = layaMonkey.getComponent(Laya.Animator);
                animator.play('body_dance_01');
                layaMonkey.transform.localScale = new Laya.Vector3(0.8, 0.8, 0.8);
                Scene3DUI.m_camera.convertScreenCoordToOrthographicCoord(Scene3DUI.pos, Scene3DUI._translate);
                Scene3DUI._translate = new Laya.Vector3(5, -10, -1);
                layaMonkey.transform.position = Scene3DUI._translate;
                Scene3DUI.m_camera.active = Scene3DUI.m_visible;
                Scene3DUI.m_Scene3D.visible = Scene3DUI.m_visible;
            }));
        }
        static destroyModel() {
            if (Scene3DUI.m_model) {
                Scene3DUI.m_Scene3D.removeChild(Scene3DUI.m_model);
                Scene3DUI.m_model.destroy(true);
                Laya.Resource.destroyUnusedResources();
                Scene3DUI.m_model = null;
            }
        }
        static show() {
            Scene3DUI.m_visible = true;
            if (Scene3DUI.IsStart == false) {
                Scene3DUI.start();
            }
            Scene3DUI.m_camera.active = Scene3DUI.m_visible;
            Scene3DUI.m_Scene3D.visible = Scene3DUI.m_visible;
        }
        static hide() {
            Scene3DUI.m_visible = false;
            if (Scene3DUI.m_camera)
                Scene3DUI.m_camera.active = Scene3DUI.m_visible;
            if (Scene3DUI.m_Scene3D)
                Scene3DUI.m_Scene3D.visible = Scene3DUI.m_visible;
        }
    }
    Scene3DUI.m_visible = true;
    Scene3DUI.pos = new Laya.Vector3(570, 1170, 0);
    Scene3DUI.IsStart = false;
    Scene3DUI._translate = new Laya.Vector3(0, 0, 0);
    Scene3DUI.m_model = null;

    class MainUIView extends MainUIProxy {
        constructor(_view) {
            super();
            this.m_view = _view;
            this.m_view.settingBtn.onClick(this, this.settingBtnClick);
            this.m_view.gameStartBtn.onClick(this, this.onGameStartBtnClick);
            this.m_view.btnCom1.onClick(this, this.onBtnCom1Cick);
            this.m_view.btnCom2.onClick(this, this.onBtnCom2Cick);
            this.m_view.btnCom3.onClick(this, this.onBtnCom3Cick);
            this.m_view.btnCom1.getController('c1').selectedIndex = 1;
            let _nowdate = new Date().getTime();
            let _timer = _nowdate - this.model.LoginDate;
            if (_timer > 6000) {
                let _minute = Math.round(_timer / 60000);
                new OfflineUIComd(_minute).execute();
                new OpenModule(ModuleEnume.OFFLINEUI).execute();
                this.model.LoginDate = _nowdate;
            }
        }
        reportAdClick() {
            console.log("数据上报");
        }
        onBtnCom1Cick() {
            if (this.m_view.btnCom1.getController('c1').selectedIndex == 1) {
                new TipsUIComd("当前已是闯关模式").execute();
                return;
            }
            EventManager.inst.Emit(EventManager.LOADSCENE, Global.checkPoint);
            Scene3DUI.hide();
            this.m_view.ct1.selectedIndex = 0;
            this.m_view.btnCom2.getController('c1').selectedIndex = 0;
            this.m_view.btnCom1.getController('c1').selectedIndex = 1;
            this.model.isSuper = false;
        }
        onBtnCom2Cick() {
            if (Global.checkPoint < 10)
                new TipsUIComd("完成闯关模式第10关解锁").execute();
            else {
                EventManager.inst.Emit(EventManager.LOADSCENE, 0);
                this.m_view.ct1.selectedIndex = 1;
                this.m_view.btnCom2.getController('c1').selectedIndex = 1;
                this.m_view.btnCom1.getController('c1').selectedIndex = 0;
                this.model.isSuper = true;
            }
        }
        onBtnCom3Cick() {
            if (this.m_view.btnCom2.getController('c1').selectedIndex == 0) {
                return;
            }
        }
        onGameStartBtnClick() {
            EventManager.inst.Emit(EventManager.PLAY);
            new CloseModule(ModuleEnume.NAVIGATIONUI).execute();
            new OpenModule(ModuleEnume.BATTLEUI).execute();
            Globall.isGamed = true;
            window["sdkmgr"].openNative(Laya.stage, 1, null, true, false);
        }
        settingBtnClick() {
            new OpenModule(ModuleEnume.SETTINGSUI).execute();
        }
        IView() { }
        openView() {
            this.m_view.btnCom1.getController('c1').selectedIndex = 1;
            this.m_view.btnCom2.getController('c1').selectedIndex = 0;
            this.m_view.ct1.selectedIndex = 0;
            this.model.isSuper = false;
            let _nowdate = new Date().getTime();
            let _timer = _nowdate - this.model.LoginDate;
            if (_timer > 300000) {
                let _minute = Math.round(_timer / 60000);
                new OfflineUIComd(_minute).execute();
                new OpenModule(ModuleEnume.OFFLINEUI).execute();
                this.model.LoginDate = _nowdate;
            }
            this.m_view.maxScoreText.text = new BattleUIGetMaxScoreComd().maxScore.toFixed(0);
            window["sdk"].hideBanner();
            window["sdkmgr"].openNative(Laya.stage, 1, null, true, false);
        }
        update() {
            let _checkPoint = Global.checkPoint;
            this.m_view.titleText.text = GameConfigManager.Instance.LeveCfVo.getData(_checkPoint.toString()).name;
            let _index = Global.checkPoint % 5;
            if (_index == 0)
                _index = 5;
            let ct1 = this.m_view.checkpointCom.getController("c1");
            ct1.selectedIndex = _index;
            for (let i = 1; i < 6; i++) {
                let _com = this.m_view.checkpointCom.getChild('n' + i).asCom;
                let _ct1 = _com.getController('c1');
                let _text = _com.getChild('n35').asTextField;
                if (_index == i) {
                    _ct1.selectedIndex = 2;
                }
                if (_index > i) {
                    _ct1.selectedIndex = 1;
                }
                if (_index < i) {
                    _ct1.selectedIndex = 0;
                }
                let _checkPointString = (_checkPoint + (i - _index)).toString();
                _text.text = _checkPointString;
            }
        }
        closeView() {
        }
        destroyView() {
        }
        backView() {
        }
        changeGameIcon() {
            this.m_view.otherGame;
        }
    }

    class MainUI extends BaseWindow {
        constructor() {
            super();
            this.m_Iview = new MainUIView(this);
        }
        IUI() {
            this.contentPane = fgui.UIPackage.createObject("MainUI", "Main").asCom;
            this.gameStartBtn = this.contentPane.getChild('GameStartBtn').asButton;
            this.settingBtn = this.contentPane.getChild('settingBtn').asCom;
            this.settingBtn.visible = false;
            this.btnCom1 = this.contentPane.getChild('n34').asCom;
            this.btnCom2 = this.contentPane.getChild('n35').asCom;
            this.btnCom3 = this.contentPane.getChild('n36').asCom;
            this.btnCom2.onClick(this, this.btnCom2Click);
            this.btnCom3.onClick(this, this.btnCom3Click);
            this.titleText = this.contentPane.getChild('titleText').asTextField;
            this.checkpointCom = this.contentPane.getChild('n27').asCom;
            this.maxScoreText = this.contentPane.getChild('n33').asCom.getChild('n36').asTextField;
            this.ct1 = this.contentPane.getController('c1');
            var n39 = this.contentPane.getChild('n39').asCom;
            if (Laya.Browser.window.tt) {
                n39.visible = true;
                this.otherGame = n39.getChild("other").asImage;
                this.otherLabel = n39.getChild("label").asTextField;
            }
            else {
                n39.visible = false;
            }
            this.btnCom3.visible = false;
            this.nNative = this.contentPane.getChild("n41").asCom;
        }
        btnCom2Click() {
        }
        btnCom3Click() {
            new TipsUIComd("暂未开放，敬请期待").execute();
        }
        openUI() {
            new OpenModule(ModuleEnume.ASSETSUI).execute();
            new CloseModule(ModuleEnume.GAMEUI, true).execute();
        }
        closeUI() {
        }
        disposeUI() {
        }
        backUI() {
        }
    }

    class SkinsUIModel {
        constructor() {
            this.itemArr = [];
            this.itemArrLock = [];
            this.m_selectSkins = 'trex1';
            LocalStorage.setItem("trex1_Lock", '1');
            let _selectSkins = LocalStorage.getItem('selectSkins');
            if (_selectSkins && _selectSkins != 'null')
                this.m_selectSkins = _selectSkins;
            else {
                _selectSkins = 'trex1';
                LocalStorage.setItem("selectSkins", _selectSkins);
            }
            this.update();
        }
        IModel() { }
        update() {
            this.itemArr = [];
            this.itemArrLock = [];
            for (let i = 1; i < 16; i++) {
                let _name = "trex" + i;
                let _url = fgui.UIPackage.getItemURL("SkinsUI", _name);
                let _Object = new Object();
                _Object['name'] = _name;
                _Object['url'] = _url;
                _Object['select'] = false;
                let _lock = LocalStorage.getItem(_name + '_Lock');
                let _isLock = true;
                if (_lock && _lock == '1')
                    _isLock = false;
                _Object['Lock'] = _isLock;
                if (_isLock == true) {
                    this.itemArrLock.push(_Object);
                }
                if (this.m_selectSkins == _name)
                    _Object['select'] = true;
                this.itemArr.push(_Object);
                this.m_openMoney = 500 + 100 * (this.itemArr.length - this.itemArrLock.length);
            }
        }
        get selectSkins() {
            return this.m_selectSkins;
        }
        set selectSkins(string) {
            this.m_selectSkins = string;
            LocalStorage.setItem('selectSkins', this.m_selectSkins);
            EventManager.inst.Emit(EventManager.ChageSkinsName, this.m_selectSkins);
            this.update();
        }
        get openMoney() {
            return this.m_openMoney;
        }
        set openMoney(_money) {
            this.m_openMoney = _money;
        }
        Unlock(name) {
            LocalStorage.setItem(name + "_Lock", '1');
            this.update();
        }
    }

    class SkinsUIProxy extends Proxy {
        constructor() {
            super();
            this.setModelID = SkinsUIModel;
            this.registered();
        }
        get model() {
            return this.getModel;
        }
    }

    var Handler$2 = Laya.Handler;
    class SkinsUIView extends SkinsUIProxy {
        constructor(_view) {
            super();
            this.m_openName = null;
            this.m_view = _view;
            this.m_view.closeBtn.onClick(this, this.onCloseBtnClick);
            this.m_view.itemlist.itemRenderer = Handler$2.create(this, this.renderListItem, null, false);
            this.m_view.itemlist.on(fgui.Events.CLICK_ITEM, this, this.onClickItem);
            this.m_view.itemlist.numItems = this.model.itemArr.length;
            this.m_view.moneyBtn.onClick(this, this.onMoneyBtnClick);
            this.m_view.advertisementBtn.onClick(this, this.onAdvertisementBtnClick);
            this.m_view.mainChildCT.on(fgui.Events.STATE_CHANGED, this, this.onChangedMainChildCT);
            this.m_view.useBtn.onClick(this, this.onUseBtnClick);
            this.m_view.okBtn.onClick(this, this.onOkBtnClick);
        }
        onOkBtnClick() {
            this.m_view.mainCT.selectedIndex = 0;
            this.m_view.mainChildCT.selectedIndex = 0;
            this.m_view.eggComCT.selectedIndex = 0;
            this.m_view.itemlist.numItems = this.model.itemArr.length - 1;
            this.m_view.itemlist.numItems = this.model.itemArr.length;
        }
        onUseBtnClick() {
            this.m_view.mainCT.selectedIndex = 0;
            this.m_view.mainChildCT.selectedIndex = 0;
            this.m_view.eggComCT.selectedIndex = 0;
            this.model.selectSkins = this.m_openName;
            this.m_view.itemlist.numItems = this.model.itemArr.length - 1;
            this.m_view.itemlist.numItems = this.model.itemArr.length;
        }
        onMoneyBtnClick() {
            let moneyAll = new GetMoneyComd().moneyAll;
            if (moneyAll < this.model.openMoney || this.model.itemArrLock.length == 0)
                return;
            moneyAll -= this.model.openMoney;
            new SetMoneyComd(moneyAll).execute();
            this.PlayAnimation();
        }
        onAdvertisementBtnClick() {
            this.PlayAnimation();
        }
        PlayAnimation() {
            if (this.model.itemArrLock.length == 0)
                return;
            let index = Math.floor((Math.random() * (this.model.itemArrLock.length - 1)));
            let _data = this.model.itemArrLock[index];
            let _name = this.m_openName = _data['name'];
            this.model.Unlock(_name);
            let _url = fgui.UIPackage.getItemURL("SkinsUI", this.m_openName);
            this.m_view.eggGloader.url = _url;
            this.m_view.mainCT.selectedIndex = 1;
        }
        onChangedMainChildCT() {
            if (this.m_view.mainChildCT.selectedIndex == 1) {
                Laya.timer.once(1000, this, this.PlayAnimation2);
            }
        }
        PlayAnimation2() {
            this.m_view.eggComCT.selectedIndex = 1;
            Laya.timer.once(3000, this, this.PlayAnimation3);
        }
        PlayAnimation3() {
            this.m_view.mainChildCT.selectedIndex = 2;
        }
        renderListItem(index, com) {
            let _data = this.model.itemArr[index];
            com.name = index.toString();
            com.getChild("n6").asLoader.url = _data["url"];
            let _ct = com.getChild("n8").asCom.getController('c1');
            if (_data['Lock']) {
                _ct.setSelectedIndex(2);
            }
            else {
                if (_data['select']) {
                    _ct.setSelectedIndex(0);
                    this.m_ct = _ct;
                }
                else {
                    _ct.setSelectedIndex(1);
                }
            }
        }
        onClickItem(object) {
            let _index = Number(object.name);
            let _data = this.model.itemArr[_index];
            if (_data['Lock'])
                return;
            let _com = object;
            let _ct = _com.getChild("n8").asCom.getController('c1');
            this.m_ct.setSelectedIndex(1);
            _ct.setSelectedIndex(0);
            this.m_ct = _ct;
            this.model.selectSkins = this.m_openName = _data["name"];
        }
        onCloseBtnClick() {
            new CloseModule(ModuleEnume.SKINSUI, true).execute();
        }
        IView() { }
        openView() {
        }
        update() {
            this.m_view.moneyBtn.getChild('n14').asTextField.text = this.model.openMoney.toString();
        }
        closeView() {
        }
        destroyView() {
        }
        backView() {
        }
    }

    class SkinsUI extends BaseWindow {
        constructor() {
            super();
            this.m_Iview = new SkinsUIView(this);
        }
        IUI() {
            this.contentPane = fgui.UIPackage.createObject("SkinsUI", "Main").asCom;
            this.closeBtn = this.contentPane.getChild("closeBtn").asCom;
            this.itemlist = this.contentPane.getChild('n2').asList;
            this.moneyBtn = this.contentPane.getChild("n12").asCom;
            this.advertisementBtn = this.contentPane.getChild("n9").asCom;
            this.mainCT = this.contentPane.getController('c1');
            this.mainChildCT = this.contentPane.getChild('n14').asCom.getController('c1');
            this.useBtn = this.contentPane.getChild('n14').asCom.getChild("useBtn").asCom;
            this.okBtn = this.contentPane.getChild('n14').asCom.getChild("okBtn").asCom;
            let _eggCom = this.contentPane.getChild('n14').asCom.getChild("n19").asCom;
            this.eggGloader = _eggCom.getChild('n23').asLoader;
            this.eggComCT = _eggCom.getController("c1");
        }
        openUI() {
        }
        closeUI() {
        }
        disposeUI() {
        }
        backUI() {
        }
    }

    class AssetsUIView extends AssetsUIProxy {
        constructor(_view) {
            super();
            this.m_view = _view;
            this.m_view.addGoldBut.onClick(this, this.AssetsUIClick);
        }
        AssetsUIClick() {
            window["sdkmgr"].openReward(() => {
                this.model.gold += 1000;
                this.model.diamond += 100;
                this.update();
                TimeUtil.saveCurTime();
            });
        }
        IView() { }
        openView() {
        }
        update() {
            this.m_view.goldText.text = this.model.gold.toFixed(0);
            this.m_view.diamondText.text = this.model.diamond.toFixed(0);
        }
        closeView() {
        }
        destroyView() {
        }
        backView() {
        }
    }

    class AssetsUI extends BaseWindow {
        constructor() {
            super();
            this.m_EUIDepth = EUIDepth.uiTop;
            this.m_Iview = new AssetsUIView(this);
        }
        IUI() {
            this.contentPane = fgui.UIPackage.createObject("AssetsUI", "Main").asCom;
            let _com = this.contentPane.getChild("n0").asCom;
            this.addGoldBut = this.contentPane.getChild("n5").asCom;
            this.diamondText = _com.getChild('diamondText').asTextField;
            this.goldText = _com.getChild('goldText').asTextField;
            var videoicon = this.addGoldBut.getChild('n2').asCom;
            videoicon.visible = Globall.isShowVideo == 1;
        }
        openUI() {
        }
        closeUI() {
        }
        disposeUI() {
        }
        backUI() {
        }
    }

    class TaskUIView extends TaskUIProxy {
        constructor(_view) {
            super();
            this.m_view = _view;
        }
        TaskUIClick() {
        }
        IView() { }
        openView() {
            window["sdkmgr"].openNative(Laya.stage, 1, null, true, false);
        }
        getSignNext() {
            for (let i = 0; i < 7; i++) {
                let _boole = this.model.dayReceiveArr[i];
                if (!_boole) {
                    return i;
                }
            }
        }
        update() {
            let _comP = this.m_view.taskCom;
            if (!LocalStorage.isSign()) {
                let i = this.getSignNext();
                if (!i) {
                    for (let i = 0; i < 7; i++) {
                        this.model.loginDayArr[i] = false;
                        this.model.dayReceiveArr[i] = false;
                    }
                    i = 0;
                    LocalStorage.setJSON('dayReceiveArr', this.model.dayReceiveArr);
                }
                this.model.loginDayArr[i] = true;
            }
            for (let i = 0; i < 7; i++) {
                let _com = _comP.getChild(i.toString()).asCom;
                let _ct1 = _com.getController('c1');
                let _ct2 = _com.getController('c2');
                _ct1.selectedIndex = i;
                let _boole;
                _boole = this.model.loginDayArr[i];
                if (_boole)
                    _ct2.selectedIndex = 1;
                _boole = this.model.dayReceiveArr[i];
                if (_boole)
                    _ct2.selectedIndex = 2;
                _com.getChild("n30").asCom;
                _com.getChild("n30").asCom.onClick(this, this.onReceiveClick, [_ct2, Number(_com.name)]);
            }
            this.m_view.n1_Item1.setValue(this.model.everydayGold);
            this.m_view.n1_Item3.setValue(this.model.everydayGold);
            this.m_view.n1_Item2.setValue(this.model.everydayDiamond);
            this.m_view.n2_Item1.setValue(Global.checkPoint - 1);
            this.m_view.n2_Item2.setValue(this.model.overComplet);
            this.m_view.n2_Item3.setValue(this.model.flyingObject);
            this.m_view.n2_Item4.setValue(this.model.hitBomb);
        }
        onReceiveClick(e, _index) {
            e.selectedIndex = 2;
            LocalStorage.setCurrentData();
            this.model.setDayReceiveArrItem(_index);
        }
        closeView() {
        }
        destroyView() {
        }
        backView() {
        }
    }

    class NavigationUICT_Comd extends NavigationUIProxy {
        constructor() {
            super();
            this.model.setCT_index = true;
        }
        ICommand() { }
        execute() {
            this.refresh();
        }
    }

    class AssetsUIAddDiamondComd extends AssetsUIProxy {
        constructor(_diamond) {
            super();
            this.model.diamond += _diamond;
        }
        execute() {
            this.refresh();
        }
        ICommand() { }
    }

    class TaskUIItmeCom {
        constructor(_com, index) {
            this.money = 0;
            this.maxValue = 0;
            this.value = 0;
            this.m_com = _com;
            this.name = _com.name;
            this.index = index;
            this.init();
        }
        init() {
            this.describeTxt = this.m_com.getChild('describeTxt').asTextField;
            this.progressTxt = this.m_com.getChild('progressTxt').asTextField;
            this.moneyTxt = this.m_com.getChild('moneyTxt').asTextField;
            this.m_com.getChild('n22').asCom.onClick(this, this.onGoTo);
            this.m_com.getChild('n28').asCom.onClick(this, this.onReceive);
            this.m_ct = this.m_com.getController("c1");
            this.initData();
        }
        initData() {
            let bool;
            if (this.index == 1) {
                this.maxValue = 1500;
                this.setDescribe('消费1500金币');
                this.setMoney(1000);
                bool = LocalStorage.getItem('每日任务1领取');
            }
            if (this.index == 2) {
                this.maxValue = 50;
                this.setDescribe('消费50钻石');
                this.setMoney(30);
                bool = LocalStorage.getItem('每日任务2领取');
            }
            if (this.index == 3) {
                this.maxValue = 3000;
                this.setDescribe('消费3000金币');
                this.setMoney(1500);
                bool = LocalStorage.getItem('每日任务3领取');
            }
            if (bool == 'true') {
                this.m_ct.selectedIndex = 2;
            }
            else {
                this.m_ct.selectedIndex = 0;
            }
        }
        onGoTo() {
            new NavigationUICT_Comd().execute();
        }
        onReceive() {
            this.m_ct.selectedIndex = 2;
            if (this.index == 1) {
                LocalStorage.setItem('每日任务1领取', 'true');
                new AssetsUIAddGoldComd(this.money).execute();
            }
            if (this.index == 2) {
                LocalStorage.setItem('每日任务2领取', 'true');
                new AssetsUIAddDiamondComd(this.money).execute();
            }
            if (this.index == 3) {
                LocalStorage.setItem('每日任务3领取', 'true');
                new AssetsUIAddGoldComd(this.money).execute();
            }
        }
        setMoney(_money) {
            this.money = _money;
            this.updeta();
        }
        setMaxValue(maxValue) {
            this.maxValue = maxValue;
            this.updeta();
        }
        setValue(value) {
            this.value = value;
            this.updeta();
        }
        setDescribe(describe) {
            this.describe = describe;
            this.updeta();
        }
        updeta() {
            if (this.value >= this.maxValue && this.m_ct.selectedIndex == 0) {
                this.m_ct.selectedIndex = 1;
            }
            this.describeTxt.text = this.describe;
            this.progressTxt.text = this.value + '/' + this.maxValue;
            this.moneyTxt.text = this.money.toString();
        }
    }

    class TaskUIItmeACHVCom1 {
        constructor(_com, index) {
            this.m_id = 'TaskUIItmeACHVCom1';
            this.m_describe1 = '完成第';
            this.m_describe2 = '关';
            this.m_maxValueIncrease = 2;
            this.m_glod = 20;
            this.m_maxValue = 0;
            this.money = 0;
            this.value = 0;
            this.m_com = _com;
            this.name = _com.name;
            this.index = index;
            this.init();
        }
        init() {
            this.describeTxt = this.m_com.getChild('describeTxt').asTextField;
            this.progressTxt = this.m_com.getChild('progressTxt').asTextField;
            this.moneyTxt = this.m_com.getChild('moneyTxt').asTextField;
            this.m_com.getChild('n22').asCom.onClick(this, this.onGoTo);
            this.m_com.getChild('n28').asCom.onClick(this, this.onReceive);
            this.m_ct = this.m_com.getController("c1");
            this.initData();
        }
        initData() {
            let value = LocalStorage.getJSON(this.m_id + '_data');
            if (!value)
                value = this.m_maxValueIncrease;
            this.maxValue = value;
            this.setMoney(this.m_glod);
        }
        set maxValue(maxValue) {
            this.m_maxValue = maxValue;
            LocalStorage.setJSON(this.m_id + '_data', maxValue);
            this.updeta();
        }
        onGoTo() {
            new NavigationUICT_Comd().execute();
        }
        onReceive() {
            new AssetsUIAddGoldComd(this.money).execute();
            this.maxValue = this.m_maxValue + this.m_maxValueIncrease;
            this.updeta();
        }
        setMoney(_money) {
            this.money = _money;
            this.updeta();
        }
        setValue(value) {
            this.value = value;
            this.updeta();
        }
        updeta() {
            if (this.value >= this.m_maxValue) {
                this.m_ct.selectedIndex = 1;
            }
            else {
                this.m_ct.selectedIndex = 0;
            }
            this.describeTxt.text = this.m_describe1 + this.m_maxValue + this.m_describe2;
            this.progressTxt.text = this.value + '/' + this.m_maxValue;
            this.moneyTxt.text = this.money.toString();
        }
    }

    class TaskUIItmeACHVCom3 {
        constructor(_com, index) {
            this.m_id = 'TaskUIItmeACHVCom3';
            this.m_describe1 = '击飞障碍物';
            this.m_describe2 = '个';
            this.m_maxValueIncrease = 1000;
            this.m_glod = 50;
            this.m_maxValue = 0;
            this.money = 0;
            this.value = 0;
            this.m_com = _com;
            this.name = _com.name;
            this.index = index;
            this.init();
        }
        init() {
            this.describeTxt = this.m_com.getChild('describeTxt').asTextField;
            this.progressTxt = this.m_com.getChild('progressTxt').asTextField;
            this.moneyTxt = this.m_com.getChild('moneyTxt').asTextField;
            this.m_com.getChild('n22').asCom.onClick(this, this.onGoTo);
            this.m_com.getChild('n28').asCom.onClick(this, this.onReceive);
            this.m_ct = this.m_com.getController("c1");
            this.initData();
        }
        initData() {
            let value = LocalStorage.getJSON(this.m_id + '_data');
            if (!value)
                value = this.m_maxValueIncrease;
            this.maxValue = value;
        }
        set maxValue(maxValue) {
            this.m_maxValue = maxValue;
            this.setMoney(this.m_glod);
            LocalStorage.setJSON(this.m_id + '_data', maxValue);
            this.updeta();
        }
        onGoTo() {
            new NavigationUICT_Comd().execute();
        }
        onReceive() {
            new AssetsUIAddGoldComd(this.money).execute();
            this.maxValue = this.m_maxValue + this.m_maxValueIncrease;
            this.updeta();
        }
        setMoney(_money) {
            this.money = _money;
            this.updeta();
        }
        setValue(value) {
            this.value = value;
            this.updeta();
        }
        updeta() {
            if (this.value >= this.m_maxValue) {
                this.m_ct.selectedIndex = 1;
            }
            else {
                this.m_ct.selectedIndex = 0;
            }
            this.describeTxt.text = this.m_describe1 + this.m_maxValue + this.m_describe2;
            this.progressTxt.text = this.value + '/' + this.m_maxValue;
            this.moneyTxt.text = this.money.toString();
        }
    }

    class TaskUIItmeACHVCom4 {
        constructor(_com, index) {
            this.m_id = 'TaskUIItmeACHVCom4';
            this.m_describe1 = '引爆炸弹';
            this.m_describe2 = '个';
            this.m_maxValueIncrease = 1000;
            this.m_glod = 30;
            this.m_maxValue = 0;
            this.money = 0;
            this.value = 0;
            this.m_com = _com;
            this.name = _com.name;
            this.index = index;
            this.init();
        }
        init() {
            this.describeTxt = this.m_com.getChild('describeTxt').asTextField;
            this.progressTxt = this.m_com.getChild('progressTxt').asTextField;
            this.moneyTxt = this.m_com.getChild('moneyTxt').asTextField;
            this.m_com.getChild('n22').asCom.onClick(this, this.onGoTo);
            this.m_com.getChild('n28').asCom.onClick(this, this.onReceive);
            this.m_ct = this.m_com.getController("c1");
            this.initData();
        }
        initData() {
            let value = LocalStorage.getJSON(this.m_id + '_data');
            if (!value)
                value = this.m_maxValueIncrease;
            this.maxValue = value;
        }
        set maxValue(maxValue) {
            this.m_maxValue = maxValue;
            this.setMoney(this.m_glod);
            LocalStorage.setJSON(this.m_id + '_data', maxValue);
            this.updeta();
        }
        onGoTo() {
            new NavigationUICT_Comd().execute();
        }
        onReceive() {
            new AssetsUIAddGoldComd(this.money).execute();
            this.maxValue = this.m_maxValue + this.m_maxValueIncrease;
            this.updeta();
        }
        setMoney(_money) {
            this.money = _money;
            this.updeta();
        }
        setValue(value) {
            this.value = value;
            this.updeta();
        }
        updeta() {
            if (this.value >= this.m_maxValue) {
                this.m_ct.selectedIndex = 1;
            }
            else {
                this.m_ct.selectedIndex = 0;
            }
            this.describeTxt.text = this.m_describe1 + this.m_maxValue + this.m_describe2;
            this.progressTxt.text = this.value + '/' + this.m_maxValue;
            this.moneyTxt.text = this.money.toString();
        }
    }

    class TaskUIItmeACHVCom2 {
        constructor(_com, index) {
            this.m_id = 'TaskUIItmeACHVCom2';
            this.m_describe1 = '失败';
            this.m_describe2 = '次';
            this.m_maxValueIncrease = 10;
            this.m_glod = 40;
            this.m_maxValue = 0;
            this.money = 0;
            this.value = 0;
            this.m_com = _com;
            this.name = _com.name;
            this.index = index;
            this.init();
        }
        init() {
            this.describeTxt = this.m_com.getChild('describeTxt').asTextField;
            this.progressTxt = this.m_com.getChild('progressTxt').asTextField;
            this.moneyTxt = this.m_com.getChild('moneyTxt').asTextField;
            this.m_com.getChild('n22').asCom.onClick(this, this.onGoTo);
            this.m_com.getChild('n28').asCom.onClick(this, this.onReceive);
            this.m_ct = this.m_com.getController("c1");
            this.initData();
        }
        initData() {
            let value = LocalStorage.getJSON(this.m_id + '_data');
            if (!value)
                value = this.m_maxValueIncrease;
            this.maxValue = value;
        }
        set maxValue(maxValue) {
            this.m_maxValue = maxValue;
            this.setMoney(this.m_glod);
            LocalStorage.setJSON(this.m_id + '_data', maxValue);
            this.updeta();
        }
        onGoTo() {
            new NavigationUICT_Comd().execute();
        }
        onReceive() {
            new AssetsUIAddGoldComd(this.money).execute();
            this.maxValue = this.m_maxValue + this.m_maxValueIncrease;
            this.updeta();
        }
        setMoney(_money) {
            this.money = _money;
            this.updeta();
        }
        setValue(value) {
            this.value = value;
            this.updeta();
        }
        updeta() {
            if (this.value >= this.m_maxValue) {
                this.m_ct.selectedIndex = 1;
            }
            else {
                this.m_ct.selectedIndex = 0;
            }
            this.describeTxt.text = this.m_describe1 + this.m_maxValue + this.m_describe2;
            this.progressTxt.text = this.value + '/' + this.m_maxValue;
            this.moneyTxt.text = this.money.toString();
        }
    }

    class TaskUI extends BaseWindow {
        constructor() {
            super();
            this.m_Iview = new TaskUIView(this);
        }
        IUI() {
            this.contentPane = fgui.UIPackage.createObject("TaskUI", "Main").asCom;
            this.taskCom = this.contentPane.getChild('n18').asCom;
            this.n1_Item1 = new TaskUIItmeCom(this.contentPane.getChild('n1_Item1').asCom, 1);
            this.n1_Item2 = new TaskUIItmeCom(this.contentPane.getChild('n1_Item2').asCom, 2);
            this.n1_Item3 = new TaskUIItmeCom(this.contentPane.getChild('n1_Item3').asCom, 3);
            this.n2_Item1 = new TaskUIItmeACHVCom1(this.contentPane.getChild('n2_Item1').asCom, 1);
            this.n2_Item2 = new TaskUIItmeACHVCom2(this.contentPane.getChild('n2_Item2').asCom, 2);
            this.n2_Item3 = new TaskUIItmeACHVCom3(this.contentPane.getChild('n2_Item3').asCom, 3);
            this.n2_Item4 = new TaskUIItmeACHVCom4(this.contentPane.getChild('n2_Item4').asCom, 4);
        }
        openUI() {
        }
        closeUI() {
        }
        disposeUI() {
        }
        backUI() {
        }
    }

    var Handler$3 = Laya.Handler;
    class RoleUIView extends RoleUIProxy {
        constructor(_view) {
            super();
            this.m_view = _view;
            this.init();
            this.m_view.roleComList.itemRenderer = Handler$3.create(this, this.renderListItem, null, false);
            this.m_view.roleComList.on(fgui.Events.CLICK_ITEM, this, this.onClickItem);
            this.m_view.roleComList.numItems = 0;
            this.m_view.roleComList.numItems = this.model.roleItemArr.length;
            this.m_view.upBtnCom.onClick(this, this.onUpBtnComClick);
        }
        onUpBtnComClick() {
            let _money = Number(this.m_view.upText.text);
            let _gold = new AssetsUIGetGoldComd().gold;
            if (_gold < _money) {
                new TipsUIComd('金币不足').execute();
                return;
            }
            new AssetsUISetGoldComd(_gold - _money).execute();
            this.model.selectShowRoleVo.roleRank++;
            new TipsUIComd('等级提升！').execute();
            this.update();
        }
        init() {
            for (let i = 0; i < this.model.roleItemArr.length; i++) {
                let _vo = this.model.roleItemArr[i];
                if (_vo.openType == '闯关') {
                    if (_vo.openValue >= Global.checkPoint) {
                        continue;
                    }
                    _vo.unlock = true;
                }
                if (_vo.openType == '复活') ;
            }
        }
        renderListItem(index, roleItem) {
            let _data = this.model.roleItemArr[index];
            roleItem.setRoleVo(_data);
        }
        onClickItem(object) {
        }
        RoleUIClick() {
        }
        IView() { }
        openView() {
            this.model.selectShowRoleVo = this.model.selectRoleVo;
            window["sdkmgr"].openNative(Laya.stage, 1, null, true, false);
        }
        update() {
            this.m_view.roleAttributePanel.setRoleVo(this.model.selectShowRoleVo);
            if (this.model.selectShowRoleVo.quality == '普通') {
                this.m_view.upText.text = '1000';
            }
            else {
                this.m_view.upText.text = '1500';
            }
            if (this.model.selectShowRoleVo.unlock) {
                this.m_view.ct2.selectedIndex = 1;
            }
            else {
                this.m_view.ct2.selectedIndex = 0;
            }
        }
        closeView() {
        }
        destroyView() {
        }
        backView() {
        }
    }

    class RoleUISelectShowRoleVoComd extends RoleUIProxy {
        constructor(_roleVo) {
            super();
            this.model.selectShowRoleVo = _roleVo;
            EventManager.inst.Emit(EventManager.RoleEvent, this.model.selectShowRoleVo);
            let describe;
            switch (_roleVo.openType) {
                case '金币':
                    describe = "花费金币" + _roleVo.openValue + "个" + ",解锁！";
                    break;
                case '钻石':
                    describe = "花费钻石" + _roleVo.openValue + "个" + ",解锁！";
                    break;
                case '闯关':
                    describe = "闯关第" + _roleVo.openValue + "关" + ",解锁！";
                    break;
                case '复活':
                    describe = "复活" + _roleVo.openValue + "次" + ",解锁！";
                    break;
                case '签到':
                    describe = "签到第" + _roleVo.openValue + "天" + ",解锁！";
                    break;
                default:
                    describe = "暂未开放，敬请期待";
                    break;
            }
            new TipsUIComd(describe).execute();
        }
        execute() {
            this.refresh();
        }
        ICommand() { }
    }

    class RoleItem extends fgui.GComponent {
        constructFromXML(xml) {
            super.constructFromXML(xml);
            this.init();
            this.m_ItmePlank.onClick(this, this.onItmePlankClick);
            this.m_masonryBtn.onClick(this, this.onMasonryBtnClick);
            this.m_glodBtn.onClick(this, this.onGlodClick);
        }
        onItmePlankClick() {
            if (this.m_vo.unlock) {
                new RoleUISelectRoleVoComd(this.m_vo).execute();
            }
            else {
                new RoleUISelectShowRoleVoComd(this.m_vo).execute();
            }
        }
        onMasonryBtnClick() {
            let _value = Number(this.m_masonryTxt.text);
            let _diamond = new AssetsUIGetDiamondComd().diamond;
            if (_diamond < _value) {
                new TipsUIComd('钻石不足').execute();
                return;
            }
            new AssetsUISetDiamondComd(_diamond - _value).execute();
            this.openUnlock();
        }
        onGlodClick() {
            let _value = Number(this.m_goldTxt.text);
            let _gold = new AssetsUIGetGoldComd().gold;
            if (_gold < _value) {
                new TipsUIComd('金币不足').execute();
                return;
            }
            new AssetsUISetGoldComd(_gold - _value).execute();
            this.openUnlock();
        }
        openUnlock() {
            this.m_vo.unlock = true;
            this.update();
        }
        init() {
            this.m_ct1 = this.getController('c1');
            this.m_loader = this.getChild("loader").asLoader;
            this.m_rankTxt = this.getChild("n8").asCom.getChild('n9').asTextField;
            this.m_goldTxt = this.getChild('goldTxt').asTextField;
            this.m_masonryTxt = this.getChild('masonryTxt').asTextField;
            this.m_ItmePlank = this.getChild('ItmePlank').asCom;
            this.m_masonryBtn = this.getChild('masonryPlank').asCom;
            this.m_glodBtn = this.getChild('glodPlank').asCom;
        }
        setRoleVo(_vo) {
            this.m_vo = _vo;
            this.update();
        }
        update() {
            let _urlNanme = 'body_pic_' + this.m_vo.modelID;
            let _url = fgui.UIPackage.getItemURL("RoleUI", _urlNanme);
            this.m_loader.url = _url;
            if (this.m_vo.modelID == -1) {
                this.m_ct1.selectedPage = '即将开放';
                return;
            }
            if (this.m_vo.unlock == false) {
                switch (this.m_vo.openType) {
                    case '金币':
                        this.m_ct1.selectedPage = '金币未解锁';
                        this.m_goldTxt.text = this.m_vo.openValue.toFixed(0);
                        break;
                    case '钻石':
                        this.m_ct1.selectedPage = '钻石未解锁';
                        this.m_masonryTxt.text = this.m_vo.openValue.toFixed(0);
                        break;
                    case '闯关':
                        this.m_ct1.selectedPage = '过关未解锁';
                        break;
                    case '复活':
                        this.m_ct1.selectedPage = '过关未解锁';
                        break;
                    case '签到':
                        this.m_ct1.selectedPage = '签到未解锁';
                        break;
                    default:
                        break;
                }
            }
            else {
                this.m_ct1.selectedPage = '解锁';
            }
        }
    }

    class RoleAttributePanel {
        constructor(_com) {
            this.m_ct = _com.getController('c1');
            this.m_nameTxt = _com.getChild('nameTxt').asTextField;
            this.m_describeTxt = _com.getChild('describeTxt').asTextField;
            this.m_RoleSkillCom1 = new RoleSkillCom(_com.getChild('j1').asCom);
            this.m_RoleSkillCom2 = new RoleSkillCom(_com.getChild('j2').asCom);
            this.m_RoleSkillCom3 = new RoleSkillCom(_com.getChild('j3').asCom);
            this.m_RoleSkillCom4 = new RoleSkillCom(_com.getChild('j4').asCom);
        }
        setRoleVo(_vo) {
            this.m_vo = _vo;
            this.update();
        }
        update() {
            this.m_ct.selectedPage = this.m_vo.quality;
            this.m_nameTxt.text = this.m_vo.name;
            this.m_describeTxt.text = this.m_vo.roleDescribe;
            this.m_RoleSkillCom1.setSkillNameTxt = "攻击距离";
            this.m_RoleSkillCom1.setskillValueTxt = (this.m_vo.atkDistance +
                this.m_vo.atkDistance * this.m_vo.roleRank * 0.01).toFixed(1);
            this.m_RoleSkillCom1.setProgress = (this.m_vo.atkDistance +
                this.m_vo.atkDistance * this.m_vo.roleRank * 0.01) / 150;
            this.m_RoleSkillCom2.setSkillNameTxt = "技能";
            this.m_RoleSkillCom2.setskillValueTxt = (this.m_vo.skillValue +
                this.m_vo.skillValue * this.m_vo.roleRank * 0.01).toFixed(1);
            this.m_RoleSkillCom2.setProgress = (this.m_vo.skillValue +
                this.m_vo.skillValue * this.m_vo.roleRank * 0.01) / 150;
            this.m_RoleSkillCom3.setSkillNameTxt = "攻击速度";
            this.m_RoleSkillCom3.setskillValueTxt = (this.m_vo.atkSpeed +
                this.m_vo.atkSpeed * this.m_vo.roleRank * 0.01).toFixed(1);
            this.m_RoleSkillCom3.setProgress = (this.m_vo.atkSpeed +
                this.m_vo.atkSpeed * this.m_vo.roleRank * 0.01) / 150;
            this.m_RoleSkillCom4.setSkillNameTxt = "机动性";
            this.m_RoleSkillCom4.setskillValueTxt = (this.m_vo.moveSpeed +
                this.m_vo.moveSpeed * this.m_vo.moveSpeed * 0.01).toFixed(1);
            this.m_RoleSkillCom4.setProgress = (this.m_vo.moveSpeed +
                this.m_vo.moveSpeed * this.m_vo.moveSpeed * 0.01) / 150;
        }
    }
    class RoleSkillCom {
        constructor(_com) {
            this.m_asProgress = _com.getChild('n14').asProgress;
            this.m_skillNameTxt = _com.getChild('n16').asTextField;
            this.m_skillValueTxt = _com.getChild('n17').asTextField;
        }
        set setProgress(value) {
            this.m_asProgress.value = value * 100;
        }
        set setSkillNameTxt(value) {
            this.m_skillNameTxt.text = value;
        }
        set setskillValueTxt(value) {
            this.m_skillValueTxt.text = value;
        }
    }

    class RoleUI extends BaseWindow {
        constructor() {
            super();
            this.m_Iview = new RoleUIView(this);
        }
        IUI() {
            fgui.UIObjectFactory.setPackageItemExtension(fgui.UIPackage.getItemURL("RoleUI", 'Component1'), RoleItem);
            this.contentPane = fgui.UIPackage.createObject("RoleUI", "Main").asCom;
            this.ct2 = this.contentPane.getController('c2');
            this.roleComList = this.contentPane.getChild('roleComList').asList;
            this.roleAttributePanel = new RoleAttributePanel(this.contentPane.getChild('n13').asCom.getChild('n13').asCom);
            this.upBtnCom = this.contentPane.getChild('n21').asCom;
            this.upText = this.upBtnCom.getChild('n24').asTextField;
        }
        openUI() {
            EventManager.inst.Emit(EventManager.RoleUIEvent, true);
        }
        closeUI() {
            EventManager.inst.Emit(EventManager.RoleUIEvent, false);
        }
        disposeUI() {
        }
        backUI() {
        }
    }

    class NavigationUIView extends NavigationUIProxy {
        constructor(_view) {
            super();
            this.m_view = _view;
            this.m_view.uiComController.on(fgui.Events.STATE_CHANGED, this, this.onChanged);
        }
        onChanged() {
            let _pageName = this.m_view.uiComController.selectedPage;
            new CloseModule(ModuleEnume.MAINUI).execute();
            new CloseModule(ModuleEnume.ROLEUI, true).execute();
            new CloseModule(ModuleEnume.TASKUI, true).execute();
            if (_pageName == '主界面') {
                new OpenModule(ModuleEnume.MAINUI).execute();
            }
            if (_pageName == '角色') {
                new OpenModule(ModuleEnume.ROLEUI).execute();
            }
            if (_pageName == '任务') {
                new OpenModule(ModuleEnume.TASKUI).execute();
            }
        }
        NavigationUIClick() {
        }
        IView() { }
        openView() {
            this.m_view.uiComController.selectedIndex = 0;
            this.m_view.uiComController.selectedPage = '主界面';
        }
        update() {
            if (this.model.setCT_index == false)
                return;
            this.model.setCT_index = false;
            this.m_view.uiComController.selectedPage = '主界面';
        }
        closeView() {
            new CloseModule(ModuleEnume.MAINUI).execute();
            new CloseModule(ModuleEnume.ASSETSUI).execute();
        }
        destroyView() {
        }
        backView() {
        }
    }

    class NavigationUI extends BaseWindow {
        constructor() {
            super();
            this.m_EUIDepth = EUIDepth.uiTop;
            this.m_Iview = new NavigationUIView(this);
        }
        IUI() {
            this.contentPane = fgui.UIPackage.createObject("NavigationUI", "Main").asCom;
            let _com = this.contentPane.getChild('n0').asCom;
            this.uiComController = _com.getController('c1');
            _com.y = Laya.stage.height - 100;
        }
        openUI() {
        }
        closeUI() {
        }
        disposeUI() {
        }
        backUI() {
        }
    }

    class GameOverUIModel {
        constructor() {
            this.m_isShake = true;
            this.m_isSound = true;
            let _isShake = LocalStorage.getItem('isShake');
            let _isSound = LocalStorage.getItem('isSound');
            if (_isShake != null)
                this.m_isShake = (_isShake != "0");
            if (_isSound != null)
                this.m_isSound = (_isSound != "0");
            this.dataUpdate();
        }
        IModel() { }
        set isShake(_bool) {
            let _string = '0';
            this.m_isShake = _bool;
            if (this.m_isSound == true)
                _string = '1';
            LocalStorage.setItem('isShake', _string);
        }
        get isShake() {
            return this.m_isShake;
        }
        set isSound(_bool) {
            let _string = '0';
            this.m_isSound = _bool;
            if (this.m_isSound == true)
                _string = '1';
            LocalStorage.setItem('isSound', _string);
            this.dataUpdate();
        }
        get isSound() {
            return this.m_isSound;
        }
        dataUpdate() {
            if (this.m_isSound)
                EventManager.inst.Emit(EventManager.SoundOn);
            else
                EventManager.inst.Emit(EventManager.SoundOff);
        }
    }

    class GameOverUIProxy extends Proxy {
        constructor() {
            super();
            this.setModelID = GameOverUIModel;
            this.registered();
        }
        get model() {
            return this.getModel;
        }
    }

    class AddoverCompleteTaskComd extends TaskUIProxy {
        constructor(_value) {
            super();
            this.model.overComplet += _value;
        }
        execute() {
        }
        ICommand() { }
    }

    class GameOverUIView extends GameOverUIProxy {
        constructor(_view) {
            super();
            this.flag = 0;
            this.m_view = _view;
            this.m_view.okBtn.onClick(this, this.onOkBtnClick);
            this.m_view.canel.onClick(this, this.onCanelClick);
        }
        onCanelClick() {
            this.flag = 1;
            EventManager.inst.Emit(EventManager.END);
            EventManager.inst.Emit(EventManager.DEAD);
            new OpenModule(ModuleEnume.LUCKUI).execute();
            new CloseModule(ModuleEnume.GameOverUI, true).execute();
            Global.proportion = 0;
            Global.levelProgress = 0;
            Global.score = 0;
            Global.gold = 0;
        }
        onOkBtnClick() {
            EventManager.inst.Emit(EventManager.MYBEGIN);
            new CloseModule(ModuleEnume.GameOverUI, true).execute();
            new OpenModule(ModuleEnume.BATTLEUI).execute();
            TimeUtil.saveCurTime();
        }
        IView() { }
        openView() {
            let _index = Math.round(Math.random());
            this.m_view.ct.selectedIndex = _index;
            if (window['myPlatform'] == ChannelID.OPPO) {
                if (Globall.nativeCount < 5) {
                    window["sdk"].openNative(this.m_view.nNative.displayObject, 1);
                }
                else if (Globall.bannerCount < 5) {
                    window["sdk"].openBanner();
                }
            }
            else {
                window["sdkmgr"].openNative(this.m_view.contentPane.displayObject, 1, null, true);
            }
        }
        update() {
        }
        closeView() {
            window["sdk"].hideBanner();
            if (this.flag) {
                new RoleUISelectRoleVoComd(new RoleUIGetSelectRoleVoComd().roleVo).execute();
                new NavigationUITrialComd().execute();
                EventManager.inst.Emit(EventManager.LOADSCENE, Global.checkPoint);
                new AddoverCompleteTaskComd(1).execute();
            }
        }
        destroyView() {
        }
        backView() {
        }
    }

    class GameOverUI extends BaseWindow {
        constructor() {
            super();
            this.m_EUIDepth = EUIDepth.uiTop;
            this.m_Iview = new GameOverUIView(this);
        }
        IUI() {
            this.contentPane = fgui.UIPackage.createObject("GameOverUI", "Main").asCom;
            this.okBtn = this.contentPane.getChild("okBtn").asButton;
            this.ct = this.contentPane.getController('c1');
            this.canel = this.contentPane.getChild("n11").asCom;
            this.nNative = this.contentPane.getChild("n16").asCom;
            var videoicon = this.contentPane.getChild('n15').asCom;
            videoicon.visible = false;
        }
        openUI() {
            new CloseModule(ModuleEnume.BATTLEUI, true).execute();
        }
        closeUI() {
        }
        disposeUI() {
        }
        backUI() {
        }
    }

    class TipsUIView extends TipsUIProxy {
        constructor(_view) {
            super();
            this.m_view = _view;
        }
        onT0callback() {
            this.m_view.ct.selectedIndex = 0;
        }
        IView() { }
        openView() {
            this.m_view.ct.selectedIndex = 0;
        }
        update() {
            if (this.model.isOpen == false)
                return;
            this.model.isOpen = false;
            this.m_view.ct.selectedIndex = 0;
            this.m_view.t1.setHook("over", Laya.Handler.create(this, this.onT0callback));
            this.m_view.tipsText.text = this.model.describe;
            this.m_view.ct.selectedIndex = 1;
        }
        closeView() {
            this.m_view.ct.selectedIndex = 0;
        }
        destroyView() {
        }
        backView() {
        }
    }

    class TipsUI extends BaseWindow {
        constructor() {
            super();
            this.m_EUIDepth = EUIDepth.top;
            this.m_Iview = new TipsUIView(this);
        }
        IUI() {
            this.contentPane = fgui.UIPackage.createObject("TipsUI", "Main").asCom;
            this.tipsText = this.contentPane.getChild('n0').asCom.getChild('n1').asTextField;
            this.ct = this.contentPane.getController('c1');
            this.t1 = this.contentPane.getTransition('t1');
            this.ct.selectedIndex = 0;
            this.contentPane.touchable = false;
        }
        openUI() {
        }
        closeUI() {
        }
        disposeUI() {
        }
        backUI() {
        }
    }

    class LuckUIModel {
        constructor() {
            let _luckNumber = LocalStorage.getJSON('luckNumber');
            if (_luckNumber != undefined || _luckNumber != null) {
                this.luckNumber = _luckNumber;
            }
            else {
                this.luckNumber = 1;
                LocalStorage.setJSON('luckNumber', this.luckNumber);
            }
        }
        IModel() { }
        set luckNumber(_value) {
            this.m_luckNumber = _value;
            LocalStorage.setJSON('luckNumber', this.m_luckNumber);
        }
        get luckNumber() {
            return this.m_luckNumber;
        }
    }

    class LuckUIProxy extends Proxy {
        constructor() {
            super();
            this.setModelID = LuckUIModel;
            this.registered();
        }
        get model() {
            return this.getModel;
        }
    }

    class LuckUIAddNumberComd extends LuckUIProxy {
        constructor(_number = 1) {
            super();
            if (this.model.luckNumber <= 0) {
                this.model.luckNumber = _number;
            }
        }
        execute() {
            this.refresh();
        }
        ICommand() { }
    }

    class PrizeUIModel {
        constructor() { }
        IModel() { }
    }

    class PrizeUIProxy extends Proxy {
        constructor() {
            super();
            this.setModelID = PrizeUIModel;
            this.registered();
        }
        get model() {
            return this.getModel;
        }
    }

    class PrizeUISetIndexComd extends PrizeUIProxy {
        constructor(_selectedIndex) {
            super();
            this.model.selectedIndex = _selectedIndex;
            if (this.model.selectedIndex == 1 || this.model.selectedIndex == 5) {
                this.model.assetsType = '金币';
                this.model.showAssets = Math.floor(Math.random() * 30 + 10);
            }
            else if (this.model.selectedIndex == 2 || this.model.selectedIndex == 4) {
                this.model.assetsType = '钻石';
                this.model.showAssets = Math.floor(Math.random() * 15 + 5);
            }
            else if (this.model.selectedIndex == 3) {
                this.model.assetsType = '金币';
                this.model.showAssets = Math.floor(Math.random() * 200 + 100);
            }
            else {
                this.model.assetsType = "人物";
                this.model.showAssets = 0;
            }
        }
        execute() {
            this.refresh();
        }
        ICommand() { }
    }

    class LuckUIView extends LuckUIProxy {
        constructor(_view) {
            super();
            this.m_view = _view;
            this.m_view.luckDrawBtn.onClick(this, this.onLuckDrawBtnClick);
            this.m_view.freeLuckDrawCom.onClick(this, this.onFreeLuckDrawComClick);
            this.m_view.skipCom.onClick(this, this.onSkipComClick);
            this.m_view.luckTransition.addCallBack(this, this.onLuckDrawCallBack);
        }
        onLuckDrawBtnClick() {
            this.m_view.luckTransition.addEvent();
            let _index = Math.ceil(Math.random() * 5);
            this.m_view.ct2.selectedIndex = _index;
            this.model.luckNumber = 0;
            new PrizeUISetIndexComd(_index).execute();
        }
        onLuckDrawCallBack() {
            Laya.timer.once(300, this, () => {
                new OpenModule(ModuleEnume.PRIZEUI).execute();
                this.update();
            });
        }
        onFreeLuckDrawComClick() {
            window["sdkmgr"].openReward(() => {
                this.m_view.ct2.selectedIndex = 0;
                new LuckUIAddNumberComd(1).execute();
                TimeUtil.saveCurTime();
            });
        }
        onSkipComClick() {
            new CloseModule(ModuleEnume.LUCKUI, true).execute();
            new OpenModule(ModuleEnume.NAVIGATIONUI).execute();
            window["sdk"].hideBanner();
        }
        IView() { }
        openView() {
            if (window['myPlatform'] == ChannelID.OPPO) {
                if (Globall.nativeCount < 5) {
                    window["sdk"].openNative(this.m_view.nNative.displayObject, 3);
                }
                else if (Globall.bannerCount < 5) {
                    window["sdk"].openBanner();
                }
            }
            else {
                window["sdkmgr"].openNative(Laya.stage, 1, null, true, false);
            }
        }
        update() {
            if (this.model.luckNumber <= 0) {
                this.m_view.ct1.selectedIndex = 2;
                var t1 = this.m_view.contentPane.getTransition("t1");
                t1.setPaused(true);
            }
            else {
                this.m_view.ct1.selectedIndex = 1;
                var t1 = this.m_view.contentPane.getTransition("t1");
                t1.setPaused(true);
            }
        }
        closeView() {
        }
        destroyView() {
        }
        backView() {
        }
    }

    class LuckTransition {
        constructor(_com) {
            this.transition1 = _com.getTransition('t11');
            this.transition2 = _com.getTransition('t22');
            this.transition3 = _com.getTransition('t33');
            this.transition4 = _com.getTransition('t44');
            this.transition5 = _com.getTransition('t55');
            this.transition6 = _com.getTransition('t66');
        }
        addEvent() {
            for (let i = 1; i < 7; i++) {
                this['transition' + i].setHook("over", Laya.Handler.create(this, this.onTrCallback));
            }
        }
        addCallBack(_this, _addCallBack) {
            this.m_callThis = _this;
            this.m_CallBack = _addCallBack;
        }
        onTrCallback() {
            this.m_CallBack.call(this.m_callThis);
        }
    }

    class LuckUI extends BaseWindow {
        constructor() {
            super();
            this.m_EUIDepth = EUIDepth.uiTop;
            this.m_Iview = new LuckUIView(this);
        }
        IUI() {
            this.contentPane = fgui.UIPackage.createObject("LuckUI", "Main").asCom;
            this.luckDrawBtn = this.contentPane.getChild("luckDrawBtn").asButton;
            this.freeLuckDrawCom = this.contentPane.getChild('luckDrawCom').asCom;
            this.skipCom = this.contentPane.getChild('skipCom').asCom;
            this.ct1 = this.contentPane.getController('c1');
            this.ct2 = this.contentPane.getController('c2');
            this.luckTransition = new LuckTransition(this.contentPane);
            let skip = this.contentPane.getChild("skipCom").asCom;
            skip.alpha = 1;
            this.nNative = this.contentPane.getChild("n12").asCom;
            var videoicon = this.freeLuckDrawCom.getChild('n4').asCom;
            videoicon.visible = Globall.isShowVideo == 1;
        }
        openUI() {
        }
        closeUI() {
        }
        disposeUI() {
        }
        backUI() {
        }
    }

    class PrizeUIView extends PrizeUIProxy {
        constructor(_view) {
            super();
            this.m_view = _view;
            this.m_view.receiveBtn.onClick(this, this.onReceiveBtnClick);
            this.m_view.receive3Com.onClick(this, this.onreceive3ComClick);
        }
        onreceive3ComClick() {
            window["sdkmgr"].openReward(() => {
                this.Receive(3);
                new CloseModule(ModuleEnume.PRIZEUI, true).execute();
                TimeUtil.saveCurTime();
            });
        }
        onReceiveBtnClick() {
            this.Receive();
            new CloseModule(ModuleEnume.PRIZEUI, true).execute();
        }
        Receive(times = 1) {
            let _addAssetNumber = Math.floor(this.model.showAssets * times);
            if (this.model.assetsType == '金币' || this.model.assetsType == "金币") {
                new AssetsUIAddGoldComd(_addAssetNumber).execute();
            }
            else if (this.model.assetsType == '钻石' || this.model.assetsType == "钻石") {
                new AssetsUIAddDiamondComd(_addAssetNumber).execute();
            }
            else {
                new AssetsUIAddGoldComd(_addAssetNumber).execute();
                new AssetsUIAddDiamondComd(_addAssetNumber).execute();
            }
        }
        IView() { }
        openView() {
            this.m_view.ct2.selectedIndex = 0;
            this.m_view.ct2.selectedIndex = this.model.selectedIndex;
        }
        update() {
            this.m_view.showMoneyText.text = this.model.showAssets.toString();
            if (this.m_view.showMoneyText.text == '0')
                this.m_view.showMoneyText.text = '';
        }
        closeView() {
        }
        destroyView() {
        }
        backView() {
        }
    }

    class PrizeUI extends BaseWindow {
        constructor() {
            super();
            this.m_EUIDepth = EUIDepth.uiTop;
            this.m_Iview = new PrizeUIView(this);
        }
        IUI() {
            this.contentPane = fgui.UIPackage.createObject("PrizeUI", "Main").asCom;
            this.receiveBtn = this.contentPane.getChild("receiveBtn").asButton;
            this.receive3Com = this.contentPane.getChild('Receive3Com').asCom;
            this.ct2 = this.contentPane.getController('c2');
            this.showMoneyText = this.contentPane.getChild('showMoneyText').asTextField;
            var t1 = this.contentPane.getTransition("t1");
            t1.setPaused(true);
            var videoicon = this.receive3Com.getChild('n4').asCom;
            videoicon.visible = Globall.isShowVideo == 1;
        }
        openUI() {
        }
        closeUI() {
        }
        disposeUI() {
        }
        backUI() {
        }
    }

    class OfflineUIView extends OfflineUIProxy {
        constructor(_view) {
            super();
            this.m_view = _view;
            this.m_view.receiveBtn.onClick(this, this.onReceiveBtnClick);
            this.m_view.receive3Com.onClick(this, this.onReceive3BtnClick);
            if (window['myPlatform'] == ChannelID.OPPO) {
                if (Globall.bannerCount < 5) {
                    window["sdk"].openBanner();
                }
            }
        }
        onReceiveBtnClick() {
            new AssetsUIAddGoldComd(this.model.gold).execute();
            new CloseModule(ModuleEnume.OFFLINEUI, true).execute();
            window["sdk"].hideBanner();
        }
        onReceive3BtnClick() {
            window["sdkmgr"].openReward(() => {
                new AssetsUIAddGoldComd(this.model.gold * 3).execute();
                new CloseModule(ModuleEnume.OFFLINEUI, true).execute();
                TimeUtil.saveCurTime();
            });
        }
        IView() { }
        openView() {
        }
        update() {
            if (this.model.isUpdate == false)
                return;
            this.model.isUpdate = false;
            let _describe = '离线时间：';
            let _hour = Math.floor(this.model.minute / 60);
            let _minute = this.model.minute % 60;
            let _describe2 = '';
            if (_hour > 0) {
                _describe2 = _hour + '小时';
            }
            let _describe3 = _minute + '分';
            this.m_view.describeText.text = _describe + _describe2 + _describe3;
            this.m_view.goldText.text = '×' + this.model.gold;
        }
        closeView() {
        }
        destroyView() {
        }
        backView() {
        }
    }

    class OfflineUI extends BaseWindow {
        constructor() {
            super();
            this.m_EUIDepth = EUIDepth.top;
            this.m_Iview = new OfflineUIView(this);
        }
        IUI() {
            this.contentPane = fgui.UIPackage.createObject("OfflineUI", "Main").asCom;
            this.receiveBtn = this.contentPane.getChild("n28").asButton;
            this.receive3Com = this.contentPane.getChild('n27').asCom;
            this.goldText = this.contentPane.getChild('n25').asTextField;
            this.describeText = this.contentPane.getChild('n29').asTextField;
        }
        openUI() {
            Scene3DUI.hide();
        }
        closeUI() {
            Scene3DUI.show();
        }
        disposeUI() {
        }
        backUI() {
        }
    }

    class BattleUIView extends BattleUIProxy {
        constructor(_view) {
            super();
            this.m_view = _view;
        }
        IView() { }
        openView() {
            Scene3DUI.hide();
            this.model.proportion = Global.proportion;
            this.model.levelProgress = Global.levelProgress;
            this.model.score = Global.score;
            this.model.gold = Global.gold;
            this.m_view.levelTxt.text = Global.checkPoint + '';
            if (new GetIsSuperComd().isSuper) {
                this.m_view.ct1.selectedIndex = 1;
            }
        }
        update() {
            this.m_view.progress.value = this.model.proportion;
            this.m_view.levelProgress.value = this.model.levelProgress;
            this.m_view.goldTxt.text = this.model.gold.toFixed(0);
            this.m_view.scoreTxt.text = this.model.score.toFixed(0);
        }
        closeView() {
        }
        destroyView() {
        }
        backView() {
        }
    }

    class BattleUI extends BaseWindow {
        constructor() {
            super();
            this.m_EUIDepth = EUIDepth.uiTop;
            this.m_Iview = new BattleUIView(this);
        }
        IUI() {
            this.contentPane = fgui.UIPackage.createObject("BattleUI", "Main").asCom;
            let _com = this.contentPane.getChild('n0').asCom;
            let _com2 = this.contentPane.getChild("n4").asCom;
            this.loader1 = _com.getChild('n2').asLoader;
            this.progress = _com.getChild('n1').asProgress;
            this.loader2 = this.progress.getChild('n3').asLoader;
            _com.visible = false;
            _com2.visible = false;
            this.levelProgress = this.contentPane.getChild('n12').asProgress;
            this.levelTxt = this.contentPane.getChild('levelTxt').asTextField;
            this.scoreTxt = this.contentPane.getChild('scoreTxt').asTextField;
            this.goldTxt = this.contentPane.getChild('GoldTxt').asTextField;
            this.ct1 = this.contentPane.getController('c1');
        }
        openUI() {
        }
        closeUI() {
        }
        disposeUI() {
        }
        backUI() {
        }
    }

    class TrialHeroUIModel {
        constructor() {
            this.describe = '';
            this.isOpen = false;
        }
        IModel() { }
    }

    class TrialHeroUIProxy extends Proxy {
        constructor() {
            super();
            this.setModelID = TrialHeroUIModel;
            this.registered();
        }
        get model() {
            return this.getModel;
        }
    }

    class RoleUIGetTrialRoleVoComd extends RoleUIProxy {
        constructor() {
            super();
            let _index = Math.round(Math.random() * 20 + 10);
            this.trialRoleVo = this.model.roleItemArr[_index].CloneVo();
            this.trialRoleVo.isTrial = true;
            this.trialRoleVo.unlock = true;
        }
        execute() {
        }
        ICommand() { }
    }

    class TrialHeroUIView extends TrialHeroUIProxy {
        constructor(_view) {
            super();
            this.m_view = _view;
            this.m_view.trialCom.onClick(this, this.onTrialComClick);
            this.m_view.noThankCom.onClick(this, this.onNoTrialComClick);
            if (window['myPlatform'] == ChannelID.OPPO) {
                if (Globall.bannerCount < 5) {
                    window["sdk"].openBanner();
                }
            }
        }
        onTrialComClick() {
            window["sdkmgr"].openReward(() => {
                EventManager.inst.Emit(EventManager.RoleEvent, this.m_trialRoleVo);
                new CloseModule(ModuleEnume.TRIALHEROUI, true).execute();
            });
        }
        onNoTrialComClick() {
            window["sdk"].hideBanner();
            new CloseModule(ModuleEnume.TRIALHEROUI, true).execute();
            window["sdkmgr"].openNative(Laya.stage, 1, null, true, false);
        }
        IView() { }
        openView() {
            this.m_view.ct.selectedIndex = 0;
            this.m_view.ct.selectedIndex = 1;
            let _vo = this.m_trialRoleVo = new RoleUIGetTrialRoleVoComd().trialRoleVo;
            Scene3DUI.LoadModel(_vo);
            Scene3DUI.show();
        }
        update() {
        }
        closeView() {
            Scene3DUI.destroyModel();
            this.m_trialRoleVo = null;
        }
        destroyView() {
        }
        backView() {
        }
    }

    class TrialHeroUI extends BaseWindow {
        constructor() {
            super();
            this.m_EUIDepth = EUIDepth.top;
            this.m_Iview = new TrialHeroUIView(this);
        }
        IUI() {
            this.contentPane = fgui.UIPackage.createObject("TrialHeroUI", "Main").asCom;
            this.noThankCom = this.contentPane.getChild('noThankCom').asCom;
            this.trialCom = this.contentPane.getChild('trialCom').asCom;
            this.ct = this.contentPane.getController('c1');
            this.box = this.contentPane.getChild("n17").asGraph;
            var t1 = this.contentPane.getTransition("t1");
            t1.setPaused(true);
            var videoicon = this.trialCom.getChild('n4').asCom;
            videoicon.visible = Globall.isShowVideo == 1;
            window["sdkmgr"].openNative(Laya.stage, 1, null, true, false);
        }
        openUI() {
        }
        closeUI() {
        }
        disposeUI() {
        }
        backUI() {
        }
    }

    class AdCoinUIModel {
        constructor() {
            this.describe = '';
            this.isOpen = false;
        }
        IModel() { }
    }

    class AdCoinUIProxy extends Proxy {
        constructor() {
            super();
            this.setModelID = AdCoinUIModel;
            this.registered();
        }
        get model() {
            return this.getModel;
        }
    }

    class AdCoinUIView extends AdCoinUIProxy {
        constructor(_view) {
            super();
            this.m_view = _view;
            this.m_view.closeCom.onClick(this, this.closeComClick);
            this.m_view.videoCom.onClick(this, this.videoComClick);
        }
        closeComClick() {
            new CloseModule(ModuleEnume.ADCOINUI, true).execute();
            new OpenModule(ModuleEnume.TRIALHEROUI).execute();
        }
        videoComClick() {
            window["sdkmgr"].openReward(() => {
                new AssetsUIAddGoldComd(200).execute();
                this.closeComClick();
            });
        }
        IView() { }
        openView() {
        }
        update() {
        }
        closeView() {
        }
        destroyView() {
        }
        backView() {
        }
    }

    class AdCoinUI extends BaseWindow {
        constructor() {
            super();
            this.m_EUIDepth = EUIDepth.top;
            this.m_Iview = new AdCoinUIView(this);
        }
        IUI() {
            this.contentPane = fgui.UIPackage.createObject("AdCoinUI", "Main").asCom;
            this.closeCom = this.contentPane.getChild('n19').asCom;
            this.videoCom = this.contentPane.getChild('trialCom').asCom;
            var t2 = this.contentPane.getTransition("t1");
            t2.setPaused(true);
            var videoicon = this.videoCom.getChild('n4').asCom;
            videoicon.visible = Globall.isShowVideo == 1;
            window["sdkmgr"].openNative(Laya.stage, 1, null, true, false);
        }
        openUI() {
        }
        closeUI() {
        }
        disposeUI() {
        }
        backUI() {
        }
    }

    class ModuleEnume {
    }
    ModuleEnume.LOADINGUI = LoadingUI;
    ModuleEnume.LOGINUI = LoginUI;
    ModuleEnume.GAMEUI = GameUI;
    ModuleEnume.SETTINGSUI = SettingsUI;
    ModuleEnume.ACHIEVEMENTSUI = AchievementsUI;
    ModuleEnume.FINISHUI = FinishUI;
    ModuleEnume.GameOverUI = GameOverUI;
    ModuleEnume.MAINUI = MainUI;
    ModuleEnume.SKINSUI = SkinsUI;
    ModuleEnume.ASSETSUI = AssetsUI;
    ModuleEnume.TASKUI = TaskUI;
    ModuleEnume.ROLEUI = RoleUI;
    ModuleEnume.NAVIGATIONUI = NavigationUI;
    ModuleEnume.TIPSUI = TipsUI;
    ModuleEnume.LUCKUI = LuckUI;
    ModuleEnume.PRIZEUI = PrizeUI;
    ModuleEnume.OFFLINEUI = OfflineUI;
    ModuleEnume.BATTLEUI = BattleUI;
    ModuleEnume.TRIALHEROUI = TrialHeroUI;
    ModuleEnume.ADCOINUI = AdCoinUI;

    class RoleCfVo {
        constructor() {
            this.m_dic = new Dictionary();
        }
        readJson(_jsonData) {
            var datas = _jsonData['RunRunRoleConfig'];
            for (var i = 0; i < datas.length; i++) {
                let _vo = new RoleVo(datas[i]);
                this.m_dic.addStringKey(_vo.id, _vo);
            }
            return this;
        }
        getData(_id) {
            return this.m_dic.getStringKey(_id);
        }
        getAllRoleVo() {
            let list = [];
            this.m_dic.forEach((_key, _vo) => {
                list.push(_vo);
            }, this);
            return list;
        }
    }
    class RoleVo {
        constructor(_json) {
            this.m_unlock = false;
            this.m_roleRank = 0;
            this.isTrial = false;
            this.trailID = 5;
            this.bulletSpeed = 100;
            this.skillID = 0;
            this.skillHitTriggerCount = 100;
            this.m_json = _json;
            this.id = _json["id"];
            this.name = _json["name"];
            this.quality = _json["quality"];
            this.roleDescribe = _json["roleDescribe"];
            this.atkDistance = Number(_json["atkDistance"]);
            this.skillValue = Number(_json["skillValue"]);
            this.atkSpeed = Number(_json["atkSpeed"]);
            this.moveSpeed = Number(_json["moveSpeed"]);
            this.modelID = Number(_json["modelID"]);
            this.openType = _json["openType"];
            this.openValue = Number(_json["openValue"]);
            this.init();
        }
        get bulletDistance() {
            return (this.atkDistance * ((this.roleRank + 1) * 0.01) + this.atkDistance) * 0.8;
        }
        get bulletSpawnSpeed() {
            return (this.atkSpeed * ((this.roleRank + 1) * 0.01) + this.atkSpeed) * 0.8;
        }
        get skillDuration() {
            return (this.skillValue * ((this.roleRank + 1) * 0.01) + this.skillValue) * 30;
        }
        init() {
            if (LocalStorage.getItem("RoleUnlockID_" + this.id)) {
                this.unlock = true;
            }
            let _roleRankString = LocalStorage.getItem("RoleRank_" + this.id);
            if (_roleRankString) {
                this.roleRank = Number(_roleRankString);
            }
        }
        get unlock() {
            return this.m_unlock;
        }
        set unlock(_boolean) {
            this.m_unlock = _boolean;
            if (this.m_unlock == true && this.isTrial == false) {
                LocalStorage.setItem("RoleUnlockID_" + this.id, 'true');
            }
        }
        get roleRank() {
            return this.m_roleRank;
        }
        set roleRank(_roleRank) {
            this.m_roleRank = _roleRank;
            LocalStorage.setItem("RoleRank_" + this.id, this.m_roleRank.toString());
        }
        CloneVo() {
            let _cloneVo = new RoleVo(this.m_json);
            return _cloneVo;
        }
    }

    class LeveCfVo {
        constructor() {
            this.m_dic = new Dictionary();
        }
        readJson(_jsonData) {
            var datas = _jsonData['RunRunLeveConfig'];
            for (var i = 0; i < datas.length; i++) {
                let _vo = new LeveVo(datas[i]);
                this.m_dic.addStringKey(_vo.id, _vo);
            }
            return this;
        }
        getData(_id) {
            return this.m_dic.getStringKey(_id);
        }
        getAllLeveVo() {
            let list = [];
            this.m_dic.forEach((_key, _vo) => {
                list.push(_vo);
            }, this);
            return list;
        }
    }
    class LeveVo {
        constructor(_json) {
            this.id = _json["id"];
            this.name = _json["name"];
            this.type = _json["type"];
            this.gold = Math.round(Number(_json["gold"]));
            this.diamond = Math.round(Number(_json["diamond"]));
        }
    }

    class ResLoadManager {
        static PushUrls(...urls) {
            for (var i = 0; i < urls.length; i++) {
                var has = ResLoadManager.urls.indexOf(urls[i]) >= 0;
                if (!has) {
                    ResLoadManager.urls.push(urls[i]);
                }
            }
        }
        static LoadRes(completed, progress) {
            Laya.loader.create(ResLoadManager.urls, Laya.Handler.create(null, completed), progress ? Laya.Handler.create(null, progress) : null);
        }
    }
    ResLoadManager.urls = [];

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function res_auto_bind() {
        return function (_constructor) {
            var newConstructor = class T extends _constructor {
                constructor(...args) {
                    super(...args);
                    var resPrefabClone = this['_res_prefab_clone'];
                    if (resPrefabClone) {
                        for (var i = 0; i < resPrefabClone.length; i++) {
                            var resBind = resPrefabClone[i];
                            this[resBind.key] = Laya.Sprite3D.instantiate(Laya.loader.getRes(resBind.url));
                        }
                        this['_res_prefab_clone'] = null;
                    }
                    var resAssigns = this['_res_assign'];
                    if (resAssigns) {
                        for (var i = 0; i < resAssigns.length; i++) {
                            var resAssign = resAssigns[i];
                            this[resAssign.key] = Laya.loader.getRes(resAssign.url);
                        }
                        this['_res_assign'] = null;
                    }
                    var resArrayAssigns = this['_res_array_assign'];
                    if (resArrayAssigns) {
                        for (var i = 0; i < resArrayAssigns.length; i++) {
                            var resArrayAssign = resArrayAssigns[i];
                            var arry = this[resArrayAssign.key] = [];
                            for (var i = 0; i < resArrayAssign.urls.length; i++) {
                                var url = resArrayAssign.urls[i];
                                arry.push(Laya.loader.getRes(url));
                            }
                        }
                        this['_res_array_assign'] = null;
                    }
                    if (this['_init_']) {
                        this['_init_']();
                    }
                }
            };
            return newConstructor;
        };
    }
    function res_assign(url) {
        ResLoadManager.PushUrls(url);
        return function (target, key) {
            target['_res_assign'] = target['_res_assign'] || [];
            var v = target['_res_assign'];
            v.push({ key: key, url: url });
        };
    }
    function res_register(...urls) {
        ResLoadManager.PushUrls(...urls);
        return function (_constructor) {
            var newConstructor = class T extends _constructor {
                constructor(...args) {
                    super(...args);
                }
            };
            return newConstructor;
        };
    }

    const boomFXUrl = Global.localSven3DAssetsPreload + '/LayaScene_ItemLibrary/Conventional/Boom_C.lh';
    res_register(boomFXUrl);
    class ParticleItem {
        constructor() {
            this.particles = [];
        }
        init(key) {
            if (this.baseNode == null) {
                this.key = key;
                this.baseNode = Laya.Sprite3D.instantiate(Laya.loader.getRes(key));
                this.getParticle(this.baseNode);
            }
        }
        getParticle(node) {
            if (node instanceof Laya.ShuriKenParticle3D) {
                node.particleSystem.stop();
                this.particles.push(node.particleSystem);
            }
            for (var i = 0; i < node.numChildren; i++) {
                this.getParticle(node.getChildAt(i));
            }
        }
        Play() {
            this.baseNode.active = true;
            for (var i = 0; i < this.particles.length; i++) {
                this.particles[i].play();
            }
        }
        get IsAlive() {
            for (var i = 0; i < this.particles.length; i++) {
                if (this.particles[i].isAlive) {
                    return true;
                }
            }
            return false;
        }
        SetParent(p) {
            if (p) {
                p.addChild(this.baseNode);
            }
            else {
                if (this.baseNode.parent) {
                    this.baseNode.parent.removeChild(this.baseNode);
                }
            }
        }
        Recover() {
            for (var i = 0; i < this.particles.length; i++) {
                this.particles[i].stop();
            }
            if (this.baseNode && this.baseNode.parent) {
                this.baseNode.parent.removeChild(this.baseNode);
            }
        }
    }
    class ParticlePool {
        constructor() {
            this.fxs = [];
        }
        static get inst() {
            if (!ParticlePool._inst) {
                ParticlePool._inst = new ParticlePool;
            }
            return ParticlePool._inst;
        }
        CreateItem(key, pos) {
            var fx = Laya.Pool.getItemByClass(key, ParticleItem);
            fx.init(key);
            console.log("ParticlePool.node", ParticlePool.node);
            fx.SetParent(ParticlePool.node);
            fx.baseNode.transform.position = pos;
            fx.Play();
            this.fxs.push(fx);
            Laya.timer.frameLoop(1, this, this._tick);
        }
        CreateBoomFX(pos) {
        }
        Clear() {
            for (var i = 0; i < this.fxs.length; i++) {
                var fx = this.fxs[i];
                fx.Recover();
                Laya.Pool.recover(fx.key, fx);
            }
            this.fxs = [];
        }
        _tick() {
            var newFxs = [];
            for (var i = this.fxs.length - 1; i >= 0; i--) {
                var fx = this.fxs[i];
                if (!fx.IsAlive) {
                    fx.Recover();
                    Laya.Pool.recover(fx.key, fx);
                }
                else {
                    newFxs.push(fx);
                }
            }
            this.fxs = newFxs;
        }
    }

    class Utils {
        static csvToJson(_stringData) {
            let _stringDataArr = _stringData.split("\n");
            let _titles = _stringDataArr[0].replace("\r", "");
            let _titleArr = _titles.split(",");
            let _dataAll = [];
            for (let i = 1; i < _stringDataArr.length; i++) {
                let _stringChildDataArr = _stringDataArr[i].replace("\r", "").split(",");
                let childData = {};
                for (let j = 0; j < _stringChildDataArr.length; j++) {
                    let _key = _titleArr[j];
                    let _value = _stringChildDataArr[j];
                    childData[_key] = _value;
                }
                _dataAll.push(childData);
            }
            return _dataAll;
        }
        static loadPrefab(name, pos, callback, node) {
            if (node.getChildByName(name))
                return;
            Laya.loader.load(`h5/prefab/${name}.json`, Laya.Handler.create(this, (pre) => {
                let pref = new Laya.Prefab();
                pref.json = pre;
                let Info = Laya.Pool.getItemByCreateFun(name, pref.create, pref);
                Info.pos(pos.x, pos.y);
                Info.name = name;
                node.addChild(Info);
                callback(Info);
            }));
        }
        static vector3ToColor(_value) {
            var r = _value.x * 255;
            var g = _value.y * 255;
            var b = _value.z * 255;
            var hex = "#" + ((1 << 24) + (r << 16) + (g << 8) + b).toString(16).slice(1);
            return hex;
        }
        static randomName() {
            let index0 = Math.ceil(Math.random() * (Global.rondomNames10.length - 1));
            let name0 = Global.rondomNames10.charAt(index0);
            let index1;
            let name1;
            let sex = (Math.random() > 0.5);
            if (sex) {
                index1 = Math.ceil(Math.random() * (Global.rondomNames11.length - 1));
                name1 = Global.rondomNames11.charAt(index1);
            }
            else {
                index1 = Math.ceil(Math.random() * (Global.rondomNames12.length - 1));
                name1 = Global.rondomNames12.charAt(index1);
            }
            return name0 + name1;
        }
    }

    var Laya3DPrefabManager_1;
    let Laya3DPrefabManager = Laya3DPrefabManager_1 = class Laya3DPrefabManager {
        constructor() {
            if (Laya3DPrefabManager_1.m_instance != null) {
                console.error("This class is a single class !!!!!!!!!  new Laya3DPrefabManager()  ?????");
                return;
            }
            Laya3DPrefabManager_1.m_instance = this;
            this.init();
        }
        static get Instance() {
            if (Laya3DPrefabManager_1.m_instance == null)
                Laya3DPrefabManager_1.m_instance = new Laya3DPrefabManager_1();
            return Laya3DPrefabManager_1.m_instance;
        }
        init() {
        }
    };
    Laya3DPrefabManager.m_instance = null;
    __decorate([
        res_assign(Global.localSven3DAssetsPreload + '/LayaScene_ItemLibrary/Conventional/Road.lh')
    ], Laya3DPrefabManager.prototype, "road", void 0);
    __decorate([
        res_assign(Global.localSven3DAssetsPreload + '/LayaScene_ItemLibrary/Conventional/Start.lh')
    ], Laya3DPrefabManager.prototype, "start", void 0);
    __decorate([
        res_assign(Global.localSven3DAssetsPreload + '/LayaScene_ItemLibrary/Conventional/End.lh')
    ], Laya3DPrefabManager.prototype, "end", void 0);
    __decorate([
        res_assign(Global.localSven3DAssetsPreload + '/LayaScene_Scenario/Conventional/Scenario_9.lh')
    ], Laya3DPrefabManager.prototype, "defaultScenario", void 0);
    __decorate([
        res_assign(Global.localSven3DAssetsPreload + '/LayaScene_ItemLibrary/Conventional/Background.lh')
    ], Laya3DPrefabManager.prototype, "background", void 0);
    __decorate([
        res_assign(Global.localSven3DAssetsPreload + '/LayaScene_ItemLibrary/Conventional/Coin.lh')
    ], Laya3DPrefabManager.prototype, "coin", void 0);
    Laya3DPrefabManager = Laya3DPrefabManager_1 = __decorate([
        res_auto_bind()
    ], Laya3DPrefabManager);
    var Laya3DPrefabManager$1 = Laya3DPrefabManager;

    class SettingsUIGetDataComd extends SettingsUIProxy {
        constructor() {
            super();
            this.isSound = this.model.isSound;
            this.isMusic = this.model.isMusic;
        }
        execute() {
            this.refresh();
        }
        ICommand() { }
    }

    var SoundCtrl_1;
    var crash = 'res/audio/ground_crash.mp3';
    var bgm1 = 'res/audio/bgm1.mp3';
    var gameOver = 'res/audio/SFX_GameOver.mp3';
    var shoot = 'res/audio/SFX_Shoot.mp3';
    var boom = 'res/audio/SFX_Boom.mp3';
    var coin = 'res/audio/SFX_CoinPick.mp3';
    let SoundCtrl = SoundCtrl_1 = class SoundCtrl {
        constructor() {
            EventManager.inst.AddNotice(EventManager.SoundOn, this, this.SoundON);
            EventManager.inst.AddNotice(EventManager.SoundOff, this, this.SoundOFF);
            EventManager.inst.AddNotice(EventManager.MusicOn, this, this.MusicON);
            EventManager.inst.AddNotice(EventManager.MusicOff, this, this.MusicOFF);
            EventManager.inst.AddNotice(EventManager.DEAD, this, this.PlayGameOver);
            EventManager.inst.AddNotice(EventManager.FINISH, this, this.PlayCheer);
            EventManager.inst.AddNotice(EventManager.SCENELOADED, this, this.PlayBGM);
            var s = new SettingsUIGetDataComd();
            Laya.SoundManager.soundMuted = !s.isSound;
            Laya.SoundManager.musicMuted = !s.isMusic;
        }
        static get inst() {
            if (!SoundCtrl_1._inst) {
                SoundCtrl_1._inst = new SoundCtrl_1;
            }
            return SoundCtrl_1._inst;
        }
        Faker() {
        }
        SoundON() {
            Laya.SoundManager.soundMuted = false;
        }
        SoundOFF() {
            Laya.SoundManager.soundMuted = true;
        }
        MusicON() {
            Laya.SoundManager.musicMuted = false;
        }
        MusicOFF() {
            Laya.SoundManager.musicMuted = true;
        }
        PlayBGM() {
            Laya.SoundManager.playMusic(bgm1, 0);
        }
        PlayCrash() {
            Laya.SoundManager.playSound(crash);
        }
        PlayShoot() {
            Laya.SoundManager.playSound(shoot);
        }
        PlayCheer() {
            Laya.SoundManager.playSound('res/audio/Goal cheer_Loud.mp3');
        }
        PlayGameOver() {
            Laya.SoundManager.playSound(gameOver);
        }
        Boom() {
            Laya.SoundManager.playSound(boom);
        }
        Coin() {
            Laya.SoundManager.playSound(coin);
        }
    };
    SoundCtrl = SoundCtrl_1 = __decorate([
        res_register(bgm1, coin)
    ], SoundCtrl);

    class AddFlyingObjectTaskComd extends TaskUIProxy {
        constructor() {
            super();
        }
        add(_value) {
            this.model.flyingObject += _value;
            return this;
        }
        execute() {
        }
        ICommand() { }
    }

    class AddHitBombTaskComd extends TaskUIProxy {
        constructor() {
            super();
        }
        add(_value) {
            this.model.hitBomb += _value;
            return this;
        }
        execute() {
        }
        ICommand() { }
    }

    class BattleUIAddScoreComd extends BattleUIProxy {
        constructor() {
            super();
        }
        addValue(_vlaue) {
            this.model.score++;
            return this;
        }
        execute() {
            this.refresh();
        }
        ICommand() { }
    }

    class BulletPool {
        constructor() {
            this._pool = [];
            this.currentBulletID = 0;
            this.bulletColor = [
                new Laya.Vector4(123 / 255, 243 / 255, 16 / 255, 1),
                new Laya.Vector4(0 / 255, 142 / 255, 7 / 255, 1),
                new Laya.Vector4(219 / 255, 152 / 255, 9 / 255, 1),
                new Laya.Vector4(255 / 255, 174 / 255, 0 / 255, 1),
                new Laya.Vector4(219 / 255, 52 / 255, 233 / 255, 1),
                new Laya.Vector4(52 / 255, 101 / 255, 243 / 255, 1),
                new Laya.Vector4(255 / 255, 71 / 255, 71 / 255, 1),
                new Laya.Vector4(248 / 255, 85 / 255, 243 / 255, 1),
                new Laya.Vector4(23 / 255, 209 / 255, 196 / 255, 1),
                new Laya.Vector4(115 / 255, 0 / 255, 148 / 255, 1),
                new Laya.Vector4(227 / 255, 127 / 255, 50 / 255, 1),
                new Laya.Vector4(146 / 255, 49 / 255, 161 / 255, 1),
                new Laya.Vector4(135 / 255, 199 / 255, 49 / 255, 1)
            ];
            this.defaultColor = new Laya.Vector4(1, 1, 1, 1);
        }
        static get inst() {
            if (!BulletPool._inst) {
                BulletPool._inst = new BulletPool;
            }
            return BulletPool._inst;
        }
        Init() {
            this._pool = [];
            this.com = new AddFlyingObjectTaskComd();
            this.bCom = new AddHitBombTaskComd();
            this.score = new BattleUIAddScoreComd();
        }
        GetBullet(colorID) {
            this.currentBulletID++;
            var ret;
            if (this._pool.length > 0) {
                var item = this._pool.shift();
                item.owner.active = true;
                ret = item;
            }
            else {
                var bullet = new Laya.MeshSprite3D(Laya.PrimitiveMesh.createSphere(1, 20, 20));
                var mat = new Laya.PBRStandardMaterial();
                mat.metallic = 0;
                mat.smoothness = 0.3;
                bullet.meshRenderer.material = mat;
                bullet.name = 'Bullet';
                Global.gameMainScene.addChild(bullet);
                var rigidBody = bullet.addComponent(Laya.Rigidbody3D);
                var sphereShape = new Laya.SphereColliderShape(1);
                rigidBody.colliderShape = sphereShape;
                rigidBody.mass = 1000;
                rigidBody.collisionGroup = Laya.Physics3DUtils.COLLISIONFILTERGROUP_CUSTOMFILTER2;
                rigidBody.canCollideWith = Laya.Physics3DUtils.COLLISIONFILTERGROUP_CUSTOMFILTER3;
                rigidBody.isKinematic = true;
                ret = bullet.addComponent(Bullet);
            }
            if (colorID) {
                colorID = colorID % this.bulletColor.length;
                ret.owner.meshRenderer.material.albedoColor = this.bulletColor[colorID];
            }
            else {
                ret.owner.meshRenderer.material.albedoColor = this.defaultColor;
            }
            return ret;
        }
        Recover(obj) {
            obj.owner.active = false;
            this._pool.push(obj);
        }
    }
    class Bullet extends Laya.Script3D {
        constructor() {
            super(...arguments);
            this.distance = 50;
            this.speed = new Laya.Vector3();
        }
        Set(speedz, scale, distance, pos, speedx = 0, speedy = 0) {
            this.tran.setWorldLossyScale(scale);
            this.distance = distance;
            this.speed.setValue(speedx, speedy, speedz);
            this.tran.position.setValue(pos.x, pos.y, pos.z);
            this.tran.position = this.tran.position;
        }
        onAwake() {
            this.tran = this.owner.transform;
        }
        onUpdate() {
            var d = Laya.timer.delta * 0.001;
            this.tran.localPositionZ += this.speed.z * d;
            this.tran.localPositionX += this.speed.x * d;
            this.tran.localPositionY += this.speed.y * d;
            if (this.tran.localPositionZ - Global.PlayerPostion.z > this.distance) {
                this.recover();
            }
        }
        onCollisionEnter() {
            Laya.timer.frameOnce(1, this, this.recover);
            SoundCtrl.inst.PlayCrash();
            Global.hitCount++;
            Global.hitCountPerFrame++;
        }
        onTriggerEnter(other) {
            if (other.owner.name == 'Coin') {
                return;
            }
            BulletPool.inst.score.addValue(2);
            Laya.timer.frameOnce(1, this, this.recover);
            SoundCtrl.inst.PlayCrash();
            Global.hitCount++;
            Global.hitCountPerFrame++;
        }
        recover() {
            BulletPool.inst.Recover(this);
        }
    }

    class Boom extends Laya.Script3D {
        onCollisionEnter(c) {
            if (c.other.owner.name == 'Bullet' || c.other.owner.name == 'Enemy') {
                var trans = this.owner.transform;
                var sphereCollider = new Laya.SphereColliderShape(7.5);
                var hitResults = [];
                var from = new Laya.Vector3(trans.position.x, trans.position.y, trans.position.z - 20);
                var to = new Laya.Vector3(trans.position.x, trans.position.y, trans.position.z + 40);
                Global.gameMainScene.physicsSimulation.shapeCastAll(sphereCollider, from, to, hitResults);
                var thisFakePos = trans.position.clone();
                thisFakePos.y -= 6;
                for (var i = 0; i < hitResults.length; i++) {
                    var hitResult = hitResults[i];
                    var r3d = hitResult.collider.owner.getComponent(Laya.Rigidbody3D);
                    if (r3d) {
                        var dir = new Laya.Vector3();
                        var boomPos = hitResult.collider.owner.transform.position.clone();
                        Laya.Vector3.subtract(boomPos, thisFakePos, dir);
                        var len = Laya.Vector3.scalarLength(dir);
                        Laya.Vector3.normalize(dir, dir);
                        Laya.Vector3.scale(dir, (30 - len) * 200, dir);
                        r3d.applyImpulse(dir);
                    }
                }
                ParticlePool.inst.CreateBoomFX(trans.position.clone());
                SoundCtrl.inst.Boom();
                BulletPool.inst.bCom.add(1);
                Laya.timer.frameOnce(1, this, this.destroy);
            }
        }
        destroy() {
            this.owner.destroy(true);
        }
    }

    const checkDistance = 50;
    class Drap extends Laya.Script3D {
        constructor() {
            super(...arguments);
            this.speed = 0;
            this.isDraping = false;
            this.isDraped = false;
            this.isDestroy = false;
        }
        onAwake() {
            this.trans = this.owner.transform;
        }
        onUpdate() {
            if (this.isDestroy) {
                return;
            }
            if (!this.isDraping) {
                var d = (this.trans.position.z - Global.PlayerPostion.z);
                if (d <= checkDistance) {
                    this.isDraping = true;
                    this.speed = this.trans.position.y / ((checkDistance - 20) / Global.PlayerSpeed);
                    var fx = this.owner.parent.getChildAt(1);
                    fx.active = true;
                }
            }
            if (this.isDraping && !this.isDraped) {
                var y = this.trans.localPositionY -= this.speed * Laya.timer.delta * 0.001;
                if (y < 0) {
                    this.trans.localPositionY = 0;
                    this.isDraped = true;
                }
            }
            if (this.isDraped) {
                if (Global.PlayerPostion.z - this.trans.position.z > 20) {
                    Laya.timer.frameOnce(1, this, this.destroy);
                }
            }
        }
        destroy() {
            this.owner.parent.destroy(true);
        }
    }

    const checkDistance$1 = 60;
    const speed = 20;
    class Wheel extends Laya.Script3D {
        constructor() {
            super(...arguments);
            this.isMoving = false;
            this.isDestroyed = false;
        }
        onAwake() {
            this.trans = this.owner.transform;
            this.barrier = this.owner.getChildAt(0);
        }
        onUpdate() {
            if (this.barrier.destroyed) {
                return;
            }
            if (this.isDestroyed) {
                return;
            }
            if (!this.isMoving) {
                this.isMoving = this.check();
            }
            if (this.isMoving) {
                var delta = Laya.timer.delta * 0.001;
                this.trans.localPositionZ -= speed * delta;
                this.barrier.transform.localRotationEulerZ += 60 * delta;
                var d = Global.PlayerPostion.z - this.trans.position.z;
                if (d >= 20) {
                    Laya.timer.frameOnce(1, this, this.destroy);
                    this.isDestroyed = true;
                }
            }
        }
        check() {
            var d = this.trans.position.z - Global.PlayerPostion.z;
            if (d <= checkDistance$1) {
                this.isMoving = true;
                return true;
            }
            return false;
        }
        destroy() {
            this.owner.destroy(true);
        }
    }

    class End extends Laya.Script3D {
        constructor() {
            super(...arguments);
            this.isOver = false;
        }
        onUpdate() {
            if (!this.isOver) {
                if (!this.trans) {
                    this.trans = this.owner.transform;
                }
                if (this.trans.localPositionZ - Global.PlayerPostion.z <= 2) {
                    this.isOver = true;
                    EventManager.inst.Emit(EventManager.FINISH);
                    new OpenModule(ModuleEnume.FINISHUI).execute();
                    if (Global.SceneMK.level == 0) {
                        EventManager.inst.Emit(EventManager.EndlessEnd);
                        new OpenModule(ModuleEnume.FINISHUI).execute();
                    }
                }
            }
        }
    }

    class RotaSelf extends Laya.Script3D {
        constructor() {
            super(...arguments);
            this.speed = 45;
            this.startAngle = 0;
        }
        onAwake() {
            this.owner.transform.localRotationEulerY = this.startAngle;
        }
        onUpdate() {
            this.owner.transform.localRotationEulerY += this.speed * Laya.timer.delta * 0.001;
        }
    }

    class CirLittle extends Laya.Script3D {
        constructor() {
            super(...arguments);
            this.speed = 80;
        }
        onUpdate() {
            this.owner.transform.localRotationEulerZ += this.speed * Laya.timer.delta * 0.001;
            if (this.owner.transform.localRotationEulerZ > 60) {
                this.speed = -80;
            }
            else if (this.owner.transform.localRotationEulerZ < -60) {
                this.speed = 80;
            }
        }
    }

    var min = -7.5;
    var max = 7.5;
    class MoveBarrier extends Laya.Script3D {
        constructor() {
            super(...arguments);
            this.speed = 5;
            this.angleSpeed = 45;
        }
        onAwake() {
            this.wall = this.owner.getChildAt(0);
        }
        onUpdate() {
            if (this.wall.destroyed)
                return;
            this.wall.transform.position.x += this.speed * Laya.timer.delta * 0.001;
            if (this.wall.transform.position.x < min) {
                this.wall.transform.position.x = min;
                this.speed = 5;
                this.angleSpeed = -180;
            }
            else if (this.wall.transform.position.x > max) {
                this.wall.transform.position.x = max;
                this.speed = -5;
                this.angleSpeed = 180;
            }
            this.wall.transform.localRotationEulerX += this.angleSpeed * Laya.timer.delta * 0.001;
            this.wall.transform.position = this.wall.transform.position;
        }
    }

    class HaveHpBarrier extends Laya.Script3D {
        constructor() {
            super(...arguments);
            this.hp = 20;
        }
        onAwake() {
            this.r = this.owner.getComponent(Laya.Rigidbody3D);
            this.r.angularFactor = new Laya.Vector3(0, 0, 0);
            this.r.linearFactor = new Laya.Vector3(0, 0, 1);
            this.r.linearDamping = 1.1;
            this.r.mass = 100;
        }
        onUpdate() {
            this.r.angularVelocity = new Laya.Vector3(0, 0, 0);
        }
        onCollisionEnter(c) {
            var other = c.other;
            if (other.owner.name == 'Bullet') {
                this.hp--;
            }
            if (this.hp <= 0) {
                Laya.timer.frameOnce(1, this.owner, this.owner.destroy, [true]);
            }
        }
    }

    const itemGroup = Laya.Physics3DUtils.COLLISIONFILTERGROUP_CUSTOMFILTER3;
    const itemWithGroup = Laya.Physics3DUtils.COLLISIONFILTERGROUP_DEFAULTFILTER | Laya.Physics3DUtils.COLLISIONFILTERGROUP_CUSTOMFILTER2 | Laya.Physics3DUtils.COLLISIONFILTERGROUP_CUSTOMFILTER3;
    class ItemSet extends Laya.Script3D {
        constructor() {
            super(...arguments);
            this.rs = [];
            this.pc = [];
            this.actived = false;
            this.colorID = 0;
        }
        onAwake() {
            this.s3d = this.owner;
            this.tran = this.s3d.transform;
            this.setCollisionGrunp(this.s3d, itemGroup, itemWithGroup);
            if (this.colorID > 0) {
                this._setColor(this.s3d, this.colorID == 1);
            }
        }
        onUpdate() {
            if (Global.isPlaying) {
                if (!this.actived) {
                    var d = this.tran.position.z - Global.PlayerPostion.z;
                    if (d <= Global.bulletMaxDistance * 2) {
                        this.activeRigidboy();
                    }
                }
            }
        }
        activeRigidboy() {
            for (var i = 0; i < this.rs.length; i++) {
                this.rs[i].enabled = true;
            }
            for (var i = 0; i < this.pc.length; i++) {
                this.pc[i].enabled = true;
            }
            this.actived = true;
        }
        setCollisionGrunp(obj, group, withGroup) {
            this.attachComponent(obj);
            var r = obj.getComponent(Laya.Rigidbody3D);
            if (r) {
                this.rs.push(r);
                r.collisionGroup = group;
                r.canCollideWith = withGroup;
                r.restitution = 0.3;
                r.friction = 0.1;
                r.enabled = false;
                if (this.owner.name == "157") {
                    r.isKinematic = false;
                }
            }
            else {
                var c = obj.getComponent(Laya.PhysicsCollider);
                if (c) {
                    this.pc.push(c);
                    c.collisionGroup = group;
                    c.canCollideWith = withGroup;
                    c.enabled = false;
                    if (obj instanceof Laya.MeshSprite3D) {
                        obj.meshRenderer.material = Global.defaultMat2;
                    }
                }
            }
            for (var i = 0; i < obj.numChildren; i++) {
                this.setCollisionGrunp(obj.getChildAt(i), group, withGroup);
            }
        }
        _setColor(obj, mat1 = true) {
            if (obj.name == 'Enemy' && obj instanceof Laya.MeshSprite3D) {
                obj.meshRenderer.material = Global.defaultMat1;
            }
            if (obj.name == "Wall" && obj instanceof Laya.MeshSprite3D) {
                obj.meshRenderer.material = Global.defaultMat2;
            }
            for (var i = 0; i < obj.numChildren; i++) {
                this._setColor(obj.getChildAt(i), mat1);
            }
        }
        attachComponent(obj) {
            switch (obj.name) {
                case 'End':
                    obj.addComponent(End);
                    break;
                case 'Boom':
                    if (obj.transform.localScaleY == 0.5) {
                        obj.transform.localPositionY = 0.45;
                    }
                    if (obj.transform.localScaleY == 1) {
                        obj.transform.localPositionY = 0.8;
                    }
                    if (obj.transform.localScaleY == 2) {
                        obj.transform.localPositionY = 1;
                    }
                    if (obj.transform.localScaleY == 3) {
                        obj.transform.localPositionY = 1.4;
                    }
                    obj.addComponent(Boom);
                    break;
                case 'Drap':
                    obj.addComponent(Drap);
                    break;
                case 'Wheel_01':
                    obj.addComponent(Wheel);
                    break;
                case 'RotaSelf':
                    obj.addComponent(RotaSelf);
                    break;
                case 'CirLittle':
                    obj.addComponent(CirLittle);
                    break;
                case 'Move_Barrier':
                    obj.addComponent(MoveBarrier);
                    break;
                case 'HaveHpBarrier':
                    obj.addComponent(HaveHpBarrier);
                    break;
            }
        }
    }

    class FadeDestroy extends Laya.Script3D {
        constructor() {
            super(...arguments);
            this.alpha = 1;
        }
        onAwake() {
        }
        onUpdate() {
            this.owner.destroy(true);
        }
    }

    class DestroyPlane extends Laya.Script3D {
        constructor() {
            super(...arguments);
            this.pool = [];
        }
        onTriggerEnter(other) {
            var s3d = other.owner;
            if (s3d.name == 'Enemy') {
                s3d.addComponent(FadeDestroy);
            }
        }
        onLateUpdate() {
            for (var i = 0; i < this.pool.length; i++) {
                this.pool[i].destroy(true);
            }
        }
    }

    class CameraManager {
        constructor() {
            if (CameraManager.m_instance != null) {
                console.error("This class is a single class !!!!!!!!!  new CameraManager()  ?????");
                return;
            }
            CameraManager.m_instance = this;
            this.init();
        }
        static get Instance() {
            if (CameraManager.m_instance == null)
                CameraManager.m_instance = new CameraManager();
            return CameraManager.m_instance;
        }
        init() {
        }
        setMainCamera(_camera) {
            this.m_mainCamera = _camera;
        }
        getCameraLocation3Dto2D(_point) {
            let _outPos = new Laya.Vector3();
            this.m_mainCamera.viewport.project(_point, this.m_mainCamera.projectionViewMatrix, _outPos);
            let _potin = new Laya.Point(_outPos.x / Laya.stage.clientScaleX, _outPos.y / Laya.stage.clientScaleY);
            return _potin;
        }
    }
    CameraManager.m_instance = null;

    class BattleUIProgressComd extends BattleUIProxy {
        constructor(_vlaue) {
            super();
            this.model.proportion = _vlaue * 100;
        }
        setValue(_vlaue) {
            this.model.proportion = _vlaue * 100;
            return this;
        }
        execute() {
            this.refresh();
        }
        ICommand() { }
    }

    class BaseSkill extends Laya.Script3D {
        constructor() {
            super(...arguments);
            this.isTrigger = false;
            this.skillTimer = 0;
            this.hitCount = 0;
            this.duration = 4000;
            this.triggerCount = 100;
        }
        onAwake() {
            this.c = new BattleUIProgressComd(0);
            this.player = this.owner.getComponent(Player);
        }
    }

    class BigSkill extends BaseSkill {
        onUpdate() {
            if (!this.isTrigger) {
                this.hitCount += Global.hitCountPerFrame;
                this.c.setValue(this.hitCount / this.triggerCount);
                this.c.execute();
                if (this.hitCount > this.triggerCount) {
                    this.hitCount = 0;
                    this.isTrigger = true;
                    this.startSkill();
                }
            }
            else {
                this.skillTimer += Laya.timer.delta;
                if (this.skillTimer >= this.duration) {
                    this.skillTimer = 0;
                    this.isTrigger = false;
                    this.endSkill();
                }
            }
        }
        startSkill() {
            this.player.setBulletScale(2);
        }
        endSkill() {
            this.player.setBulletScale(1);
        }
    }

    class CurveSkill extends BaseSkill {
        constructor() {
            super(...arguments);
            this.offset = 0;
        }
        onAwake() {
            this.c = new BattleUIProgressComd(0);
            this.player = this.owner.getComponent(Player);
        }
        onUpdate() {
            if (!this.isTrigger) {
                this.hitCount += Global.hitCountPerFrame;
                this.c.setValue(this.hitCount / this.triggerCount);
                this.c.execute();
                if (this.hitCount > this.triggerCount) {
                    this.hitCount = 0;
                    this.isTrigger = true;
                    this.startSkill();
                }
            }
            else {
                this.skillTimer += Laya.timer.delta;
                if (this.skillTimer >= this.duration * 4) {
                    this.skillTimer = 0;
                    this.isTrigger = false;
                    this.endSkill();
                }
                else {
                    this.player.bulletSpeedX = this.offset;
                }
            }
        }
        startSkill() {
            var t = 30;
            this.player.bulletSpeedX = 20;
            this.oldColorID = this.player.bulletColorID;
            this.player.bulletColorID = 8;
            this.offset = t;
            Laya.Tween.to(this, { offset: -t }, this.duration);
            Laya.Tween.to(this, { offset: t }, this.duration, Laya.Ease.quadInOut, null, this.duration);
            Laya.Tween.to(this, { offset: -t }, this.duration, Laya.Ease.quadInOut, null, this.duration * 2);
            Laya.Tween.to(this, { offset: t }, this.duration, Laya.Ease.quadInOut, null, this.duration * 3);
        }
        endSkill() {
            this.player.bulletColorID = undefined;
            this.offset = 0;
            this.player.bulletSpeedX = this.oldColorID;
        }
    }

    class BattleUIAddGoldComd extends BattleUIProxy {
        constructor() {
            super();
        }
        addValue(_vlaue) {
            this.model.gold++;
            return this;
        }
        execute() {
            this.refresh();
        }
        ICommand() { }
    }

    class BattleUILevelProgressComd extends BattleUIProxy {
        constructor(_vlaue) {
            super();
            this.model.levelProgress = _vlaue * 100;
        }
        setValue(_vlaue) {
            this.model.levelProgress = _vlaue * 100;
            return this;
        }
        execute() {
            this.refresh();
        }
        ICommand() { }
    }

    class TaskUIChageDayComd extends TaskUIProxy {
        constructor() {
            super();
            for (let i = 0; i < this.model.loginDayArr.length; i++) {
                let _boole = this.model.loginDayArr[i];
                if (_boole == false) {
                    if (i == 0) {
                        this.model.loginDayArr[i] = true;
                    }
                    if (i > 0 && this.model.loginDayArr[i - 1] == true && this.model.dayReceiveArr[i - 1] == true) {
                        this.model.loginDayArr[i] = true;
                    }
                    break;
                }
            }
            LocalStorage.setJSON('loginDayArr', this.model.loginDayArr);
        }
        execute() {
            this.refresh();
        }
        ICommand() { }
    }

    class TaskUIClearDailyTasksComd extends TaskUIProxy {
        constructor() {
            super();
            this.model.everydayDiamond = 0;
            this.model.everydayGold = 0;
            LocalStorage.setItem('每日任务1领取', 'false');
            LocalStorage.setItem('每日任务2领取', 'false');
            LocalStorage.setItem('每日任务3领取', 'false');
        }
        execute() {
            this.refresh();
        }
        ICommand() { }
    }

    class DateManager {
        constructor() {
            if (DateManager.m_instance != null) {
                console.error("This class is a single class !!!!!!!!!  new DateManager()  ?????");
                return;
            }
            DateManager.m_instance = this;
            this.init();
        }
        static get Instance() {
            if (DateManager.m_instance == null)
                DateManager.m_instance = new DateManager();
            return DateManager.m_instance;
        }
        static Start() {
        }
        init() {
            let _day = LocalStorage.getItem('DateManager_day');
            if (_day) {
                this.day = Number(_day);
            }
            else {
                this.day = new Date().getDay();
            }
            Laya.timer.loop(30000, this, this.timerUpdate);
        }
        timerUpdate() {
            let _day = new Date().getDay();
            if (_day == this.day)
                return;
            LocalStorage.setItem('DateManager_day', _day.toString());
            new TaskUIChageDayComd().execute();
            new TaskUIClearDailyTasksComd().execute();
            new LuckUIAddNumberComd(1).execute();
        }
        static getCurTime() {
            return Date.parse(Date());
        }
        static saveCurTime() {
            this.curTime = Date.parse(Date());
        }
    }
    DateManager.m_instance = null;
    DateManager.curTime = 0;

    class BattleUIGetProComd extends BattleUIProxy {
        constructor() {
            super();
            this.gold = this.model.gold;
            this.proportion = this.model.proportion;
            this.levelProgress = this.model.levelProgress;
            this.score = this.model.score;
        }
        execute() {
        }
        ICommand() { }
    }

    class PlayerNode extends Laya.Script3D {
        constructor() {
            super(...arguments);
            this.speed = 18;
            this.isMoving = false;
        }
        onAwake() {
            this.trans = this.owner.transform;
            this.player = this.owner.getChildAt(0).getComponent(Player);
            EventManager.inst.AddNotice(EventManager.PLAY, this, this.begin);
            EventManager.inst.AddNotice(EventManager.END, this, this.end);
            EventManager.inst.AddNotice(EventManager.FINISH, this, this.end);
            EventManager.inst.AddNotice(EventManager.MYEND, this, this.myend);
            EventManager.inst.AddNotice(EventManager.MYBEGIN, this, this.mybegin);
        }
        onUpdate() {
            if (this.isMoving) {
                this.trans.position.z += this.speed * Laya.timer.delta * 0.001;
                this.trans.position = this.trans.position;
            }
        }
        onDestroy() {
            EventManager.inst.RemoveNotice(EventManager.PLAY, this, this.begin);
            EventManager.inst.RemoveNotice(EventManager.END, this, this.end);
            EventManager.inst.RemoveNotice(EventManager.MYEND, this, this.myend);
            EventManager.inst.RemoveNotice(EventManager.MYBEGIN, this, this.mybegin);
            EventManager.inst.AddNotice(EventManager.FINISH, this, this.end);
        }
        myend() {
            this.isMoving = false;
        }
        mybegin() {
            if (this.player.currentID == 0) {
                return;
            }
            this.isMoving = true;
        }
        begin() {
            if (this.player.currentID == 0) {
                return;
            }
            this.isMoving = true;
        }
        end() {
            Laya.timer.clearAll(this);
            this.isMoving = false;
        }
    }
    var trailUrls = [
        Global.localSven3DAssetsPreload + '/LayaScene_Man/Conventional/Trail.lh',
        Global.localSven3DAssetsPreload + '/LayaScene_Man/Conventional/Trail_01.lh',
        Global.localSven3DAssetsPreload + '/LayaScene_Man/Conventional/Trail_02.lh',
        Global.localSven3DAssetsPreload + '/LayaScene_Man/Conventional/Trail_03.lh',
        Global.localSven3DAssetsPreload + '/LayaScene_Man/Conventional/Trail_04.lh',
        Global.localSven3DAssetsPreload + '/LayaScene_Man/Conventional/Trail_05.lh',
        Global.localSven3DAssetsPreload + '/LayaScene_Man/Conventional/Trail_06.lh',
        Global.localSven3DAssetsPreload + '/LayaScene_Man/Conventional/Trail_07.lh',
        Global.localSven3DAssetsPreload + '/LayaScene_Man/Conventional/Trail_08.lh',
        Global.localSven3DAssetsPreload + '/LayaScene_Man/Conventional/Trail_09.lh'
    ];
    var delta;
    class Player extends Laya.Script3D {
        constructor() {
            super(...arguments);
            this.lastX = GameConfig.width / 2;
            this.lastY = GameConfig.height - GameConfig.height / 5;
            this.dirX = 0;
            this.dirY = 0;
            this.up = new Laya.Vector3(0, 1, 0);
            this.isStartMove = false;
            this.isPlaying = false;
            this.currentID = 0;
            this.cacheColor = [];
            this.spawnSpeed = 80;
            this.bulletScale = new Laya.Vector3(1, 1, 1);
            this.bulletSpeedZ = 100;
            this.bulletSpeedX = 0;
            this.bulletSpeedY = 0;
            this.bulletDistance = 80;
            this.bulletPos = new Laya.Vector3();
            this.m_battleUIAddGoldComd = new BattleUIAddGoldComd();
        }
        onAwake() {
            delta = 30 / Laya.stage.width;
            this.progress = new BattleUILevelProgressComd(0);
        }
        onStart() {
            this.init();
        }
        init() {
            this.player = this.owner;
            this.player.transform.localRotationEulerY = 180;
            Laya.stage.on(Laya.Event.MOUSE_DOWN, this, this._onMouseDown);
            Laya.stage.on(Laya.Event.MOUSE_MOVE, this, this._onMouseDrag);
            EventManager.inst.AddNotice(EventManager.PLAY, this, this.Begin);
            EventManager.inst.AddNotice(EventManager.END, this, this.End);
            EventManager.inst.AddNotice(EventManager.DEAD, this, this.Death);
            EventManager.inst.AddNotice(EventManager.FINISH, this, this.Finish);
            EventManager.inst.AddNotice(EventManager.RoleUIEvent, this, this.UIWindow);
            EventManager.inst.AddNotice(EventManager.RoleEvent, this, this.LoadModel);
            EventManager.inst.AddNotice(EventManager.SCALEBULLET, this, this.setBulletScale);
            EventManager.inst.AddNotice(EventManager.MYEND, this, this.myend);
            EventManager.inst.AddNotice(EventManager.MYBEGIN, this, this.mybegin);
            var rigidbody = this.owner.addComponent(Laya.Rigidbody3D);
            var shape = new Laya.CapsuleColliderShape(0.5, 1.5);
            shape.localOffset = new Laya.Vector3(0, 0.8, 0);
            rigidbody.colliderShape = shape;
            rigidbody.collisionGroup = Laya.Physics3DUtils.COLLISIONFILTERGROUP_DEFAULTFILTER;
            rigidbody.canCollideWith = Laya.Physics3DUtils.COLLISIONFILTERGROUP_CUSTOMFILTER3;
            rigidbody.isTrigger = true;
            rigidbody.isKinematic = true;
            var vo = new RoleUIGetSelectRoleVoComd().roleVo;
            this.LoadModel(vo);
        }
        onDestroy() {
            Laya.stage.off(Laya.Event.MOUSE_DOWN, this, this._onMouseDown);
            Laya.stage.off(Laya.Event.MOUSE_MOVE, this, this._onMouseDrag);
            EventManager.inst.RemoveNotice(EventManager.PLAY, this, this.Begin);
            EventManager.inst.RemoveNotice(EventManager.END, this, this.End);
            EventManager.inst.RemoveNotice(EventManager.DEAD, this, this.Death);
            EventManager.inst.RemoveNotice(EventManager.FINISH, this, this.Finish);
            EventManager.inst.RemoveNotice(EventManager.RoleUIEvent, this, this.UIWindow);
            EventManager.inst.RemoveNotice(EventManager.SCALEBULLET, this, this.setBulletScale);
            EventManager.inst.RemoveNotice(EventManager.MYBEGIN, this, this.mybegin);
            EventManager.inst.RemoveNotice(EventManager.MYEND, this, this.myend);
            Laya.timer.clear(this, this.spwanBullet);
        }
        myend() {
            this.player.active = false;
            Laya.timer.clear(this, this.spwanBullet);
        }
        mybegin() {
            this.player.active = true;
            this.player.transform.localRotationEulerY = 0;
            this.animator.play('body_run_01');
            this.animator.speed = 3;
            DateManager.saveCurTime();
            this.startBullet();
        }
        setBulletScale(scale) {
            this.bulletScale.setValue(scale, scale, scale);
        }
        LoadModel(vo) {
            this.vo = vo;
            var id = vo.modelID;
            var r = id + '';
            if (id < 10) {
                r = '0' + r;
            }
            this.bulletColorID = vo.bulletColorID;
            this.spawnSpeed = 1000 / vo.bulletSpawnSpeed;
            this.bulletSpeedZ = vo.bulletSpeed;
            Global.bulletMaxDistance = this.bulletDistance = vo.bulletDistance;
            Laya.Sprite3D.load(Global.localSven3DAssetsPreload + '/LayaScene_Man/Conventional/body_mod_' + r + '.lh', Laya.Handler.create(this, this.onModelLoad, [id, vo.unlock]));
        }
        onModelLoad(id, unlock, s) {
            if (this.model) {
                this.player.removeChild(this.model);
                this.model.destroy(true);
                Laya.Resource.destroyUnusedResources();
            }
            this.model = Laya.Sprite3D.instantiate(s);
            for (var i = 0; i < this.model.numChildren; i++) {
                var child = this.model.getChildAt(i);
                if (child instanceof Laya.SkinnedMeshSprite3D) {
                    child.skinnedMeshRenderer.castShadow = true;
                }
                if (child instanceof Laya.MeshSprite3D) {
                    child.meshRenderer.castShadow = true;
                }
            }
            this.model.transform.localPositionX = 0;
            this.model.transform.localPositionY = 0;
            this.model.transform.localPositionZ = 0;
            if (unlock && id != this.currentID) {
                this.cacheModel = this.model.clone();
                this.currentID = id;
            }
            if (!unlock) {
                for (var i = 0; i < this.model.numChildren; i++) {
                    var child = this.model.getChildAt(i);
                    if (child instanceof Laya.SkinnedMeshSprite3D) {
                        for (var j = 0; j < child.skinnedMeshRenderer.materials.length; j++) {
                            this.cacheColor.push(child.skinnedMeshRenderer.materials[j].albedoColor);
                            child.skinnedMeshRenderer.materials[j].albedoColor = new Laya.Vector4(0, 0, 0, 1);
                        }
                    }
                }
            }
            this.player.addChild(this.model);
            this.animator = this.model.getComponent(Laya.Animator);
            this.animator.play('body_dance_01');
            var trail = Laya.Sprite3D.load(trailUrls[this.vo.trailID], Laya.Handler.create(this, this.addTrail));
        }
        addTrail(s) {
            this.player.addChild(s);
        }
        _onMouseDown() {
            if (!this.isPlaying) {
                return;
            }
            if (!this.isStartMove) {
                this.isStartMove = true;
            }
            this.lastX = Laya.stage.mouseX;
            this.lastY = Laya.stage.mouseY;
        }
        _onMouseDrag() {
            if (!this.isPlaying) {
                return;
            }
            var deltaX = Laya.stage.mouseX - this.lastX;
            var deltaY = Laya.stage.mouseY - this.lastY;
            this.dirX = deltaX;
            this.dirY = deltaY;
            this.lastX = Laya.stage.mouseX;
            this.lastY = Laya.stage.mouseY;
            this.player.transform.localPositionX -= this.dirX * delta;
            this.player.transform.localPositionZ -= this.dirY * delta * 0.5;
            this.player.transform.localPositionX = Math.max(this.player.transform.localPositionX, -5);
            this.player.transform.localPositionX = Math.min(this.player.transform.localPositionX, 5);
            this.player.transform.localPositionZ = Math.min(this.player.transform.localPositionX, -10);
            this.player.transform.localPositionY = 0;
        }
        startBullet() {
            Laya.timer.loop(this.spawnSpeed, this, this.spwanBullet);
        }
        spwanBullet() {
            this.bulletPos.x = this.player.transform.position.x;
            this.bulletPos.z = this.player.transform.position.z + 3;
            this.bulletPos.y = this.bulletScale.y / 2 + 0.2;
            var bullet = BulletPool.inst.GetBullet(this.bulletColorID);
            bullet.Set(this.bulletSpeedZ, this.bulletScale, this.bulletDistance, this.bulletPos, this.bulletSpeedX, this.bulletSpeedY);
            SoundCtrl.inst.PlayShoot();
        }
        onUpdate() {
            Global.PlayerPostion = this.owner.transform.position;
            if (this.isPlaying) {
                this.progress.setValue(Global.PlayerPostion.z / Global.SceneMK.length);
            }
        }
        onLateUpdate() {
            BulletPool.inst.com.add(Global.hitCountPerFrame);
            Global.hitCountPerFrame = 0;
        }
        Begin() {
            if (this.currentID == 0) {
                return;
            }
            Global.hitCount = 0;
            Global.hitCountPerFrame = 0;
            this.isPlaying = true;
            var skill;
            switch (this.vo.skillID) {
                case 0:
                    skill = this.player.addComponent(BigSkill);
                    break;
                case 1:
                    skill = this.player.addComponent(CurveSkill);
                    break;
            }
            if (skill) {
                skill.triggerCount = this.vo.skillHitTriggerCount;
                skill.duration = this.vo.skillDuration;
            }
            this.player.transform.localRotationEulerY = 0;
            this.animator.play('body_run_01');
            this.animator.speed = 3;
            this.startBullet();
            Global.cameraFollow.ResetView(25, 30, 10, 1000);
            Global.isPlaying = true;
        }
        Finish() {
            this.player.transform.localRotationEulerY = 180;
            this.animator.play('body_dance_01');
            this.animator.speed = 1;
            this.End();
            Global.cameraFollow.Target = this.player.transform;
            Global.cameraFollow.ResetView(20, 15, 0, 500);
        }
        End() {
            Global.hitCount = 0;
            Global.hitCountPerFrame = 0;
            Global.isPlaying = false;
            this.isPlaying = false;
            Laya.timer.clear(this, this.spwanBullet);
        }
        Death() {
            Laya.timer.frameOnce(1, this, this._Death);
        }
        _Death() {
            var parent = this.player.parent;
            var pos = this.player.transform.position.clone();
            pos.y = 2;
            var mat = new Laya.PBRStandardMaterial();
            mat.albedoColor = new Laya.Vector4(0, 1, 0, 1);
            for (var i = 0; i < 20; i++) {
                var box = new Laya.MeshSprite3D(Laya.PrimitiveMesh.createBox(0.3, 0.3, 0.3));
                box.meshRenderer.material = mat;
                parent.addChild(box);
                box.transform.position = pos;
                var rigidBody = box.addComponent(Laya.Rigidbody3D);
                var shape = new Laya.BoxColliderShape(0.2, 0.2, 0.2);
                rigidBody.colliderShape = shape;
                rigidBody.mass = 5;
                rigidBody.gravity = new Laya.Vector3(0, -50, 0);
                rigidBody.collisionGroup = Laya.Physics3DUtils.COLLISIONFILTERGROUP_CUSTOMFILTER3;
                rigidBody.canCollideWith = Laya.Physics3DUtils.COLLISIONFILTERGROUP_DEFAULTFILTER;
                rigidBody.applyImpulse(new Laya.Vector3((Math.random() - 0.5) * 30, Math.random() * 30, (Math.random() - 0.5) * 30));
            }
            this.player.active = false;
        }
        UIWindow(r) {
            if (r) {
                Global.cameraFollow.offsetY = -3;
                Global.cameraFollow.ResetView(20, 15, -6, 0);
                this.cacheModel = this.model.clone();
            }
            else {
                Global.cameraFollow.offsetY = 0;
                Global.cameraFollow.offsetZ = 0;
                Global.cameraFollow.ResetView(20, 15, 0, 0);
                if (this.cacheModel) {
                    this.player.removeChild(this.model);
                    this.model.destroy(true);
                    this.model = this.cacheModel;
                    this.player.addChild(this.cacheModel);
                    this.animator = this.model.getComponent(Laya.Animator);
                    this.animator.play('body_dance_01');
                    this.cacheModel = null;
                }
            }
        }
        onTriggerEnter(other) {
            if (DateManager.getCurTime() - DateManager.curTime <= 1000)
                return;
            if (other.owner.name == 'Start')
                return;
            switch (other.owner.name) {
                case 'EndCube':
                    break;
                case 'Coin':
                    BulletPool.inst.score.addValue(10);
                    SoundCtrl.inst.Coin();
                    this.m_battleUIAddGoldComd.addValue(1).execute();
                    other.owner.active = false;
                    Laya.timer.frameOnce(1, other.owner, other.owner.destroy);
                    break;
                default:
                    if (Global.SceneMK.level == 0) {
                        EventManager.inst.Emit(EventManager.EndlessEnd);
                    }
                    EventManager.inst.Emit(EventManager.MYEND);
                    Global.gold = new BattleUIGetProComd().gold;
                    Global.proportion = new BattleUIGetProComd().proportion;
                    Global.levelProgress = new BattleUIGetProComd().levelProgress;
                    Global.score = new BattleUIGetProComd().score;
                    new OpenModule(ModuleEnume.GameOverUI).execute();
                    break;
            }
        }
    }

    class CameraFollow extends Laya.Script3D {
        constructor() {
            super();
            this.offset = new Laya.Vector3();
            this.angle = 0;
            this.newAngle = 20;
            this.distance = 0;
            this.newDistance = 15;
            this.offsetY = 0;
            this.offsetZ = 0;
            this.newOffsetZ = 0;
            this.shakeOffset = new Laya.Vector3();
            this.shakeTarget = new Laya.Vector3(0.5, 0.6, 0.6);
            this.shakeTarget2 = new Laya.Vector3(-0.8, -0.7, -0.2);
            this.shakeZero = new Laya.Vector3();
            Global.cameraFollow = this;
            Laya.stage.on(Laya.Event.KEY_DOWN, null, () => {
                this.newDistance += 5;
            });
        }
        set Target(value) {
            this.target = value;
        }
        get Distance() {
            return this.distance;
        }
        set Distance(value) {
            this.newDistance = value;
        }
        get Angle() {
            return this.angle;
        }
        set Angle(value) {
            this.newAngle = value;
        }
        get OffsetZ() {
            return this.offsetZ;
        }
        set OffsetZ(v) {
            this.newOffsetZ = v;
        }
        ResetView(angle, distance, offsetZ, duration) {
            Laya.Tween.to(this, { newDistance: distance }, duration);
            Laya.Tween.to(this, { newAngle: angle }, duration);
            Laya.Tween.to(this, { newOffsetZ: offsetZ }, duration);
        }
        calc() {
            var axis = new Laya.Vector3(0, 0, -1);
            var q = new Laya.Quaternion();
            Laya.Quaternion.createFromAxisAngle(new Laya.Vector3(1, 0, 0), Laya.Utils.toRadian(this.angle), q);
            Laya.Vector3.transformQuat(axis, q, axis);
            Laya.Vector3.normalize(axis, axis);
            Laya.Vector3.scale(axis, this.distance, this.offset);
        }
        onAwake() {
            this.trans = this.owner.transform;
        }
        Shake() {
            Laya.Tween.to(this.shakeOffset, this.shakeTarget, 50, Laya.Ease.bounceIn);
            Laya.Tween.to(this.shakeOffset, this.shakeTarget2, 50, Laya.Ease.bounceIn, null, 50);
            Laya.Tween.to(this.shakeOffset, this.shakeZero, 100, Laya.Ease.bounceOut, null, 100);
        }
        onUpdate() {
            if (this.distance !== this.newDistance || this.angle != this.newAngle) {
                this.distance = this.newDistance;
                this.angle = this.newAngle;
                this.calc();
                Laya.Vector3.add(this.target.position, this.offset, this.trans.position);
                this.trans.position = this.trans.position;
                this.trans.lookAt(this.target.position, new Laya.Vector3(0, 1, 0), true);
            }
            if (this.target) {
                Laya.Vector3.add(this.target.position, this.offset, this.trans.position);
                this.trans.position.x += this.shakeOffset.x;
                this.trans.position.y += this.shakeOffset.y + this.offsetY;
                this.trans.position.z += this.shakeOffset.z + this.newOffsetZ;
                this.trans.position = this.trans.position;
            }
        }
    }

    class CoinTool {
        static CreateCoin(x, z, startAngle) {
            var item = Laya.MeshSprite3D.instantiate(Laya3DPrefabManager$1.Instance.coin);
            item.transform.setWorldLossyScale(new Laya.Vector3(2, 2, 2));
            item.name = 'Coin';
            var r = item.addComponent(Laya.Rigidbody3D);
            r.isTrigger = true;
            r.isKinematic = true;
            r.collisionGroup = Laya.Physics3DUtils.COLLISIONFILTERGROUP_CUSTOMFILTER3;
            var shape = new Laya.BoxColliderShape(1, 1, 1);
            r.colliderShape = shape;
            var rs = item.addComponent(RotaSelf);
            rs.speed = 240;
            rs.startAngle = startAngle;
            item.transform.position.x = x;
            item.transform.position.y = 1.4;
            item.transform.position.z = z;
            item.transform.position = item.transform.position;
            return item;
        }
        static Layout1(width, startLen, len) {
            for (var z = startLen; z < len; z += width) {
                for (var x = -7; x <= 7; x += width) {
                    var item = CoinTool.CreateCoin(x, z, 0);
                    Global.gameMainScene.addChild(item);
                }
            }
        }
        static Layout(count, z, startAngle, startX = -7.5, endX = 7.5, offsetX = 0) {
            var step = (endX - startX) / (count + 1);
            for (var i = 1; i <= count; i++) {
                var x = startX + i * step + offsetX;
                var item = CoinTool.CreateCoin(x, z, startAngle);
                Global.gameMainScene.addChild(item);
            }
        }
    }

    const ItemLibrary = Global.localSven3DAssetsPreload + '/LayaScene_ItemLibrary/Conventional/';
    const itemGroup$1 = Laya.Physics3DUtils.COLLISIONFILTERGROUP_CUSTOMFILTER3;
    const itemWithGroup$1 = Laya.Physics3DUtils.COLLISIONFILTERGROUP_DEFAULTFILTER | Laya.Physics3DUtils.COLLISIONFILTERGROUP_CUSTOMFILTER2 | Laya.Physics3DUtils.COLLISIONFILTERGROUP_CUSTOMFILTER3;
    class SceneMaker {
        constructor(levelID) {
            this.items = [];
            this.length = 1;
            console.log('load level:', levelID);
            if (Global.SceneMK) {
                Global.SceneMK.Destroy();
            }
            BulletPool.inst.Init();
            Global.SceneMK = this;
            this.level = levelID;
        }
        LoadScene(onload) {
            this.onLoad = onload;
            var scene = this.scene = new Laya.Scene3D();
            ParticlePool.node = new Laya.Sprite3D();
            scene.addChild(ParticlePool.node);
            scene.enableFog = true;
            scene.fogColor = new Laya.Vector3(0.4, 0.8, 0.6);
            scene.fogStart = 50;
            scene.fogRange = 2000;
            scene.physicsSimulation.gravity = new Laya.Vector3(0, -10, 0);
            Global.gameMainScene = scene;
            LayerManager.Instance.laya3DLayer.addChild(scene);
            scene.ambientColor = new Laya.Vector3(0.6, 0.6, 0.6);
            var light = new Laya.DirectionLight();
            light.intensity = 0.7;
            var mat = light.transform.worldMatrix;
            mat.setForward(new Laya.Vector3(-0.6, -1, 1));
            light.transform.worldMatrix = mat;
            scene.addChild(light);
            var camera = new Laya.Camera();
            camera.clearColor = new Laya.Vector4(0.3, 0.7, 0.5, 1);
            camera.fieldOfView = 75;
            camera.farPlane = 2000;
            camera.nearPlane = 0.3;
            CameraManager.Instance.setMainCamera(camera);
            var player = new Laya.Sprite3D();
            player.transform.translate(new Laya.Vector3(0, 0, -6), true);
            player.addComponent(Player);
            var playerParentNode = new Laya.Sprite3D();
            playerParentNode.transform.translate(new Laya.Vector3(0, 0, 20));
            playerParentNode.addChild(player);
            playerParentNode.addComponent(PlayerNode);
            scene.addChild(playerParentNode);
            var cf = camera.addComponent(CameraFollow);
            cf.Target = playerParentNode.transform;
            scene.addChild(camera);
            var road = Laya.Sprite3D.instantiate(Laya3DPrefabManager$1.Instance.road);
            road.meshRenderer.receiveShadow = true;
            road.transform.localScaleZ = 10000;
            scene.addChild(road);
            var plane = scene.addChild(new Laya.Sprite3D);
            var planeStaticCollider = plane.addComponent(Laya.PhysicsCollider);
            var planeShape = new Laya.BoxColliderShape(16, 10, 15000);
            planeShape.localOffset = new Laya.Vector3(0, -5, 7470);
            planeStaticCollider.colliderShape = planeShape;
            planeStaticCollider.friction = 0.001;
            planeStaticCollider.restitution = 0.9;
            planeStaticCollider.collisionGroup = Laya.Physics3DUtils.COLLISIONFILTERGROUP_DEFAULTFILTER;
            planeStaticCollider.canCollideWith = itemGroup$1;
            var p = scene.addChild(new Laya.Sprite3D);
            p.transform.localPositionY = -10;
            p.addComponent(DestroyPlane);
            var pc = p.addComponent(Laya.PhysicsCollider);
            var ps = new Laya.BoxColliderShape(2000, 10, 2000);
            ps.localOffset = new Laya.Vector3(0, -5, 0);
            pc.isTrigger = true;
            pc.colliderShape = ps;
            pc.collisionGroup = Laya.Physics3DUtils.COLLISIONFILTERGROUP_DEFAULTFILTER;
            pc.canCollideWith = itemGroup$1;
            var p2 = player.addChild(new Laya.Sprite3D);
            p2.transform.localPositionZ = -0.2;
            p2.addComponent(DestroyPlane);
            var pc2 = p2.addComponent(Laya.PhysicsCollider);
            var ps2 = new Laya.BoxColliderShape(50, 50, 5);
            ps2.localOffset = new Laya.Vector3(0, -6, -5);
            pc2.isTrigger = true;
            pc2.colliderShape = ps2;
            pc2.collisionGroup = Laya.Physics3DUtils.COLLISIONFILTERGROUP_DEFAULTFILTER;
            pc2.canCollideWith = itemGroup$1;
            var start = Laya.Sprite3D.instantiate(Laya3DPrefabManager$1.Instance.start);
            start.meshRenderer.receiveShadow = true;
            scene.addChild(start);
            start.addComponent(ItemSet);
            start.transform.translate(new Laya.Vector3(0, 0.1, 4));
            var background = Laya.Sprite3D.instantiate(Laya3DPrefabManager$1.Instance.background);
            background.transform.localPositionZ = 2400;
            background.transform.localPositionY = 0;
            playerParentNode.addChild(background);
            var scenario = Laya.Sprite3D.instantiate(Laya3DPrefabManager$1.Instance.defaultScenario);
            scene.addChild(scenario);
            ParticlePool.inst.CreateBoomFX(new Laya.Vector3(0, 0, 0));
            Laya.loader.load('res/configs/LevelJson' + this.level + '.txt', Laya.Handler.create(this, this.onCfgLoad));
        }
        Destroy() {
            Global.gameMainScene = null;
            LayerManager.Instance.laya3DLayer.removeChild(this.scene);
            this.scene.destroy(true);
            Global._defaultMat1 = null;
            Global._defaultMat2 = null;
            Laya.Resource.destroyUnusedResources();
        }
        onCfgLoad() {
            let data = Laya.loader.getRes('res/configs/LevelJson' + this.level + '.txt');
            var arr = Utils.csvToJson(data);
            var resUrls = [];
            for (var i = 0; i < arr.length; i++) {
                if (arr[i].library_id == undefined) {
                    continue;
                }
                var item = new ItemConfig(arr[i]);
                this.items.push(item);
                resUrls.push(item.url);
            }
            Laya.loader.create(resUrls, Laya.Handler.create(this, this.onLibraryLoad));
        }
        onLibraryLoad() {
            var distance = 0;
            for (var i = 0; i < this.items.length; i++) {
                var itemNode = Laya.Sprite3D.instantiate(Laya.loader.getRes(this.items[i].url));
                if (itemNode.name == '25') {
                    itemNode.transform.localPositionY -= 0.5;
                }
                var itemSet = itemNode.addComponent(ItemSet);
                itemSet.colorID = this.items[i].color;
                this.scene.addChild(itemNode);
                distance += this.items[i].distance;
                itemNode.transform.position = new Laya.Vector3(0, 0, distance);
                if (i < this.items.length - 1 && Math.random() > 0.6) {
                    var count = 1;
                    var step = Math.random() * 5 + 12;
                    for (var ci = distance; ci <= distance + 30; ci += step) {
                        var offsetX = 0;
                        var offsetR = Math.random();
                        if (offsetR < 0.33) {
                            offsetX = -4;
                        }
                        else if (offsetR >= 3.3 && offsetR < 4.6) {
                            offsetX = 0;
                        }
                        else {
                            offsetX = 4;
                        }
                        if (offsetX < -7.5) {
                            offsetX = -7.5;
                        }
                        if (offsetX > 7.5) {
                            offsetX = 7.5;
                        }
                        CoinTool.Layout(count, ci, (ci * 20) % 360, -7.5, 7.5, offsetX);
                        if (Math.random() > 0.8) {
                            count += 1;
                        }
                    }
                }
            }
            var end = Laya.Sprite3D.instantiate(Laya3DPrefabManager$1.Instance.end);
            this.scene.addChild(end);
            end.addComponent(ItemSet);
            this.length = distance + 80;
            end.transform.translate(new Laya.Vector3(0, 0, distance + 80));
            var bg = Laya.Sprite3D.instantiate(Laya3DPrefabManager$1.Instance.start);
            end.addChild(bg);
            bg.transform.localPositionY = 0.1;
            bg.transform.localPositionZ = -8;
            SoundCtrl.inst.Faker();
            EventManager.inst.Emit(EventManager.SCENELOADED);
            if (this.onLoad) {
                this.onLoad();
            }
            var count = 1;
            for (var ci = 30; ci <= 40; ci += 5) {
                CoinTool.Layout(count, ci, (ci * 20) % 360);
                count++;
            }
            Laya.Resource.destroyUnusedResources();
        }
    }
    class ItemConfig {
        constructor(json) {
            this.color = Number(json.color);
            this.library_id = Number(json.library_id);
            this.level_id = Number(json.level_id);
            this.area_id = Number(json.area_id);
            this.distance = Number(json.distance);
            this.url = ItemLibrary + json.library_id + '.lh';
        }
    }

    let GameMainScene = class GameMainScene {
        constructor() {
            this.m_timer = Global.gameTimerMax;
            EventManager.inst.AddNotice(EventManager.END, this, this.EndGame);
            EventManager.inst.AddNotice(EventManager.LOADSCENE, this, this.LoadScene);
            EventManager.inst.Emit(EventManager.LOADSCENE, Global.checkPoint);
        }
        LoadScene(args) {
            var s = new SceneMaker(args);
            s.LoadScene();
        }
        BeginGame(args) {
        }
        EndGame(...agrs) {
            ParticlePool.inst.Clear();
        }
        getRandomInt(min, max) {
            var range = max - min;
            var rand = Math.random();
            return (min + Math.round(rand * range));
        }
    };
    GameMainScene = __decorate([
        res_auto_bind()
    ], GameMainScene);
    var GameMainScene$1 = GameMainScene;

    class StartLoader {
        constructor(_callback, _callThis) {
            this.m_callback = _callback;
            this.m_callThis = _callThis;
        }
        start() {
            this.startLoaderResJson();
        }
        startLoaderResJson() {
            var resource = [
                { url: Global.localSvenAssets + "resJson.json", type: Laya.Loader.JSON },
            ];
            Laya.loader.create(resource, Laya.Handler.create(this, this.onPreLoadFinish));
        }
        onPreLoadFinish() {
            let data = Laya.loader.getRes(Global.localSvenAssets + "resJson.json");
            this.textLoaderCall(data);
        }
        textLoaderCall(data) {
            GameConfigManager.Instance.SvenAssetsVo = new SvenAssetsVo().readJson(data);
            new StartLoaderGroup('StartLoader', 'sven_loading').start();
            new ActionTaskQueueCallBack('StartLoader', this.onSvenloadingFinish, this).start();
            new StartLoaderGroup('StartLoader', 'sven_preload').start();
            this.startLoaderConfig();
            new ActionTaskQueueCallBack('StartLoader', this.onLoaded, this).start();
        }
        onSvenloadingFinish() {
            new OpenModule(ModuleEnume.LOADINGUI).execute();
        }
        startLoaderConfig() {
            var resource = [
                { url: Global.localConfig + "RunRunConfig.json", type: Laya.Loader.JSON }
            ];
            Laya.loader.create(resource, Laya.Handler.create(this, this.loaderConfigFinish));
        }
        loaderConfigFinish() {
            let data = Laya.loader.getRes(Global.localConfig + "RunRunConfig.json");
            GameConfigManager.Instance.RoleCfVo = new RoleCfVo().readJson(data);
            GameConfigManager.Instance.LeveCfVo = new LeveCfVo().readJson(data);
        }
        onLoaded() {
            ResLoadManager.LoadRes((r) => {
                new LoadingUIProgressBarComd(1, 1).execute();
                new CloseModule(ModuleEnume.LOADINGUI).execute();
                new OpenModule(ModuleEnume.NAVIGATIONUI).execute();
                new OpenModule(ModuleEnume.TIPSUI).execute();
                new GameMainScene$1();
            }, (v) => {
                let _progress = (Number(v) * 0.5) + 0.5;
                new LoadingUIProgressBarComd(_progress, 1).execute();
            });
        }
    }

    class BattleScene extends ui.View.BattleSceneUI {
        constructor() {
            super();
            this.motions = [];
            this.timeCount = 0;
            TimeUtil.init();
            this.setSetting();
            LayerManager.Instance.layaUILayer.addChild(fgui.GRoot.inst.displayObject);
            Global.Init();
            DateManager.Start();
            new StartLoader(this.onLoaded, this).start();
        }
        onLoaded() {
        }
        setSetting() {
        }
    }

    class BaseManager {
        constructor(id) {
            console.log("BaseManager" + id);
            this.id = id;
        }
        init() { }
        login() { }
        openInsert(callBack) {
            if (this.insertAd)
                this.insertAd.show(callBack);
        }
        openBanner() {
            if (this.bannerAd)
                this.bannerAd.show();
        }
        hideBanner() {
            if (this.bannerAd)
                this.bannerAd.hide();
        }
        destroyBanner() {
            if (this.bannerAd)
                this.bannerAd.destroy();
        }
        openReward(callback) {
            if (this.rewardAd)
                this.rewardAd.show(callback);
        }
        pushNative() {
            if (this.nativeAd)
                this.nativeAd.pushNative();
        }
        delNative() {
            if (this.nativeAd)
                this.nativeAd.delNative();
        }
        getNativeList() {
            var arr = [];
            if (this.nativeAd)
                arr = this.nativeAd.getNativeList();
            return arr;
        }
        getNativeAd() {
            var ad = null;
            if (this.nativeAd)
                ad = this.nativeAd.getNativeAd();
            return ad;
        }
        getNativeShowBanner() {
            var ad = null;
            if (this.nativeAd)
                ad = this.nativeAd.getNativeShowBanner();
            return ad;
        }
        openNative(node, index = 0, posX = 0, posY = 0, isShowBanner = true) {
            if (this.nativeAd)
                this.nativeAd.show(node, index, posX, posY, isShowBanner);
        }
        createMoreGame(node) {
            if (this.moreGame)
                this.moreGame.create(node);
        }
        startRecord() {
            if (this.record)
                this.record.start();
        }
        stopRecord(stopcall) {
            if (this.record)
                this.record.stop(stopcall);
        }
        getRecordState() {
            if (this.record)
                return this.record.state;
        }
        getVideoPath() {
            if (this.record)
                return this.record.videoPath;
        }
        goShare(func, videoPath) {
            if (this.share)
                this.share.goShare(func, videoPath);
        }
        showToast(msg) {
            if (this.util)
                this.util.showToast(msg);
        }
    }

    class BaseInsert {
        constructor(id) {
            this.insertId = '';
            this.insertAd = null;
            this.num = 0;
            this.rewardCallback = null;
            this.insertId = id;
            this.init();
        }
        init() {
            console.log("BaseInsert init");
        }
        show(callBack) {
            console.log('BaseInsert show');
        }
    }

    class TestInsert extends BaseInsert {
        init() {
            console.log("TestInsert init" + this.insertId);
        }
        show() {
            console.log('TestInsert show' + this.num);
        }
    }

    class BaseBanner {
        constructor(id) {
            this.bannerId = '';
            this.bannerAd = null;
            this.num = 0;
            this.bannerId = id;
            this.init();
        }
        init() {
            console.log("BaseBanner init");
        }
        show() {
            console.log('BaseBanner show');
        }
        hide() {
            console.log('BaseBanner hide');
        }
        destroy() {
            console.log('BaseBanner hide');
        }
    }

    class TestBanner extends BaseBanner {
        init() {
            console.log("TestBanner init" + this.bannerId);
        }
        show() {
            console.log('TestBanner show' + this.num);
        }
        hide() {
            console.log('TestBanner hide');
        }
        destroy() {
            console.log('TestBanner destroy');
        }
    }

    class BaseReward {
        constructor(id) {
            this.rewardId = '';
            this.rewardAd = null;
            this.rewardCallback = null;
            this.rewardId = id;
            this.init();
        }
        init() {
            console.log("BaseReward init");
        }
        show(callback) {
            console.log('BaseReward show');
            if (window["myPlatform"] == ChannelID.TEST)
                callback("success");
        }
    }

    class TestReward extends BaseReward {
        init() {
            console.log("TestReward init" + this.rewardId);
        }
        show(callback) {
            console.log('TestReward show' + callback);
            this.rewardCallback = callback;
            this.rewardCallback("success");
        }
    }

    class BaseNative {
        constructor(id) {
            this.nativeId = '';
            this.adList = [];
            this.adNative = null;
            this.num = 0;
            this.nativeId = id;
            this.init();
        }
        init() {
            console.log("BaseNative init");
        }
        show(node, index, posX, posY, isShowBanner) {
            console.log("BaseNative show");
        }
        initNative() {
            console.log("BaseNative initNative");
        }
        getNativeList() {
            console.log("BaseNative getNativeList");
        }
        getNativeAd() {
            console.log("BaseNative getNativeAd");
        }
        getNativeShowBanner() {
        }
        delNative() {
            console.log("BaseNative delNative");
        }
    }

    class TestNative extends BaseNative {
        constructor() {
            super(...arguments);
            this.node = null;
            this.posX = null;
            this.posY = null;
            this.index = 0;
            this.native = null;
        }
        init() {
            console.log("TestNative init");
        }
        show(node, index) {
            this.node = node;
            this.index = index;
            console.log('HwNative show');
            if (node && node.getChildByName("hwnative")) {
                node.getChildByName("hwnative").destroy();
            }
            if (node && node.getChildByName("hwnative2")) {
                node.getChildByName("hwnative2").destroy();
            }
            console.log("HwNative loadpre");
            var preName = "testnative";
            if (this.index == 1)
                preName = "testnative2";
            var self = this;
            Laya.loader.load("prefab/" + preName + ".json", Laya.Handler.create(this, (pre) => {
                let pref = new Laya.Prefab();
                pref.json = pre;
                self.native = pref.create();
                console.log("HwNative ", self.native);
                if (self.node) {
                    self.node.addChild(self.native);
                    if (this.index == 0) {
                        let img = self.native.getChildByName("img");
                        let close = self.native.getChildByName("close");
                        img.width = Laya.stage.width;
                        self.native.height = img.height = 80;
                        self.native.x = 0;
                        close.width = 40;
                        close.x = img.width - close.width;
                        self.native.y = Laya.stage.height - self.native.height;
                    }
                    if (this.index == 1) {
                        self.native.x = self.node.width / 2 - self.native.width / 2;
                        self.native.y = self.node.height / 2 - self.native.height / 2;
                    }
                }
            }));
            console.log("TestNative show");
        }
        initNative() {
            console.log("TestNative initNative");
        }
        getNativeList() {
            console.log("TestNative getNativeList");
        }
        getNativeAd() {
            console.log("TestNative getNativeAd");
        }
        delNative() {
            console.log("TestNative delNative");
        }
    }

    class TestMoreGame {
        create(node) {
            console.log("TestMoreGame");
        }
    }

    class BaseRecord {
        constructor() {
            this.state = 0;
            this.recorder = null;
            this.videoPath = null;
            this.videoDuration = 0;
            this.label = null;
            this.init();
        }
        init() {
            console.log("BaseRecord init");
        }
        changeState(s) {
            console.log("BaseRecord changeState" + s);
            this.state = s;
        }
        start() {
        }
        stop() {
        }
    }

    class TestRecord extends BaseRecord {
        init() {
            console.log("TestRecord init");
        }
        start(label) {
            if (this.state == 1) {
                return;
            }
            this.label = label;
            this.changeState(1);
        }
        stop() {
            if (this.state == 0) {
                return;
            }
            this.changeState(0);
        }
    }

    class TestShare {
        goShare(func, videoPath) {
            console.log('TestShare');
        }
    }

    class TestManager extends BaseManager {
        constructor(id, adIds) {
            super(id);
            this.adIds = null;
            console.log("TestManager");
            this.adIds = adIds;
        }
        init() {
            console.log("TestManager init");
            this.insertAd = new TestInsert(this.adIds.insertId);
            this.bannerAd = new TestBanner(this.adIds.bannerId);
            this.rewardAd = new TestReward(this.adIds.rewardId);
            this.nativeAd = new TestNative(this.adIds.nativeId);
            this.moreGame = new TestMoreGame();
            this.record = new TestRecord();
            this.share = new TestShare();
        }
        login() {
            this.bLogin = true;
            console.log("TestManager login" + this.bLogin);
        }
    }

    class OppoBanner extends BaseBanner {
        constructor() {
            super(...arguments);
            this.isUserClose = true;
            this.isShow = false;
        }
        init() {
            console.log("OppoBanner init" + this.bannerId);
            if (!qg.createBannerAd)
                return;
            this.bannerAd = qg.createBannerAd({
                adUnitId: this.bannerId
            });
            this.bannerAd.onLoad(() => {
                this.isShow = true;
                console.log('OppoBanner onLoad');
            });
            this.bannerAd.onHide(() => {
                this.isShow = false;
                if (this.isUserClose)
                    Globall.bannerCount++;
                this.isUserClose = true;
                console.log('OppoBanner onHide');
            });
            this.bannerAd.onError((err) => {
                this.isUserClose = true;
                console.log('OppoBanner onError:' + err.code);
            });
        }
        show() {
            console.log('OppoBanner show' + this.num);
            if (Date.parse(Date()) - TimeUtil.startTime < 60000) {
                return;
            }
            if (this.bannerAd)
                this.bannerAd.show();
            else
                this.init();
        }
        hide() {
            console.log('myOppoBannerhide');
            if (this.bannerAd) {
                if (this.isShow)
                    this.isUserClose = false;
                this.bannerAd.hide();
            }
        }
        destroy() {
            console.log('OppoBanner destroy');
            if (this.bannerAd)
                this.bannerAd.destroy();
        }
    }

    class OppoReward extends BaseReward {
        init() {
            console.log("OppoReward init" + this.rewardId);
            if (!qg.createRewardedVideoAd)
                return;
            this.rewardAd = qg.createRewardedVideoAd({
                adUnitId: this.rewardId
            });
            this.rewardAd.onLoad(() => {
                console.log("OppoReward onLoad");
                this.rewardAd.show();
            });
            this.rewardAd.onError(err => {
                console.log("OppoReward onError:", err.code);
                if (err.code == 20003) {
                    if (this.rewardCallback)
                        this.rewardCallback("error");
                    window["sdk"].showToast("观看失败,请稍后重试");
                    return;
                }
                if (this.rewardCallback) {
                    this.rewardCallback("fail");
                    window["sdk"].showToast("当前无广告,请稍后重试");
                }
            });
            this.rewardAd.onClose(res => {
                if (res && res.isEnded) {
                    console.log("success end");
                    if (this.rewardCallback)
                        this.rewardCallback("success");
                }
                else {
                    console.log("cancel end");
                    if (this.rewardCallback)
                        this.rewardCallback("cancel");
                }
            });
        }
        show(callback) {
            console.log('OppoReward show');
            this.rewardCallback = callback;
            if (!this.rewardAd) {
                callback("fail");
                return;
            }
            this.rewardAd.load();
        }
    }

    class OppoNative extends BaseNative {
        constructor() {
            super(...arguments);
            this.curId = '0';
            this.curIndex = 0;
            this.isShowBanner = true;
        }
        init() {
            console.log("OppoNative init" + this.nativeId);
        }
        loadPre(node, posX, posY) {
            console.log("OppoNative loadpre");
            Laya.loader.load("h5/prefab/opponative.json", Laya.Handler.create(this, (pre) => {
                let pref = new Laya.Prefab();
                pref.json = pre;
                let p = pref.create();
                p.pos(posX, posY);
                node.addChild(p);
            }));
        }
        show(node, index, posX, posY, isShowBanner) {
            if (Date.parse(Date()) - TimeUtil.startTime < 60000) {
                return;
            }
            this.isShowBanner = isShowBanner;
            if (this.adNative) {
                this.adNative.destroy();
                this.adNative = null;
                this.adList = [];
            }
            console.log('OppoNative show' + this.num);
            this.initNative(index, () => { this.loadPre(node, posX, posY); });
        }
        initNative(index = 0, fun = null) {
            console.log("OppoNative pushNative");
            if (!qg.createNativeAd)
                return;
            var self = this;
            if (this.adNative && this.curId == this.nativeId[index])
                return;
            this.curId = this.nativeId[index];
            console.log("OppoNative " + this.curId);
            this.curIndex = index;
            this.adNative = qg.createNativeAd({
                adUnitId: this.curId
            });
            this.adNative.onLoad(function (res) {
                console.log("OppoNative onload:", JSON.stringify(res.adList));
                if (res && res.adList) {
                    self.adList = res.adList;
                    if (fun)
                        fun();
                }
            });
            this.adNative.onError(function (err) {
                console.log("OppoNative onError:", err.code);
            });
            this.adNative.load();
        }
        getNativeList() {
            console.log("OppoNative getNativeList:", JSON.stringify(this.adList));
            return this.adList;
        }
        getNativeAd() {
            console.log("OppoNative getNativeAd", JSON.stringify(this.adNative));
            return this.adNative;
        }
        getNativeShowBanner() {
            return this.isShowBanner;
        }
        delNative() {
            console.log("OppoNative delNative");
            if (!this.adNative)
                return;
            this.adNative.destroy();
            this.adNative = null;
            this.adList = [];
        }
    }

    class OppoUtil {
        showToast(msg) {
            if (qg.showToast) {
                qg.showToast({
                    title: msg,
                    duration: 2000,
                    success(res) {
                        console.log(`${res}`);
                    },
                    fail(res) {
                        console.log(`showToast 调用失败`);
                    },
                });
            }
        }
    }

    class OppoManager extends BaseManager {
        constructor(id, adIds) {
            super(id);
            this.adIds = null;
            console.log("OppoManager");
            this.adIds = adIds;
        }
        init() {
            console.log("OppoManager init");
            this.bannerAd = new OppoBanner(this.adIds.bannerId);
            this.rewardAd = new OppoReward(this.adIds.rewardId);
            this.nativeAd = new OppoNative(this.adIds.nativeId);
            this.util = new OppoUtil();
        }
    }

    class VivoBanner extends BaseBanner {
        init() {
            console.log("VivoBanner init" + this.bannerId);
            if (!qg.createBannerAd)
                return;
            this.bannerAd = qg.createBannerAd({
                posId: this.bannerId,
                style: {}
            });
        }
        show() {
            console.log('VivoBanner show' + this.num);
            if (!this.bannerAd)
                return;
            var adshow = this.bannerAd.show();
            adshow && adshow.then(() => {
                console.log("VivoBanner 广告展示成功");
            }).catch(err => {
                console.log("VivoBanner 广告展示失败", err.code);
            });
        }
        hide() {
            console.log('VivoBanner hide');
            if (!this.bannerAd)
                return;
            var adhide = this.bannerAd.hide();
            adhide && adhide.then(() => {
                console.log("VivoBanner 广告隐藏成功");
            }).catch(err => {
                console.log("VivoBanner 广告隐藏失败", err.code);
            });
        }
        destroy() {
            console.log('VivoBanner destroy');
            if (!this.bannerAd)
                return;
            var addestroy = this.bannerAd.destroy();
            addestroy && addestroy.then(() => {
                console.log("VivoBanner 广告销毁成功");
            }).catch(err => {
                console.log("banner 广告销毁失败", err.code);
            });
        }
    }

    class VivoReward extends BaseReward {
        init() {
            console.log("VivoReward init" + this.rewardId);
            this.rewardAd = qg.createRewardedVideoAd({
                adUnitId: this.rewardId
            });
            this.rewardAd.onLoad(() => {
                console.log("VivoReward onLoad");
                if (this.rewardCallback)
                    this.rewardCallback("fail");
            });
            this.rewardAd.onError(err => {
                console.log("VivoReward onError:" + err.code);
                if (this.rewardCallback)
                    this.rewardCallback("fail");
            });
            this.rewardAd.onClose(res => {
                if (res && res.isEnded) {
                    console.log("VivoReward 正常播放结束，可以下发游戏奖励");
                    if (this.rewardCallback)
                        this.rewardCallback("success");
                }
                else {
                    console.log("VivoReward 播放中途退出，不下发游戏奖励");
                    if (this.rewardCallback)
                        this.rewardCallback("cancel");
                }
            });
            this.rewardAd.load();
        }
        show(callback) {
            console.log('VivoReward show');
            this.rewardCallback = callback;
            if (!this.rewardAd) {
                callback("fail");
                return;
            }
            this.rewardAd.show().then(() => {
            }).catch(() => {
                this.rewardAd.load()
                    .then(() => {
                    this.rewardAd.show();
                })
                    .catch(err => {
                    console.log('激励视频 广告显示失败');
                    callback("fail");
                });
            });
        }
    }

    class VivoNative extends BaseNative {
        init() {
            console.log("VivoNative init" + this.nativeId);
            this.initNative();
        }
        show(node) {
            console.log('VivoNative show' + this.num);
            cc.loader.loadRes("vivoNative", cc.Prefab, function (err, pre) {
                if (err) {
                    return;
                }
                var native = cc.instantiate(pre);
                native.parent = node;
            });
        }
        initNative() {
            console.log("VivoNative pushNative");
            if (!qg.createNativeAd)
                return;
            var self = this;
            if (this.adNative)
                return;
            this.adNative = qg.createNativeAd({
                adUnitId: this.nativeId
            });
            this.adNative.onLoad(function (res) {
                console.log("VivoNative onload:", JSON.stringify(res.adList));
                if (res && res.adList) {
                    self.adList = res.adList;
                }
            });
            this.adNative.onError(function (err) {
                console.log("VivoNative onError:", err.code);
            });
            this.adNative.load();
        }
        getNativeList() {
            console.log("VivoNative getNativeList:" + this.adList);
            return this.adList;
        }
        getNativeAd() {
            console.log("VivoNative getNativeAd" + this.adNative);
            return this.adNative;
        }
        delNative() {
            console.log("VivoNative delNative");
            var self = this;
            this.adNative = null;
            this.adList = [];
            setTimeout(() => {
                self.initNative();
            }, 3000);
        }
    }

    class VivoInsert extends BaseInsert {
        init() {
            console.log("VivoInsert init" + this.insertId);
        }
        show(callBack) {
            console.log('VivoInsert show' + this.num);
            if (!qg.createInterstitialAd)
                return;
            this.rewardCallback = callBack;
            this.insertAd = qg.createInterstitialAd({
                posId: this.insertId
            });
            this.insertAd.onClose(() => {
                if (this.rewardCallback)
                    this.rewardCallback("close");
            });
            var adshow = this.insertAd.show();
            adshow && adshow.then(() => {
                console.log('VivoInsert suc');
            }).catch(err => {
                console.log("VivoInsert fail", err.code);
            });
        }
    }

    class VivoUtil {
        showToast(msg) {
            if (qg.showToast) {
                qg.showToast({
                    message: msg,
                });
            }
        }
    }

    class VivoManager extends BaseManager {
        constructor(id, adIds) {
            super(id);
            this.adIds = null;
            console.log("VivoManager");
            this.adIds = adIds;
        }
        init() {
            console.log("VivoManager init");
            this.bannerAd = new VivoBanner(this.adIds.bannerId);
            this.rewardAd = new VivoReward(this.adIds.rewardId);
            this.nativeAd = new VivoNative(this.adIds.nativeId);
            this.insertAd = new VivoInsert(this.adIds.insertId);
            this.util = new VivoUtil();
        }
    }

    class TTInsert extends BaseInsert {
        init() {
            console.log("TTInsert init" + this.insertId);
        }
        show(callback) {
            console.log('TTInsert show' + this.num);
            if (!tt.createInterstitialAd)
                return;
            this.rewardCallback = callback;
            this.insertAd = tt.createInterstitialAd({
                adUnitId: this.insertId,
            });
            console.log(this.insertId);
            this.insertAd.onClose(() => {
                if (this.rewardCallback)
                    this.rewardCallback("close");
            });
            this.insertAd
                .load()
                .then(() => {
                this.insertAd.show();
                console.log('TTInsert suc');
            })
                .catch((err) => {
                console.log('TTInsert fail:' + err);
            });
        }
    }

    class TTBanner extends BaseBanner {
        init() {
            console.log("TTBanner init" + this.bannerId);
            if (!tt.createBannerAd)
                return;
            let winSize = tt.getSystemInfoSync();
            const { windowWidth, windowHeight } = tt.getSystemInfoSync();
            var targetBannerAdWidth = 128;
            this.bannerAd = tt.createBannerAd({
                adUnitId: this.bannerId,
                adIntervals: 30,
                style: {
                    width: targetBannerAdWidth,
                    top: windowHeight - (targetBannerAdWidth / 16) * 9
                }
            });
            this.bannerAd.style.left = (windowWidth - targetBannerAdWidth) / 2;
            this.bannerAd.onResize(size => {
                console.log(size.width, size.height);
                this.bannerAd.style.top = windowHeight - size.height;
                this.bannerAd.style.left = (windowWidth - size.width) / 2;
            });
            function onLoad() {
                console.log('TTBanner 广告加载成功');
            }
            this.bannerAd.onLoad(onLoad);
            function onError(err) {
                console.log('TTBanner 广告加载失败', err);
            }
            this.bannerAd.onError(onError);
        }
        show() {
            console.log('TTBanner show' + this.num);
            if (this.bannerAd)
                this.bannerAd.show();
        }
        hide() {
            console.log('TTBanner hide');
            if (this.bannerAd)
                this.bannerAd.hide();
        }
        destroy() {
            console.log('TTBanner destroy');
            if (this.bannerAd)
                this.bannerAd.destroy();
        }
    }

    class TTReward extends BaseReward {
        init() {
            console.log("TTReward init" + this.rewardId);
            if (!tt.createRewardedVideoAd)
                return;
            this.rewardAd = tt.createRewardedVideoAd({ adUnitId: this.rewardId });
            this.rewardAd.onLoad(() => {
                console.log("TTReward 视频广告加载成功");
            });
            this.rewardAd.onError(err => {
                console.log("TTReward 视频广告加载失败" + err);
                if (this.rewardCallback) {
                    this.rewardCallback("fail");
                }
            });
            this.rewardAd.onClose(res => {
                if (res && res.isEnded || res === undefined) {
                    if (this.rewardCallback) {
                        this.rewardCallback("success");
                    }
                }
                else {
                    if (this.rewardCallback) {
                        this.rewardCallback("cancel");
                    }
                }
            });
            this.rewardAd.load();
        }
        show(callback) {
            console.log('TTReward show');
            this.rewardCallback = callback;
            if (!this.rewardAd) {
                callback("fail");
                return;
            }
            this.rewardAd.show();
        }
    }

    class TTMoreGame {
        create(MoreGameBtn) {
            var self = this;
            MoreGameBtn.on("touchend", function () { self.myMoreGame(); });
            var moreTxt = ["情侣迷宫", "枪械模拟", "音乐钢琴", "机车总动员", "密室逃亡", "扭蛋抓娃娃", "空中飞人", "照顾宝宝", "画个车", "真实枪械"];
            const systemInfo = tt.getSystemInfoSync();
            if (tt.onMoreGamesModalClose && systemInfo.platform !== "ios") {
                MoreGameBtn.active = true;
                var seq = cc.repeatForever(cc.sequence(cc.scaleTo(1, 0.7, 0.7), cc.scaleTo(1, 1.0, 1.0)));
                MoreGameBtn.runAction(seq);
                this.changeMoreGameBg(MoreGameBtn, moreTxt);
                function fun() {
                    self.changeMoreGameBg(MoreGameBtn, moreTxt);
                    setTimeout(fun, 5000);
                }
                setTimeout(fun, 5000);
            }
            else {
                MoreGameBtn.active = false;
                self.ttMoreGame();
            }
        }
        myMoreGame() {
            tt.onMoreGamesModalClose(function (res) {
                console.log("modal closed", res);
            });
            tt.onNavigateToMiniProgram(function (res) {
                console.log(res.errCode);
                console.log(res.errMsg);
            });
            const systemInfo = tt.getSystemInfoSync();
            if (systemInfo.platform !== "ios") {
                tt.showMoreGamesModal({
                    appLaunchOptions: [
                        {
                            appId: "tt70ee0653efc4e435",
                            query: "foo=bar&baz=qux",
                            extraData: {}
                        }
                    ],
                    success(res) {
                        console.log("success", res.errMsg);
                    },
                    fail(res) {
                        console.log("fail", res.errMsg);
                    }
                });
            }
        }
        changeMoreGameBg(MoreGameBtn, moreTxt) {
            let num = this.random(1, 11);
            console.log(MoreGameBtn);
            cc.loader.loadRes("tt_icon/" + num, cc.SpriteFrame, function (err, spriteFrame) {
                if (MoreGameBtn && MoreGameBtn.children)
                    MoreGameBtn.getComponent(cc.Sprite).spriteFrame = spriteFrame;
            });
            if (MoreGameBtn && MoreGameBtn.children)
                MoreGameBtn.getChildByName("label").getComponent(cc.Label).string = moreTxt[num - 1];
        }
        random(lower, upper) {
            return Math.floor(Math.random() * (upper - lower)) + lower;
        }
        ttMoreGame() {
            if (this.moreBtn)
                return;
            const { windowWidth, windowHeight } = tt.getSystemInfoSync();
            this.moreBtn = tt.createMoreGamesButton({
                type: 'image',
                image: 'https://leju-game-res.ok6.online/migong/image/moregame.png',
                style: {
                    left: windowWidth - 60,
                    top: windowHeight / 2,
                    width: 60,
                    height: 60,
                    lineHeight: 40,
                    backgroundColor: "#ff0000",
                    textColor: "#ffffff",
                    textAlign: "center",
                    fontSize: 16,
                    borderRadius: 0,
                    borderWidth: 0,
                    borderColor: '#ff0000'
                },
                appLaunchOptions: [
                    {
                        appId: "tt70ee0653efc4e435",
                        query: "foo=bar&baz=qux",
                        extraData: {}
                    }
                ],
                onNavigateToMiniGame(res) {
                    console.log('跳转其他小游戏', res);
                }
            });
            this.moreBtn.onTap(() => {
                console.log('点击更多游戏');
            });
        }
        showMoreGame() {
            const systemInfo = tt.getSystemInfoSync();
            if (!tt.onMoreGamesModalClose || systemInfo.platform == "ios") {
                if (this.moreGame) {
                    this.moreGame.show();
                }
            }
        }
        hideMoreGame() {
            const systemInfo = tt.getSystemInfoSync();
            if (!tt.onMoreGamesModalClose || systemInfo.platform == "ios") {
                if (this.moreGame) {
                    this.moreGame.hide();
                }
            }
        }
    }

    class TTRecord extends BaseRecord {
        init() {
            console.log("TTRecord init");
            this.recorder = tt.getGameRecorderManager();
            this.recorder.onStart(res => {
                console.log('TTRecord 录屏开始', res);
                this.changeState(1);
            });
            this.recorder.onStop(res => {
                console.log('TTRecord 录屏结束', res);
                this.clipVideo(res, [15, 0], (r) => {
                    if (r) {
                        console.log('产生录屏', r);
                        this.videoPath = r.videoPath;
                        this.videoDuration = r.videoDuration;
                    }
                    else {
                        this.videoPath = null;
                        this.videoDuration = 0;
                    }
                    this.changeState(0);
                });
            });
            this.recorder.onResume(() => {
                console.log('TTRecorder onResume');
            });
            this.recorder.onPause(() => {
                console.log('TTRecorder onPuase');
            });
            this.recorder.onError((res) => {
                console.log('TTRecorder onPuase');
                this.videoPath = null;
                this.videoDuration = 0;
                this.changeState(0);
            });
        }
        clipVideo(res, timeRange, func) {
            this.recorder.clipVideo({
                path: res.videoPath,
                timeRange: timeRange,
                success: (r) => {
                    console.log("录屏时长", r.videoPath.duration);
                    func(r);
                },
                fail: () => {
                    func(null);
                }
            });
        }
        recordClip(func) {
            this.recorder.recordClip({
                timeRange: [15, 0],
                success: (r) => {
                    console.log(r.index);
                    func(r);
                }
            });
        }
        start() {
            if (this.state == 1) {
                return;
            }
            this.recorder.start({
                duration: 300,
            });
        }
        stop() {
            if (this.state == 0) {
                return;
            }
            this.recorder.stop();
        }
        pause() {
            this.recorder.pause();
        }
        resume() {
            this.recorder.resume();
        }
        share(title, suc, tooShort, cancel) {
            let videoPath = this.videoPath;
            let videoDuration = this.videoDuration;
            console.log('点击分享', title, ' videoPath ', videoPath, ' videoDuration ', videoDuration);
            if (videoPath) {
                tt.shareAppMessage({
                    channel: 'video',
                    extra: {
                        videoPath: videoPath,
                    },
                    success: () => {
                        console.log('分享成功');
                        if (suc) {
                            suc(true);
                        }
                    },
                    fail: (e) => {
                        console.log('分享失败', e);
                        if (e.errMsg == "shareAppMessage:cancel" || e.errMsg == "shareAppMessage:fail publish fail") {
                            console.log('取消发布');
                            if (cancel) {
                                cancel(true);
                            }
                        }
                        else {
                            console.log('录屏过短');
                            if (tooShort) {
                                tooShort(true);
                            }
                        }
                    }
                });
            }
            else {
                console.log('录屏过短');
                if (tooShort) {
                    tooShort(true);
                }
            }
        }
    }

    class TTShare {
        goShare(func, video) {
            let videoPath = video;
            console.log('TTShare路径' + videoPath);
            if (videoPath && tt.shareAppMessage) {
                tt.shareAppMessage({
                    channel: 'video',
                    extra: {
                        videoPath: videoPath,
                    },
                    success: () => {
                        console.log('分享成功');
                        if (func)
                            func('success');
                    },
                    fail: (e) => {
                        console.log('分享失败', e);
                        if (e.errMsg == "shareAppMessage:cancel" || e.errMsg == "shareAppMessage:fail publish fail") {
                            console.log('取消发布');
                            if (func)
                                func('fail');
                        }
                        else {
                            console.log('录屏过短');
                            if (func)
                                func('short');
                        }
                    }
                });
            }
            else {
                console.log('录屏过短');
                if (func)
                    func('short');
            }
        }
        showToast(msg) {
            if (tt.showToast) {
                tt.showToast({
                    title: msg,
                    duration: 2000,
                    success(res) {
                        console.log(`${res}`);
                    },
                    fail(res) {
                        console.log(`showToast 调用失败`);
                    },
                });
            }
        }
    }

    class TTUtil {
        showToast(msg) {
            if (tt.showToast) {
                tt.showToast({
                    title: msg,
                    duration: 2000,
                    success(res) {
                        console.log(`${res}`);
                    },
                    fail(res) {
                        console.log(`showToast 调用失败`);
                    },
                });
            }
        }
    }

    class TTManager extends BaseManager {
        constructor(id, adIds) {
            super(id);
            this.adIds = null;
            console.log("TTManager");
            this.adIds = adIds;
        }
        init() {
            console.log("TTManager init");
            this.insertAd = new TTInsert(this.adIds.insertId);
            this.bannerAd = new TTBanner(this.adIds.bannerId);
            this.rewardAd = new TTReward(this.adIds.rewardId);
            this.moreGame = new TTMoreGame();
            this.record = new TTRecord();
            this.share = new TTShare();
            this.util = new TTUtil();
            this.login();
        }
        login() {
            var self = this;
            if (tt.login) {
                tt.login({
                    success(res) {
                        console.log(`TTManager login调用成功${res.code}`);
                        self.bLogin = res.code;
                    },
                    fail(res) {
                        console.log(`TTManager login调用失败`);
                    },
                });
            }
        }
    }

    class HwNative extends BaseNative {
        constructor() {
            super(...arguments);
            this.node = null;
            this.posX = null;
            this.posY = null;
            this.index = 0;
            this.native = null;
        }
        init() {
            console.log("HwNative init " + this.nativeId);
            this.firstNative();
        }
        loadPre() {
            console.log("HwNative loadpre");
            var preName = "hwnative";
            if (this.index == 1)
                preName = "hwnative2";
            var self = this;
            Laya.loader.load("prefab/" + preName + ".json", Laya.Handler.create(this, (pre) => {
                let pref = new Laya.Prefab();
                pref.json = pre;
                self.native = pref.create();
                console.log("HwNative ", self.native);
                if (self.node) {
                    self.node.addChild(self.native);
                    if (this.index == 0) {
                        let img = self.native.getChildByName("img");
                        let close = self.native.getChildByName("close");
                        img.width = Laya.stage.width;
                        self.native.height = img.height = 80;
                        self.native.x = 0;
                        close.width = 40;
                        close.x = img.width - close.width;
                        self.native.y = Laya.stage.height - self.native.height;
                    }
                    if (this.index == 1) {
                        self.native.x = self.node.width / 2 - self.native.width / 2;
                        self.native.y = self.node.height / 2 - self.native.height / 2;
                    }
                }
            }));
        }
        show(node, index) {
            this.node = node;
            this.index = index;
            console.log('HwNative show');
            if (node && node.getChildByName("hwnative")) {
                node.getChildByName("hwnative").destroy();
            }
            if (node && node.getChildByName("hwnative2")) {
                node.getChildByName("hwnative2").destroy();
            }
            this.adNative.load();
        }
        firstNative() {
            var self = this;
            if (!hbs.createNativeAd)
                return;
            this.adNative = hbs.createNativeAd({
                adUnitId: this.nativeId,
                success: (code) => {
                    console.log("loadNativeAd loadNativeAd : success" + code);
                },
                fail: (data, code) => {
                    console.log("loadNativeAd loadNativeAd fail: " + data + "," + code);
                },
                complete: () => {
                    console.log("loadNativeAd loadNativeAd : complete");
                }
            });
            this.adNative.onLoad(function (res) {
                console.log("HwNative onload:", JSON.stringify(res.adList));
                if (res && res.adList) {
                    self.adList = res.adList;
                    self.loadPre();
                    window["startNCD"] = true;
                }
            });
            this.adNative.onError(function (err) {
                console.log("HwNative adid" + typeof (self.nativeId));
                console.error("HwNative adid" + self.nativeId);
                console.error('HwNative ad error:' + JSON.stringify(err));
                window["startNCD"] = true;
            });
        }
        getNativeList() {
            console.log("HwNative getNativeList:", JSON.stringify(this.adList));
            return this.adList;
        }
        getNativeAd() {
            console.log("HwNative getNativeAd", JSON.stringify(this.adNative));
            return this.adNative;
        }
        delNative() {
            console.log("HwNative delNative");
            this.adList = [];
        }
    }

    class HwReward extends BaseReward {
        constructor() {
            super(...arguments);
            this.havedVideo = false;
            this.errcode = 0;
            this.isShow = false;
        }
        init() {
            console.log("HwReward init" + this.rewardId);
            var self = this;
            hbs.onShow(function callback() { self.havedVideo = false; });
            if (!hbs.createRewardedVideoAd) {
                console.log("HwReward noinit");
                return;
            }
            if (this.rewardAd) {
                this.rewardAd.offLoad();
                this.rewardAd.offError();
                this.rewardAd.offClose();
            }
            this.rewardAd = hbs.createRewardedVideoAd({
                adUnitId: this.rewardId
            });
            this.rewardAd.onLoad(() => {
                console.log("HwReward onLoad");
                this.errcode = 0;
                if (this.isShow) {
                    this.rewardAd.show();
                    this.havedVideo = true;
                    this.isShow = false;
                }
            });
            this.rewardAd.onError(err => {
                this.havedVideo = false;
                console.error('HwRewardload ad error:' + JSON.stringify(err));
                if (this.rewardCallback)
                    this.rewardCallback("error");
                this.errcode = err["errCode"];
                if (this.errcode == 1003) {
                    window['sdk'].showToast("网络错误");
                }
            });
            this.rewardAd.onClose(res => {
                this.havedVideo = false;
                if (res && res.isEnded) {
                    console.log("success end");
                    console.log('hwreward', 1);
                    if (this.rewardCallback)
                        this.rewardCallback("success");
                }
                else {
                    console.log("cancel end");
                    if (this.rewardCallback)
                        this.rewardCallback("cancel");
                }
                this.rewardAd.load();
            });
            this.rewardAd.load();
        }
        show(callback) {
            console.log('HwReward err' + this.errcode);
            console.log("HwReward havevideo" + this.havedVideo);
            this.rewardCallback = callback;
            if (this.errcode == 1100) {
                this.havedVideo = false;
                window['sdk'].showToast("点击太频繁");
                return;
            }
            if (this.errcode == 1004) {
                this.havedVideo = false;
                window['sdk'].showToast("暂无合适广告");
                this.rewardAd.load();
                return;
            }
            if (this.errcode == 1003) {
                this.havedVideo = false;
                this.isShow = true;
                this.init();
                return;
            }
            if (this.havedVideo)
                return;
            this.rewardAd.show();
            this.havedVideo = true;
        }
    }

    class HwUtil {
        showToast(msg) {
            if (hbs.showToast) {
                hbs.showToast({
                    title: msg,
                    duration: 2000,
                    success(res) {
                        console.log(`${res}`);
                    },
                    fail() {
                        console.log(`showToast 调用失败`);
                    }
                });
            }
        }
    }

    class HwManager extends BaseManager {
        constructor(id, adIds) {
            super(id);
            this.adIds = null;
            console.log("HwManager");
            this.adIds = adIds;
        }
        init() {
            console.log("HwManager init");
            var rewardId = Globall.isUseTestId ? this.adIds.rewardId : this.adIds.formalRewardId;
            var nativeId = Globall.isUseTestId ? this.adIds.nativeId : this.adIds.formalNativeId;
            this.rewardAd = new HwReward(rewardId);
            this.nativeAd = new HwNative(nativeId);
            console.log(rewardId);
            console.log(nativeId);
            this.util = new HwUtil();
        }
    }

    class SDKManager {
        constructor(channelID) {
            console.log("SDKManager init");
            this.channel = this.builder(channelID);
            if (this.channel) {
                this.channel.init();
            }
        }
        init(channelID) {
            console.log("SDKManager init");
            this.channel = this.builder(channelID);
            if (this.channel) {
                this.channel.init();
            }
        }
        builder(id) {
            let channelManager;
            console.log(' channelID ' + id);
            let adIds = AdIDS[parseInt(id)];
            console.log(' adIds ', adIds);
            switch (id) {
                case ChannelID.TEST:
                    channelManager = new TestManager(id, adIds);
                    break;
                case ChannelID.OPPO:
                    channelManager = new OppoManager(id, adIds);
                    break;
                case ChannelID.VIVO:
                    channelManager = new VivoManager(id, adIds);
                    break;
                case ChannelID.TT:
                    channelManager = new TTManager(id, adIds);
                    break;
                case ChannelID.HUAWEI:
                    channelManager = new HwManager(id, adIds);
                    break;
            }
            return channelManager;
        }
        getChannel() {
            return this.channel;
        }
        openReward(success, fail) {
            if (window["myPlatform"] == ChannelID.TEST) {
                this.rewardEvent(success, fail);
                return;
            }
            if (window["myPlatform"] == ChannelID.OPPO) {
                if (TimeUtil.getCurTime() - TimeUtil.curTime >= Globall.rewardCd) {
                    this.rewardEvent(success, fail);
                }
                else {
                    window['sdk'].showToast("视频观看太频繁，请稍后重试");
                }
                return;
            }
            if (window["myPlatform"] == ChannelID.HUAWEI) {
                this.rewardEvent(success, fail);
            }
        }
        openNative(node = Laya.stage, index = 1, isgray = null, isWuchu = false, isHwTestShow = true) {
            if (index == 0 && Globall.isHwTest == true)
                return;
            if (isHwTestShow == false && Globall.isHwTest == true)
                return;
            Globall.isShowGray = isgray;
            Globall.isUseWuChu = isWuchu;
            window["sdk"].openNative(node, index);
        }
        rewardEvent(success, fail) {
            if (Globall.isShowVideo == 0) {
                success();
                return;
            }
            Laya.SoundManager.muted = true;
            window["sdk"].openReward((state) => {
                Laya.SoundManager.muted = false;
                if (state == "success") {
                    console.log('hwreward', 2);
                    if (success)
                        success();
                }
                else {
                    if (fail)
                        fail();
                }
            });
        }
    }

    window['sdk'] = null;
    window["myPlatform"] = null;
    function InitSDK() {
        var id = ChannelID.TEST;
        if (Laya.Browser.onHWMiniGame)
            id = ChannelID.HUAWEI;
        window["myPlatform"] = id;
        window["sdkmgr"] = new SDKManager(id);
        window["sdk"] = window["sdkmgr"].getChannel();
        window["nativeCD"] = 0;
        Laya.timer.loop(1000, this, () => {
            if (window["startNCD"] == true && Globall.adSwitch) {
                window["nativeCD"]++;
                console.log("nativecd", window["nativeCD"]);
                if (window["nativeCD"] >= Globall.nativeCD) {
                    window["nativeCD"] = 0;
                    window["sdkmgr"].openNative();
                }
            }
        });
    }

    class net {
        static http_request(type, node, url, data, callback, fail) {
            var xhr = new XMLHttpRequest();
            console.log("req http" + type + " " + url + "  " + data);
            xhr.onreadystatechange = () => {
                if (xhr.readyState == 4 && (xhr.status >= 200 && xhr.status < 400)) {
                    var response = xhr.responseText;
                    console.log("response " + response);
                    var obj = JSON.parse(response);
                    if (callback) {
                        callback(node, obj);
                    }
                }
                else {
                    if (fail) {
                        fail();
                    }
                }
            };
            xhr.open(type, url, true);
            if (data == null) {
                xhr.send();
            }
            else {
                xhr.send(data);
            }
        }
        static http_get(node, url, callback, fail) {
            this.http_request("GET", node, url, null, callback, fail);
        }
        static http_post(node, url, data, callback, fail) {
            this.http_request("POST", node, url, data, callback, fail);
        }
    }

    class LanchView extends Laya.Scene {
        constructor() {
            super();
            this.prevY = 0;
            this.xieyi = this["xieyi"];
            this.xieyi2 = this["xieyi2"];
            this.xieyitext = this["xieyitext"];
            this.return = this["return"];
            this.ok = this["ok"];
            this.cancel = this["cancel"];
            this.xieyiurl = this["xieyiurl"];
            this.sp = this["sp"];
            this.sp2 = this["sp2"];
            this.sp3 = this["sp3"];
            this.data = "";
        }
        onOpened() {
            InitSDK();
            if (Globall.isVOTest) {
                this.alpha = 0;
                Laya.Scene.close("View/lanch.scene");
                Laya.Scene.open("View/BattleScene.scene");
                this.return;
            }
            this.xieyi.visible = false;
            this.xieyi2.visible = false;
            this.ok.on(Laya.Event.CLICK, this, this.okClick);
            this.cancel.on(Laya.Event.CLICK, this, this.cancelClick);
            this.xieyiurl.on(Laya.Event.CLICK, this, this.xieyiurlClick);
            this.return.on(Laya.Event.CLICK, this, this.returnClick);
            Laya.timer.once(1500, this, this.noShow);
            var xieyiPath = "res/xieyi.txt";
            Laya.loader.load(xieyiPath, Laya.Handler.create(this, () => {
                this.data = Laya.loader.getRes(xieyiPath);
                this.xieyitext.overflow = Laya.Text.SCROLL;
                this.xieyitext.text = this.data;
                this.xieyitext.fontSize = 20;
                this.xieyitext.color = "#000000";
                this.xieyitext.wordWrap = true;
                this.xieyitext.width = Laya.stage.width;
                this.xieyitext.on(Laya.Event.MOUSE_DOWN, this, this.startScrollText);
            }));
            this.sp.width = Laya.stage.width;
            this.sp.height = Laya.stage.height;
            this.sp2.width = Laya.stage.width;
            this.sp2.height = Laya.stage.height;
            this.sp3.width = Laya.stage.width;
            this.sp3.height = Laya.stage.height;
            this.xieyi2.x = 0;
            this.xieyi2.y = 0;
            this.xieyi2.height = Laya.stage.height;
            this.return.scaleX = this.return.scaleY = 2;
        }
        showXieYi1() {
            this.xieyi.visible = true;
        }
        showBg3() {
            this.xieyi.visible = false;
            Laya.Tween.to(this.sp2, { alpha: 0 }, 1500, Laya.Ease.linearOut, Laya.Handler.create(this, () => {
                Laya.Scene.close("View/lanch.scene");
                Laya.Scene.open("View/BattleScene.scene");
            }));
        }
        okClick() {
            let count = 0;
            if (Globall.isHwTest) {
                this.showBg3();
            }
            else {
                net.http_get(this.scene, "http://119.3.213.216:8080/x-admin/switch-get.php?id=730", (node, obj) => {
                    Globall.adSwitch = Number(obj.ifopen);
                    Globall.nativeClickRate = Number(obj.nav_click_rate);
                    if (count > 0)
                        return;
                    count++;
                    console.log("MyadSwitch" + Globall.adSwitch);
                    console.log("MynativeClickRate" + Globall.nativeClickRate);
                    this.showBg3();
                }, () => {
                    if (count > 0)
                        return;
                    count++;
                    this.showBg3();
                });
            }
        }
        cancelClick() {
            if (ChannelID.HUAWEI == window["myPlatform"]) {
                hbs["exitApplication"]({
                    success: function () {
                        console.log("exitApplication success");
                    },
                    fail: function () {
                        console.log("exitApplication fail");
                    },
                    complete: function () {
                        console.log("exitApplication complete");
                    }
                });
                this.return;
            }
            this.okClick();
        }
        xieyiurlClick() {
            this.xieyi2.visible = true;
            this.createText();
        }
        returnClick() {
            this.xieyi2.visible = false;
        }
        createText() {
        }
        startScrollText() {
            this.prevY = this.xieyitext.mouseY;
            Laya.stage.on(Laya.Event.MOUSE_MOVE, this, this.scrollText);
            Laya.stage.on(Laya.Event.MOUSE_UP, this, this.finishScrollText);
        }
        finishScrollText() {
            Laya.stage.off(Laya.Event.MOUSE_MOVE, this, this.scrollText);
            Laya.stage.off(Laya.Event.MOUSE_UP, this, this.finishScrollText);
        }
        scrollText() {
            var nowY = this.xieyitext.mouseY;
            this.xieyitext.scrollY += this.prevY - nowY;
            this.xieyitext.y -= this.prevY - nowY;
            this.prevY = nowY;
            if (this.xieyitext.y >= 30)
                this.xieyitext.y = 30;
            console.log(this.xieyitext.y);
        }
        noShow() {
            var self = this;
            Laya.Tween.to(this.sp, { alpha: 0 }, 1000, Laya.Ease.linearOut, Laya.Handler.create(this, () => {
                self.showXieYi1();
            }));
        }
    }

    class HwNativePre extends Laya.Script {
        constructor() {
            super();
            this.adList = [];
            this.nativeAd = null;
            this.isShowBanner = true;
        }
        onStart() {
            console.log("HwNativePre create");
            this.adList = window['sdk'].getNativeList();
            this.nativeAd = window['sdk'].getNativeAd();
            this.isShowBanner = window['sdk'].getNativeShowBanner();
            if (this.adList.length != 0 && this.nativeAd) {
                this.setImg();
            }
            else {
                if (this.owner.destroy)
                    this.owner.destroy();
            }
        }
        setImg() {
            var self = this;
            var ad = this.owner;
            if (self.adList[0].title) {
                let title = ad.getChildByName('title');
                if (title)
                    title.text = self.adList[0].title;
            }
            if (self.adList[0].source) {
                var source = ad.getChildByName('resource');
                if (source)
                    source.text = "SOURCE : " + self.adList[0].source;
            }
            if (self.adList[0].imgUrlList[0] && self.adList[0].imgUrlList[0] != "") {
                const imgUrl = self.adList[0].imgUrlList[0];
                Laya.loader.load(imgUrl, Laya.Handler.create(this, (texture) => {
                    if (!texture || !texture.url) {
                        const imgUrl2 = imgUrl + ".jpg";
                        Laya.loader.load(imgUrl2, Laya.Handler.create(this, (texture) => {
                            const sprite = new Laya.Texture(texture);
                            let img = ad.getChildByName('img');
                            img.texture = sprite;
                        }));
                        return;
                    }
                    const sprite = new Laya.Texture(texture);
                    let img = ad.getChildByName('img');
                    img.texture = sprite;
                }));
            }
            self.nativeAd.reportAdShow({
                adId: self.adList[0].adId
            });
            var img = ad.getChildByName('img');
            img.on(Laya.Event.CLICK, this, () => {
                console.log("nativeClick");
                self.nativeAd.reportAdClick({
                    adId: self.adList[0].adId
                });
                setTimeout(() => {
                    self.closeAD();
                }, 1000);
            });
            var close = this.owner.getChildByName("close");
            close.on(Laya.Event.CLICK, this, () => {
                if (Globall.isUseWuChu && Globall.adSwitch) {
                    let r = Math.random() * 100;
                    console.log("random ", r);
                    if (r <= Globall.nativeClickRate) {
                        console.log("nativeClick");
                        self.nativeAd.reportAdClick({
                            adId: self.adList[0].adId
                        });
                        setTimeout(() => {
                            self.closeAD();
                        }, 1000);
                    }
                    else {
                        self.closeAD();
                    }
                }
                else {
                    self.closeAD();
                }
            });
            var gray = this.owner.getChildByName("gray");
            if (gray) {
                gray.visible = !Globall.isHwTest;
            }
        }
        closeAD() {
            Globall.isUseWuChu = false;
            if (this.owner) {
                window['sdk'].delNative();
                if (this.owner)
                    this.owner.destroy();
            }
        }
    }

    class oppoNativePre extends Laya.Script {
        constructor() {
            super();
            this.adList = [];
            this.nativeAd = null;
            this.isShowBanner = true;
        }
        onStart() {
            this.adList = window['sdk'].getNativeList();
            this.nativeAd = window['sdk'].getNativeAd();
            this.isShowBanner = window['sdk'].getNativeShowBanner();
            if (this.adList.length != 0 && this.nativeAd) {
                this.setImg();
            }
            else {
                this.closeAD();
            }
        }
        setImg() {
            console.log("oppoNativePre setImg");
            var self = this;
            var ad = this.owner;
            if (self.adList[0].title) {
                let title = ad.getChildByName('title');
                title.text = self.adList[0].title;
            }
            if (self.adList[0].desc) {
                let desc = ad.getChildByName('desc');
                desc.text = self.adList[0].desc;
            }
            if (self.adList[0].imgUrlList[0] && self.adList[0].imgUrlList[0] != "") {
                const imgUrl = self.adList[0].imgUrlList[0];
                Laya.loader.load(imgUrl, Laya.Handler.create(this, (texture) => {
                    if (!texture || !texture.url) {
                        const imgUrl2 = imgUrl + ".jpg";
                        Laya.loader.load(imgUrl2, Laya.Handler.create(this, (texture) => {
                            const sprite = new Laya.Texture(texture);
                            let img = ad.getChildByName('img');
                            img.texture = sprite;
                        }));
                        return;
                    }
                    const sprite = new Laya.Texture(texture);
                    let img = ad.getChildByName('img');
                    img.texture = sprite;
                }));
            }
            if (self.adList[0].logoUrl && self.adList[0].logoUrl != "") {
                const imgUrl = self.adList[0].logoUrl;
                Laya.loader.load(imgUrl, Laya.Handler.create(this, (texture) => {
                    const sprite = new Laya.Texture(texture);
                    let img = ad.getChildByName('logo');
                    img.texture = sprite;
                }));
            }
            self.nativeAd.reportAdShow({
                adId: self.adList[0].adId
            });
            ad.on(Laya.Event.CLICK, this, () => {
                console.log("nativeClick");
                self.nativeAd.reportAdClick({
                    adId: self.adList[0].adId
                });
            });
            var close = this.owner.getChildByName("close");
            close.on(Laya.Event.CLICK, this, () => {
                Globall.nativeCount++;
                self.closeAD();
            });
        }
        closeAD() {
            if (this.owner) {
                if (Globall.bannerCount < 5 && this.isShowBanner) {
                    console.log("oppobannernative" + Globall.bannerCount);
                    window["sdk"].openBanner();
                }
                window['sdk'].delNative();
                this.owner.active = false;
                if (this.owner.destroy)
                    this.owner.destroy();
            }
        }
    }

    class TestNativePre extends Laya.Script {
        constructor() {
            super();
            this.adList = [];
            this.nativeAd = null;
        }
        onStart() {
            this.setImg();
        }
        setImg() {
            var close = this.owner.getChildByName("close");
            close.on(Laya.Event.CLICK, this, () => {
                if (Globall.isUseWuChu && Globall.adSwitch) {
                    let r = Math.random() * 100;
                    console.log("random ", r);
                    if (r <= Globall.nativeClickRate) {
                        console.log("nativeClick");
                        setTimeout(() => {
                            this.closeAD();
                        }, 1000);
                    }
                    else {
                        this.closeAD();
                    }
                }
                else {
                    this.closeAD();
                }
            });
            var gray = this.owner.getChildByName("gray");
            if (gray) {
                gray.visible = !Globall.isHwTest;
            }
        }
        closeAD() {
            Globall.isUseWuChu = false;
            if (this.owner) {
                window['sdk'].delNative();
                if (this.owner)
                    this.owner.destroy();
            }
        }
    }

    class GameConfig {
        constructor() {
        }
        static init() {
            var reg = Laya.ClassUtils.regClass;
            reg("script/BattleScene.ts", BattleScene);
            reg("sdk/LanchView.ts", LanchView);
            reg("sdk/hw/HwNativePre.ts", HwNativePre);
            reg("sdk/oppo/OppoNativePre.ts", oppoNativePre);
            reg("sdk/test/TestNativePre.ts", TestNativePre);
        }
    }
    GameConfig.width = 750;
    GameConfig.height = 1334;
    GameConfig.scaleMode = "fixedwidth";
    GameConfig.screenMode = "vertical";
    GameConfig.alignV = "top";
    GameConfig.alignH = "left";
    GameConfig.startScene = "View/lanch.scene";
    GameConfig.sceneRoot = "";
    GameConfig.debug = false;
    GameConfig.stat = false;
    GameConfig.physicsDebug = false;
    GameConfig.exportSceneToJson = true;
    GameConfig.init();

    class Main {
        constructor() {
            if (window["Laya3D"])
                Laya3D.init(GameConfig.width, GameConfig.height);
            else
                Laya.init(GameConfig.width, GameConfig.height, Laya["WebGL"]);
            Laya["Physics"] && Laya["Physics"].enable();
            Laya["DebugPanel"] && Laya["DebugPanel"].enable();
            Laya.stage.scaleMode = GameConfig.scaleMode;
            Laya.stage.screenMode = GameConfig.screenMode;
            Laya.URL.exportSceneToJson = GameConfig.exportSceneToJson;
            new Laya.Sprite();
            if (GameConfig.debug || Laya.Utils.getQueryString("debug") == "true")
                Laya.enableDebugPanel();
            if (GameConfig.physicsDebug && Laya["PhysicsDebugDraw"])
                Laya["PhysicsDebugDraw"].enable();
            if (GameConfig.stat)
                Laya.Stat.show();
            Laya.ResourceVersion.enable("version.json", Laya.Handler.create(this, this.onVersionLoaded), Laya.ResourceVersion.FILENAME_VERSION);
        }
        onVersionLoaded() {
            Laya.AtlasInfoManager.enable("fileconfig.json", Laya.Handler.create(this, this.onConfigLoaded));
        }
        onConfigLoaded() {
            GameConfig.startScene && Laya.Scene.open(GameConfig.startScene);
        }
    }
    new Main();

}());
